########################################################################
#
# Tagging cuts calibrated for Stripping13b Reco10, use default(2010data) cuts
#
# @author Marc Grabalosa
# @date 2011-01-24
########################################################################

from Gaudi.Configuration import *
from Configurables import BTagging, BTaggingTool, TaggerMuonTool, TaggerElectronTool, TaggerKaonSameTool, TaggerKaonOppositeTool, TaggerPionSameTool, TaggerVertexChargeTool, CombineTaggersProbability

tag = BTagging ('BTagging')
tag.addTool ( BTaggingTool )

tag.BTaggingTool.addTool ( CombineTaggersProbability )
tag.BTaggingTool.CombineTaggersProbability.ProbMin_OS  = 0.
tag.BTaggingTool.CombineTaggersProbability.P0_Cal_OS  = 0.392 # +/-0.0016
tag.BTaggingTool.CombineTaggersProbability.P1_Cal_OS  = 0.921 #+/-0.017
tag.BTaggingTool.CombineTaggersProbability.Eta_Cal_OS = 0.363
tag.BTaggingTool.CombineTaggersProbability.ProbMin  = 0.

tag.BTaggingTool.addTool ( TaggerMuonTool )
tag.BTaggingTool.TaggerMuonTool.Muon_Pt_cut      = 1200
tag.BTaggingTool.TaggerMuonTool.Muon_P_cut       = 0 
tag.BTaggingTool.TaggerMuonTool.Muon_lcs_cut     = 3.2
tag.BTaggingTool.TaggerMuonTool.Muon_IPs_cut     = 0.0
tag.BTaggingTool.TaggerMuonTool.Muon_IPssign_cut = -9999.0
tag.BTaggingTool.TaggerMuonTool.Muon_PIDm_cut    = 2.5
tag.BTaggingTool.TaggerMuonTool.Muon_ipPU_cut    = 3.0
tag.BTaggingTool.TaggerMuonTool.Muon_distPhi_cut = 0.005 
tag.BTaggingTool.TaggerMuonTool.Muon_cand        = 10.
tag.BTaggingTool.TaggerMuonTool.Muon_ProbMin     = 0.
tag.BTaggingTool.TaggerMuonTool.Muon_P0_Cal      = 0.
tag.BTaggingTool.TaggerMuonTool.Muon_P1_Cal      = 1.
tag.BTaggingTool.TaggerMuonTool.Muon_Eta_Cal     = 0.

tag.BTaggingTool.addTool ( TaggerElectronTool )
tag.BTaggingTool.TaggerElectronTool.Ele_Pt_cut    = 1000
tag.BTaggingTool.TaggerElectronTool.Ele_P_cut     = 0.0
tag.BTaggingTool.TaggerElectronTool.Ele_lcs_cut   = 3.85
tag.BTaggingTool.TaggerElectronTool.Ele_IPs_cut   = 1.
tag.BTaggingTool.TaggerElectronTool.Ele_ghost_cut = -999.
tag.BTaggingTool.TaggerElectronTool.Ele_VeloChargeMin = 0.0
tag.BTaggingTool.TaggerElectronTool.Ele_VeloChargeMax = 1.6
tag.BTaggingTool.TaggerElectronTool.Ele_EoverP        = 0.75
tag.BTaggingTool.TaggerElectronTool.Ele_PIDe_cut  = 4.0
tag.BTaggingTool.TaggerElectronTool.Ele_ipPU_cut  = 5.
tag.BTaggingTool.TaggerElectronTool.Ele_distPhi_cut  = 0.005
tag.BTaggingTool.TaggerElectronTool.Ele_ProbMin       = 0.
tag.BTaggingTool.TaggerElectronTool.Ele_P0_Cal        = 0.
tag.BTaggingTool.TaggerElectronTool.Ele_P1_Cal        = 1.
tag.BTaggingTool.TaggerElectronTool.Ele_Eta_Cal       = 0.

tag.BTaggingTool.addTool ( TaggerKaonOppositeTool )
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_Pt_cut   = 700
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_P_cut    = 5000
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_IPs_cut  = 4.3
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_IP_cut   = 1.45
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_lcs_cut  = 2.45
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDk     = 0.75
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDkp    = -3.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_ghost_cut= -999.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_ipPU_cut = 7.5
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_distPhi_cut = 0.005
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_ProbMin     = 0.54
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_P0_Cal      = 0.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_P1_Cal      = 1.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_Eta_Cal     = 0.

tag.BTaggingTool.addTool ( TaggerKaonSameTool )
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_Pt_cut  = 850
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_P_cut   = 5250
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_IP_cut  = 4.125
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_Phi_cut = 0.825
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_Eta_cut = 0.6
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_dQ_cut  = 1850.
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_lcs_cut    = 3.75
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_PIDk_cut  = 3.5
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_PIDkp_cut = -8.5
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_ipPU_cut   = 3.0
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_distPhi_cut   = 0.005
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_ProbMin     = 0.
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_P0_Cal      = 0.0
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_P1_Cal      = 1.0
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_Eta_Cal     = 0.0

tag.BTaggingTool.addTool ( TaggerPionSameTool )
tag.BTaggingTool.TaggerPionSameTool.PionSame_Pt_cut       = 600
tag.BTaggingTool.TaggerPionSameTool.PionSame_P_cut        = 4000
tag.BTaggingTool.TaggerPionSameTool.PionSame_IPs_cut      = 9.
tag.BTaggingTool.TaggerPionSameTool.PionSame_lcs_cut      = 5.0
tag.BTaggingTool.TaggerPionSameTool.PionSame_deta_max_cut = 0.35
tag.BTaggingTool.TaggerPionSameTool.PionSame_deta_min_cut = -0.5
tag.BTaggingTool.TaggerPionSameTool.PionSame_dphi_cut     = 0.75
tag.BTaggingTool.TaggerPionSameTool.PionSame_dR_cut       = 0.75
tag.BTaggingTool.TaggerPionSameTool.PionSame_dQ_cut       = 2500
tag.BTaggingTool.TaggerPionSameTool.PionSame_dQ_extra_cut = 1200
tag.BTaggingTool.TaggerPionSameTool.PionSame_ghost_cut    = -999.
tag.BTaggingTool.TaggerPionSameTool.PionSame_ipPU_cut     = 6.
tag.BTaggingTool.TaggerPionSameTool.PionSame_distPhi_cut  = 0.005
tag.BTaggingTool.TaggerPionSameTool.PionSame_PIDNoK_cut   = 4.3
tag.BTaggingTool.TaggerPionSameTool.PionSame_PIDNoP_cut   = 14.0
tag.BTaggingTool.TaggerPionSameTool.PionSame_ProbMin      = 0.56
#---- no cal
tag.BTaggingTool.TaggerPionSameTool.PionSame_P0_Cal       = 0.  
tag.BTaggingTool.TaggerPionSameTool.PionSame_P1_Cal       = 1.
tag.BTaggingTool.TaggerPionSameTool.PionSame_P2_Cal       = 0.
tag.BTaggingTool.TaggerPionSameTool.PionSame_Eta_Cal      = 0.

tag.BTaggingTool.addTool ( TaggerVertexChargeTool )
tag.BTaggingTool.SVertexOneSeedTool.MinSeedProbability    = 0.42
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_PowerK        = 0.55
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_MinimumVCharge= 0.2
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Ptsum         = 1.55
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Ptmean        = 0.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_IPSsum        = 0.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_DocaMaxsum    = 0.5
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Psum          = 8.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Msum          = 0.6
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Magsum        = 0.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Bdphidir      = 50.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_ProbMin       = 0.54
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_P0_Cal        = 0.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_P1_Cal        = 1.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Eta_Cal       = 0.
