#include "../src/configuration.h"
/******************************** ******************************** 
 Define here the list of input variables of the NNet
 NB the variables and the order should be the same as in TaggerXXXTool.cxx
****************************************************************/
#ifndef Variables_H 
#define Variables_H 1

#include <vector>
#include <string> 


class Variables {

std::vector<std::string> muonlist;
std::vector<std::string> elelist;
std::vector<std::string> kaonlist;
std::vector<std::string> pionSlist;
std::vector<std::string> vtxlist;
std::vector<std::string> kaonSlist;
std::vector<std::string> combNNlist;

public:
std::vector<std::string> init_Muon();
std::vector<std::string> init_Ele();
std::vector<std::string> init_Kaon();
std::vector<std::string> init_pionS();
std::vector<std::string> init_vtx();
std::vector<std::string> init_kaonS();
std::vector<std::string> init_combNN();
};

std::vector<std::string> Variables::init_Muon(){
muonlist.clear();
muonlist.push_back("mult");
muonlist.push_back("partP");
muonlist.push_back("partPt");
//muonlist.push_back("nnkrec"); // tolto
muonlist.push_back("ptB");
muonlist.push_back("IPs");
//muonlist.push_back("IPssign");
muonlist.push_back("partlcs");
//muonlist.push_back("PIDm"); // tolto
muonlist.push_back("PIDNNm");
// muonlist.push_back("PIDNNpi"); // tolto
muonlist.push_back("ghostProb");
muonlist.push_back("IPPU");
return (muonlist);
}
std::vector<std::string> Variables::init_Ele(){
elelist.clear();
elelist.push_back("mult");
elelist.push_back("partP");
elelist.push_back("partPt");
//elelist.push_back("nnkrec"); // tolto
elelist.push_back("ptB");
elelist.push_back("IPs");
//elelist.push_back("IPssign");
elelist.push_back("partlcs");
//elelist.push_back("PIDe"); // tolto
//elelist.push_back("PIDNNe"); // aggiunto
//elelist.push_back("PIDNNpi"); //tolto
//elelist.push_back("PIDNNp");
//elelist.push_back("PIDNNk"); // aggiunto
 elelist.push_back("eOverP"); // aggiunto
 //elelist.push_back("veloch"); // tolto
 elelist.push_back("ghostProb"); // aggiunto
elelist.push_back("IPPU");
return (elelist);
}

std::vector<std::string> Variables::init_Kaon(){
kaonlist.clear();
kaonlist.push_back("mult");
kaonlist.push_back("partP");
kaonlist.push_back("partPt");
kaonlist.push_back("nnkrec");
kaonlist.push_back("ptB");
kaonlist.push_back("IPs");
//kaonlist.push_back("IPssign");
kaonlist.push_back("partlcs");
//kaonlist.push_back("PIDk");
//kaonlist.push_back("PIDpk");
kaonlist.push_back("PIDNNk");
kaonlist.push_back("PIDNNpi");
kaonlist.push_back("PIDNNp");
kaonlist.push_back("ghostProb");
kaonlist.push_back("IPPU");
return (kaonlist);
}
std::vector<std::string> Variables::init_pionS(){
pionSlist.clear();
pionSlist.push_back("mult");
pionSlist.push_back("partP");
pionSlist.push_back("partPt");
pionSlist.push_back("nnkrec");
pionSlist.push_back("ptB");
pionSlist.push_back("nndeta");
pionSlist.push_back("nndphi");
pionSlist.push_back("nndq");
pionSlist.push_back("nndr");
return (pionSlist);
}

std::vector<std::string> Variables::init_vtx(){
vtxlist.clear();
vtxlist.push_back("mult");
vtxlist.push_back("nnkrec");
vtxlist.push_back("ptB");
vtxlist.push_back("vflag");
vtxlist.push_back("ptmean");
vtxlist.push_back("ipsmean");
vtxlist.push_back("vcharge");
vtxlist.push_back("svm");
vtxlist.push_back("svp");
vtxlist.push_back("BDphiDir");
vtxlist.push_back("svtau");
vtxlist.push_back("docamax");
return (vtxlist);
}
std::vector<std::string> Variables::init_kaonS(){
kaonSlist.clear();
kaonSlist.push_back("mult");
kaonSlist.push_back("partP");
kaonSlist.push_back("partPt");
kaonSlist.push_back("nnkrec");
kaonSlist.push_back("ptB");
kaonSlist.push_back("nndeta");
kaonSlist.push_back("nndphi");
kaonSlist.push_back("nndq");
kaonSlist.push_back("nndr");
return (kaonSlist);
}

std::vector<std::string> Variables::init_combNN(){
combNNlist.clear();
combNNlist.push_back("om_muon");
combNNlist.push_back("om_ele");
combNNlist.push_back("om_kaon");
combNNlist.push_back("om_vtx");
//combNNlist.push_back("mult");
//combNNlist.push_back("ptB");
//combNNlist.push_back("nnkrec");
//combNNlist.push_back("eta");

return (combNNlist);
}


#endif
