########################################################################
#
# Tagging cuts calibrated for Stripping13b Reco10, use default(2010data) cuts
#
# @author Marc Grabalosa
# @date 2011-01-24
########################################################################

from Gaudi.Configuration import *
from Configurables import BTagging, BTaggingTool, TaggerMuonTool, TaggerElectronTool, TaggerKaonSameTool, TaggerKaonOppositeTool, TaggerPionSameTool, TaggerVertexChargeTool, CombineTaggersProbability

tag = BTagging ('BTagging')
tag.addTool ( BTaggingTool )

tag.BTaggingTool.addTool ( CombineTaggersProbability )
tag.BTaggingTool.CombineTaggersProbability.ProbMin  = 0.
tag.BTaggingTool.CombineTaggersProbability.ProbMin_OS  = 0.5
tag.BTaggingTool.CombineTaggersProbability.P0_Cal_OS  = 0.3845
tag.BTaggingTool.CombineTaggersProbability.P1_Cal_OS  = 0.900
tag.BTaggingTool.CombineTaggersProbability.Eta_Cal_OS = 0.358
# 23 Jan // Tuning %3==1 CloneKO_rightSplit

tag.BTaggingTool.addTool ( TaggerMuonTool )
tag.BTaggingTool.TaggerMuonTool.Muon_Pt_cut      = 1100 # 1200
tag.BTaggingTool.TaggerMuonTool.Muon_P_cut       = 0 
tag.BTaggingTool.TaggerMuonTool.Muon_IPs_cut     = 0.
tag.BTaggingTool.TaggerMuonTool.Muon_lcs_cut     = 3   # default cut
tag.BTaggingTool.TaggerMuonTool.Muon_IPssign_cut = -9999.0
tag.BTaggingTool.TaggerMuonTool.Muon_PIDm_cut    = -100# -10.  # no cut
tag.BTaggingTool.TaggerMuonTool.Muon_ipPU_cut    = 3.   
tag.BTaggingTool.TaggerMuonTool.Muon_distPhi_cut = 0.005 
tag.BTaggingTool.TaggerMuonTool.Muon_cand        = 10.
tag.BTaggingTool.TaggerMuonTool.Muon_ProbMin     = 0. # 0.6
#
tag.BTaggingTool.TaggerMuonTool.Muon_ghostProb_cut = 0.4
#tag.BTaggingTool.TaggerMuonTool.Muon_ghostProbNN_cut  = 0.25
tag.BTaggingTool.TaggerMuonTool.Muon_PIDNNm_cut    = 0.4 #0.52
tag.BTaggingTool.TaggerMuonTool.Muon_PIDNNpi_cut   = 0.7
tag.BTaggingTool.TaggerMuonTool.Muon_PIDNNe_cut    = 0.8
tag.BTaggingTool.TaggerMuonTool.Muon_PIDNNk_cut    = 0.8
tag.BTaggingTool.TaggerMuonTool.Muon_PIDNNp_cut    = 0.8
#
tag.BTaggingTool.TaggerMuonTool.Muon_P0_Cal      = 0.3103
tag.BTaggingTool.TaggerMuonTool.Muon_P1_Cal      = 0.999
tag.BTaggingTool.TaggerMuonTool.Muon_Eta_Cal     = 0.3092


tag.BTaggingTool.addTool ( TaggerElectronTool )
tag.BTaggingTool.TaggerElectronTool.Ele_Pt_cut    =1100# 1000.#1100
tag.BTaggingTool.TaggerElectronTool.Ele_P_cut     = 0.0
tag.BTaggingTool.TaggerElectronTool.Ele_lcs_cut   = 3. # default cut
tag.BTaggingTool.TaggerElectronTool.Ele_IPs_cut   = 3.5# 3.#3.5
tag.BTaggingTool.TaggerElectronTool.Ele_IPssign_cut   =3.5#  3.#3.5
tag.BTaggingTool.TaggerElectronTool.Ele_ghost_cut = -999.
tag.BTaggingTool.TaggerElectronTool.Ele_VeloChargeMin = 0.0
tag.BTaggingTool.TaggerElectronTool.Ele_VeloChargeMax = 1.4
tag.BTaggingTool.TaggerElectronTool.Ele_EoverP        =0.85 #0.8#0.85
tag.BTaggingTool.TaggerElectronTool.Ele_EoverPmax     =2. #5.#2
tag.BTaggingTool.TaggerElectronTool.Ele_PIDe_cut  = -1.# -3.#-1.
tag.BTaggingTool.TaggerElectronTool.Ele_ipPU_cut  = 4.# 3.5# 4.
tag.BTaggingTool.TaggerElectronTool.Ele_distPhi_cut  = 0.005
#
tag.BTaggingTool.TaggerElectronTool.Ele_PIDNNk_cut        = 0.8# 1.#0.8
tag.BTaggingTool.TaggerElectronTool.Ele_PIDNNp_cut        = 0.8# 1.#0.8
tag.BTaggingTool.TaggerElectronTool.Ele_PIDNNpi_cut        = 0.8# 1.#0.8
tag.BTaggingTool.TaggerElectronTool.Ele_PIDNNe_cut        = 0.15
tag.BTaggingTool.TaggerElectronTool.Ele_PIDNNepi_cut        = -0.4
tag.BTaggingTool.TaggerElectronTool.Ele_ghostProb_cut        = 0.4# 0.45# 0.4
#
tag.BTaggingTool.TaggerElectronTool.Ele_ProbMin       = 0.
tag.BTaggingTool.TaggerElectronTool.Ele_P0_Cal        = 0.
tag.BTaggingTool.TaggerElectronTool.Ele_P1_Cal        = 1.
tag.BTaggingTool.TaggerElectronTool.Ele_Eta_Cal       = 0.

tag.BTaggingTool.addTool ( TaggerKaonOppositeTool )
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_Pt_cut   = 700# 750
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_P_cut    = 2000
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_lcs_cut  = 3
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_IPs_cut  = 4 
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_IP_cut   = 1.6# 1.7 
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDk     = -100#0.75
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDkp    = -300#-3.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_ghost_cut= -999.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_ipPU_cut =  6 
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_distPhi_cut = 0.005
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_ProbMin     = 0.
#
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDNNk_cut       = 0.35# 0.35
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDNNmu_cut      = 0.8
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDNNe_cut       = 0.8
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDNNpi_cut      = 0.8
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDNNp_cut       = 0.6
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDNNkp_cut      = 0.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_PIDNNkpi_cut     = -1
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_ghostProb_cut    = 0.35
#
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_P0_Cal      = 0.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_P1_Cal      = 1.
tag.BTaggingTool.TaggerKaonOppositeTool.Kaon_Eta_Cal     = 0.

tag.BTaggingTool.addTool ( TaggerKaonSameTool )
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_Pt_cut  = 850
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_P_cut   = 5250
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_IP_cut  = 4.125
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_Phi_cut = 0.825
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_Eta_cut = 0.6
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_dQ_cut  = 1850.
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_lcs_cut    = 3.75
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_PIDk_cut  = 3.5
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_PIDkp_cut = -8.5
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_ipPU_cut   = 3.0
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_distPhi_cut   = 0.005
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_ProbMin     = 0.
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_P0_Cal      = 0.
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_P1_Cal      = 1.
tag.BTaggingTool.TaggerKaonSameTool.KaonSame_Eta_Cal     = 0.

tag.BTaggingTool.addTool ( TaggerPionSameTool )
tag.BTaggingTool.TaggerPionSameTool.PionSame_Pt_cut       = 500 #600
tag.BTaggingTool.TaggerPionSameTool.PionSame_P_cut        = 4000 #4000
tag.BTaggingTool.TaggerPionSameTool.PionSame_IPs_cut      = 9.
tag.BTaggingTool.TaggerPionSameTool.PionSame_lcs_cut      = 5.0
tag.BTaggingTool.TaggerPionSameTool.PionSame_deta_max_cut = 0.4 #0.35
tag.BTaggingTool.TaggerPionSameTool.PionSame_deta_min_cut = -0.5
tag.BTaggingTool.TaggerPionSameTool.PionSame_dphi_cut     = 0.75 # 0.75
tag.BTaggingTool.TaggerPionSameTool.PionSame_dR_cut       = 0.75 #0.75
tag.BTaggingTool.TaggerPionSameTool.PionSame_dQ_cut       = 2500 # 2500
tag.BTaggingTool.TaggerPionSameTool.PionSame_dQ_extra_cut = 1000 #1200
tag.BTaggingTool.TaggerPionSameTool.PionSame_ghost_cut    = -999.
tag.BTaggingTool.TaggerPionSameTool.PionSame_ipPU_cut     = 4 #6.
tag.BTaggingTool.TaggerPionSameTool.PionSame_distPhi_cut  = 0.005
tag.BTaggingTool.TaggerPionSameTool.PionSame_PIDNoK_cut   = 100 #4.3
tag.BTaggingTool.TaggerPionSameTool.PionSame_PIDNoP_cut   = 300 #14.0
tag.BTaggingTool.TaggerPionSameTool.PionSame_ghostProb_cut = 0.35
tag.BTaggingTool.TaggerPionSameTool.PionSame_PIDNNpi_cut   = 0.3
tag.BTaggingTool.TaggerPionSameTool.PionSame_PIDNNk_cut    = 0.3
tag.BTaggingTool.TaggerPionSameTool.PionSame_PIDNNp_cut    = 0.34
tag.BTaggingTool.TaggerPionSameTool.PionSame_ProbMin      = 0.# 0.53 #0.57 # 0.56
tag.BTaggingTool.TaggerPionSameTool.PionSame_P0_Cal       = 0.
tag.BTaggingTool.TaggerPionSameTool.PionSame_P1_Cal       = 1.
tag.BTaggingTool.TaggerPionSameTool.PionSame_P2_Cal       = 0.
tag.BTaggingTool.TaggerPionSameTool.PionSame_Eta_Cal      = 0.


tag.BTaggingTool.addTool ( TaggerVertexChargeTool )
tag.BTaggingTool.SVertexOneSeedTool.MinSeedProbability    = 0.42
tag.BTaggingTool.SVertexOneSeedTool.MinSeedPtmin          = 0.1
tag.BTaggingTool.SVertexOneSeedTool.MinSeedIPSmin         = 2.5
tag.BTaggingTool.SVertexOneSeedTool.MinSeedDphimin        = 0.
tag.BTaggingTool.SVertexOneSeedTool.MinSeedDphimax        = 5
tag.BTaggingTool.SVertexOneSeedTool.ghostProb_cut   = 0.37#55

tag.BTaggingTool.TaggerVertexChargeTool.Vtx_PowerK        = 0.55
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_MinimumVCharge= 0.2
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Ptsum         = 2.2 #1.55
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Ptmean        = 0.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_IPSsum        = 10.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_DocaMaxsum    = 0.5
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Psum          = 8.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Msum          = 0.6
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Magsum        = 0.  # ??? 
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Bdphidir      = 50. #  ??? 
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_ProbMin       = 0.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_P0_Cal        = 0.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_P1_Cal        = 1.
tag.BTaggingTool.TaggerVertexChargeTool.Vtx_Eta_Cal       = 0.






