#ifndef ChooseBestTagger_H
#define ChooseBestTagger_H 1

#include <vector>
#include <cmath>
#include "Particle.h"
#include "FlavourTag.h"
#include "Tagger.h"


/** @class ChooseBestTagger
 *
 *  Tool to combine taggers probability treating them as independent
 *
 *  @author Marco Musy
 *  @date   2010-07-15
 */
class ChooseBestTagger {

 public:

  ChooseBestTagger( );
  ~ChooseBestTagger(){ delete theTag; } ///< Destructor

  FlavourTag* combineTaggers( Taggers& vtg , int signalType);

 
 private:
  double m_omegamaxbin, m_omegascale, m_ProbMin;
  double m_ProbMin_OS, m_P0_Cal_OS, m_P1_Cal_OS, m_Eta_Cal_OS;
  //  double m_ProbMin_OS, m_P0_Cal_OS, m_P1_Cal_OS, m_Eta_Cal_OS, m_P0_Cal_OS1, m_P1_Cal_OS1, m_Eta_Cal_OS1;
  FlavourTag* theTag;

};

#endif 
