#ifndef NNETTOOL_MLP_H 
#define NNETTOOL_MLP_H 1

#include "GenericTool.h"
#include <list>
#include "TString.h"
#include "TMVA/Reader.h"

/** @class NNetTool_MLP
 *
 *  Tool that calculates the mistag value for a tagger
 *
 *  @author Antonio Falabella
 *  @date   2012-11-30
 */
class NNetTool_MLP : public GenericTool {

public:
  /// Standard constructor
  NNetTool_MLP( );
  ~NNetTool_MLP( ){}; ///< Destructor
  
  double MLPmTMVA(std::list<std::pair<string,Float_t> >&);
  double MLPeTMVA(std::list<std::pair<string,Float_t> >&);
  double MLPkaonTMVA(std::list<std::pair<string,Float_t> >&);
  double MLPpionSTMVA(std::list<std::pair<string,Float_t> >& );
  double MLPvtxTMVA(std::list<std::pair<string,Float_t> >& );
  double MLPkaonSTMVA(std::list<std::pair<string,Float_t> >& );
  double MLPfragOppTMVA(std::list<std::pair<string,Float_t> >& );
  double MLPCombNNTMVA(std::list<std::pair<string,Float_t> >&);

private:

  double m_P0mu, m_P1mu, m_P2mu, m_P3mu;
  double m_P0e,  m_P1e,  m_P2e , m_P3e;
  double m_P0k,  m_P1k,  m_P2k,  m_P3k;
  double m_P0ks, m_P1ks, m_P2ks, m_P3ks;
  double m_P0ps, m_P1ps, m_P2ps, m_P3ps;
  double m_P0vtx,m_P1vtx,m_P2vtx,m_P3vtx;  
  double m_P0combNN,m_P1combNN,m_P2combNN,m_P3combNN;
  //  double m_Gt075, m_wSameSign2, m_wSameSignMoreThan2;
  //  double m_ProbMinVtx, m_MinimumVCharge;

};
#endif // NNETTOOL_MLP_H
