#include "configuration.h"
#include "SVertexOneSeedTool.h"

SVertexOneSeedTool::SVertexOneSeedTool() {

  //  declareProperty( "MinSeedProbability", m_maxprobf = 0.4 );
  declareProperty( "MinSeedProbability", m_maxprobf = 0.42 );
  declareProperty( "MinSeedPtmin", m_ptmin = 0.1 ); 
  declareProperty( "MinSeedIPSmin", m_ipsmin = 2.5 );
  declareProperty( "MinSeedDphimin", m_dphimin = 0. );
  declareProperty( "MinSeedDphimax", m_dphimax = 5. );
  declareProperty( "ghostProb_cut", m_ghostProb_vtx = 1.0);//0.37
  //declareProperty( "ghostProb_cut_avtx", m_ghostProb_avtx = 1.0);//0.37

  //declare histos:///////////////////
  hvprobf2 = new TH1F("hvprobf2","probf",        100, 0, 1.01);
  hvprobf0 = new TH1F("hvprobf0","probf",        100, 0, 1.01);
  hvChi0   = new TH1F("hvChi0","hvChi0", 100, 0, 15);
  hvChi2   = new TH1F("hvChi2","hvChi2", 100, 0, 15);
  hz0      = new TH1F("hz0","hz0", 50, 0, 10);
  hz2      = new TH1F("hz2","hz2", 50, 0, 10);
  hvpmin_2 = new TH1F("hvpmin_2","hvpmin_2", 100, 0, 2.5);
  hvpmin_0 = new TH1F("hvpmin_0","hvpmin_0", 100, 0, 2.5);
  hvipmin2 = new TH1F("hvipmin2","hvipmin2", 100, 0, 2);
  hvipmin0 = new TH1F("hvipmin0","hvipmin0", 100, 0, 2);
  hvipmax2 = new TH1F("hvipmax2","hvipmax2", 100, 0, 5);
  hvipmax0 = new TH1F("hvipmax0","hvipmax0", 100, 0, 5);
  hvipsmin2= new TH1F("hvipsmin2","hvipsmin2", 100, 0, 40);
  hvipsmin0= new TH1F("hvipsmin0","hvipsmin0", 100, 0, 40);
  hvdphi2  = new TH1F("hvdphi2","hvdphi2", 100, 0, 3);
  hvdphi0  = new TH1F("hvdphi0","hvdphi0", 100, 0, 3);
  hvmass2  = new TH1F("hvmass2","hvmass2", 100, 0, 3);
  hvmass0  = new TH1F("hvmass0","hvmass0", 100, 0, 3);
  hvreson2 = new TH1F("hvreson2","hvreson2", 100, 0, 3);
  hvreson0 = new TH1F("hvreson0","hvreson0", 100, 0, 3);
  hvsvpointtheta2 = new TH1F("hvsvpointtheta2","SVpointTheta", 65, 0, 0.5);
  hvsvpointtheta0 = new TH1F("hvsvpointtheta0","SVpointTheta", 65, 0, 0.5);
  hvmaxprobf2 = new TH1F("hvmaxprobf2","maxprobf", 100, 0, 1.01);
  hvmaxprobf0 = new TH1F("hvmaxprobf0","maxprobf", 100, 0, 1.01);

  hr_seed_ipsmin = new TH1F("hr_seed_ipsmin","ipsmin right tags", 80, 0, 30);
  hw_seed_ipsmin = new TH1F("hw_seed_ipsmin","ipsmin wrong tags", 80, 0, 30);
  hr_seed_ipmax = new TH1F("hr_seed_ipmax","ipmax right tags", 60, 0, 6);
  hw_seed_ipmax = new TH1F("hw_seed_ipmax","ipmax wrong tags", 60, 0, 6);
  hr_seed_ptmin = new TH1F("hr_seed_ptmin","ptmin right tags", 60, 0, 5);
  hw_seed_ptmin = new TH1F("hw_seed_ptmin","ptmin wrong tags", 60, 0, 5);
  hr_seed_chi2 = new TH1F("hr_seed_chi2","chi2 right tags", 50, 0, 13);
  hw_seed_chi2 = new TH1F("hw_seed_chi2","chi2 wrong tags", 50, 0, 13);
  hr_seed_dphi = new TH1F("hr_seed_dphi","dphi right tags", 50, 0, 3.2);
  hw_seed_dphi = new TH1F("hw_seed_dphi","dphi wrong tags", 50, 0, 3.2);
  hr_seed_rdist = new TH1F("hr_seed_rdist","rdist right tags", 50, 0, 10);
  hw_seed_rdist = new TH1F("hw_seed_rdist","rdist wrong tags", 50, 0, 10);
  hr_seed_probf = new TH1F("hr_seed_probf","probf right tags", 50, 0, 1);
  hw_seed_probf = new TH1F("hw_seed_probf","probf wrong tags", 50, 0, 1);
  hr_seed_svpointtheta = new TH1F("hr_seed_svpointtheta","svpointtheta right tags", 50, 0, 0.4);
  hw_seed_svpointtheta = new TH1F("hw_seed_svpointtheta","svpointtheta wrong tags", 50, 0, 0.4);

  htr_pt1 = new TH1F("htr_pt1","htr_pt1", 50, 0, 8);
  htr_pt0 = new TH1F("htr_pt0","htr_pt0", 50, 0, 8);
  htr_ip1 = new TH1F("htr_ip1","htr_ip1", 50, 0, 3);
  htr_ip0 = new TH1F("htr_ip0","htr_ip0", 50, 0, 3);
  htr_ips1 = new TH1F("htr_ips1","htr_ips1", 50, 0, 20);
  htr_ips0 = new TH1F("htr_ips0","htr_ips0", 50, 0, 20);
  htr_ipsv1 = new TH1F("htr_ipsv1","htr_ipsv1", 50, 0, 2.7);
  htr_ipsv0 = new TH1F("htr_ipsv0","htr_ipsv0", 50, 0, 2.7);
  htr_doca1 = new TH1F("htr_doca1","htr_doca1", 50, 0, 0.5);
  htr_doca0 = new TH1F("htr_doca0","htr_doca0", 50, 0, 0.5);
  htr_lcs1 = new TH1F("htr_lcs1","htr_lcs1", 50, 0, 5);
  htr_lcs0 = new TH1F("htr_lcs0","htr_lcs0", 50, 0, 5);

}

//////////////////////////////////////////////////////////
Vertices SVertexOneSeedTool::buildVertex(Particles& vtags, 
                                         Event* event) {
  Vertices vtxvect; 

  if( ! event->hasSecondaryVertexSeed() ) return vtxvect;

  //loop to find seed -----------------------------------
  // this has been done already in DaVinci...
  // just use 2-track seed formed there:

  Vertex* Vfit = event->getSeeds().at(0);

  Particles pp = Vfit->outgoingParticles();
  Particle* p1 = pp.at(0); 
  Particle* p2 = pp.at(1);

  debug()<<"SVertexOneSeedTool outgoingParticles "<<pp.size()<<endl;

  //evaluate likelihood
  double seedchi2 = Vfit->chi2PerDoF();
  double prob_chi2 = pol(seedchi2, 0.632154, -0.0421607, 0.00181837);

  double ptmin = std::min(p1->pt(), p2->pt()) /GeV;
  double prob_ptmin = 0;
  if (ptmin < m_ptmin) return vtxvect; //////////// CUT
  if (ptmin<1) prob_ptmin = pol(ptmin, 0.0144075, 1.28718, -0.477544);
  else prob_ptmin = pol(ptmin, 0.536686, 0.382045, -0.0945185);

  //  if( std::max((p1)->pt(), (p2)->pt()) /GeV < 0.3 ) return vtxvect;  //cut  ---- non c'era !!! 

  
  double ipmax = std::max(p1->IP(), p2->IP());
  double prob_ipmax = 0;
  if (ipmax<0.4) prob_ipmax = pol(ipmax, 0.490689, 1.21535, -1.87733);
  else prob_ipmax = pol(ipmax, 0.790337, -0.229543, 0.00438416);
  
  double ipsmin     = std::min(p1->IPs(), p2->IPs());
  if (ipsmin < m_ipsmin) return vtxvect; //////////// CUT
  double prob_ipsmin = 0;
  if (ipsmin<6) prob_ipsmin = pol(ipsmin, -0.442382, 0.326852, -0.0258772);
  else prob_ipsmin = pol(ipsmin, 0.540565, 0.0130981, -0.000204322);
  
  double dphi= fabs(p1->Phi()-p2->Phi()); 
  if(dphi>PI) dphi= 2.*PI-dphi;
  if(dphi < m_dphimin) return vtxvect; //////////// CUT
  if(dphi > m_dphimax) { 
    cout<<" Attention!!! This cut is not implemented in FT!!!"<<m_dphimax<<endl;
    return vtxvect; //////////// CUT
  }

  double prob_deltaphi = pol(dphi, 0.611887, 0.0165528, -0.0398336);
  
  double prob_rdist;
  TVector3 SVpoint = Vfit->position();
  double rdist = sqrt( SVpoint.x()*SVpoint.x()
		       +SVpoint.y()*SVpoint.y()
		       +SVpoint.z()*SVpoint.z()*.074*.074 );
  prob_rdist = pol(rdist, 0.673403, -0.0743514, 0.00646535);

  double pointtheta = SVpoint.Theta();
  double prob_pointtheta = 0;
  if (pointtheta <0.05) prob_pointtheta = pol(pointtheta, 0.466409, 7.29019, -94.1293);
  else prob_pointtheta = pol(pointtheta, 0.555528, 0.98924, -5.43018);
  
  debug()<<prob_chi2<< " "<<  prob_ptmin<<  " "<<    prob_ipmax<< " "
         << prob_ipsmin<<  " "<< prob_deltaphi<<  " "<< prob_rdist<< " "<<prob_pointtheta<<endmsg;

  double probf = combine(prob_chi2,   prob_ptmin,    prob_ipmax,
                         prob_ipsmin, prob_deltaphi, prob_rdist, prob_pointtheta);


  // some cuts
  if(SVpoint.Theta()>.350 || SVpoint.Theta()<.010) {
    std::cout<<" SVproint Theta cut "<<SVpoint.Theta()<<std::endl;    
    return vtxvect; // 'acceptance' cut (already in BTaggingAnalysis)
  }
  /*
// This is WRONG!!! 
  double smass= (p1->momentum()+p2->momentum()).M();
  if(msgLevel(MSG::VERBOSE)) verbose()<<"smass"<<smass<<endreq;
  if(smass<0.2) return vtxvect; // mass cut
  if(smass>0.490 && smass<0.505 && p1->charge()*p2->charge()<0) {
    std::cout<<" Ks con MASSA giusta ! "<<smass<<" "<<p1->momentum().M()<<" "<<p2->momentum().M()<<std::endl;
    return vtxvect; // Kshort cut
  }
  */

  
  Double_t pi_mass = 0.139570;
  TLorentzVector p_1 = p1->momentum();
  TLorentzVector p_2 = p2->momentum();

  double mass;
  if((p_1+p_2).M()/GeV<0.2 ) {
    std::cout<<" massa forzata <0.2 "<<(p_1+p_2).M()/GeV<< std::endl;
    return vtxvect;
  }
  if(abs(p1->ID()) == 211 || abs(p2->ID()) == 211) {    
    p_1.SetE(sqrt(pow(p_1.P(),2)+pow(pi_mass,2)));
    p_2.SetE(sqrt(pow(p_2.P(),2)+pow(pi_mass,2)));

    mass = (p_1+p_2).M()/GeV; //
    if( mass<0.2 ) {
      std::cout<<" massa forzata <0.2 "<< mass<< std::endl;
      return vtxvect;
    }
    
    if( mass > 0.490 && mass < 0.505  && p1->charge()*p2->charge()<0) {
      verbose() << "This is a Ks candidate! skip."<<endreq;
      // std::cout<<" Ks con MASSA FORZATA ! "<<mass<<" "<<p1->momentum().M()<<" "<<p2->momentum().M()<<std::endl;
      return vtxvect;
    } 
  }


  double smass=mass;
  /*  
  Double_t K_mass = 0.493677;

  p_1.SetE(sqrt(p_1.P()*p_1.P()+K_mass*K_mass));
  p_2.SetE(sqrt(p_2.P()*p_2.P()+K_mass*K_mass));
  
  mass = (p_1+p_2).M()/GeV; //
  if( mass<0.2 ) std::cout<<" massa forzata K <0.2 "<< mass<< std::endl;
  if( fabs(mass-1.019455)< 0.010 && p1->charge()*p2->charge()<0 && 
      (abs(p1->momentum().M()-K_mass)<0.01 ||abs(p2->momentum().M()-K_mass)<0.01 )) {
    verbose() << "This is a phi candidate! skip."<<endreq;
    std::cout<<" phi con MASSA FORZATA KAONE ! "<<mass<<" "<<p1->momentum().M()<<" "<<p2->momentum().M()<<std::endl;
    //return vtxvect;
  }
  */

#ifdef NEWCUTS
  if(p1->ghostProbability()>m_ghostProb_vtx || p2->ghostProbability()>m_ghostProb_vtx) return vtxvect;
#endif

  //plots
  bool twofromB = (p1->fromB()==1) && (p2->fromB()==1);
  if(twofromB) { // MC
    hvprobf2->Fill(probf,event->N_sig_sw()); 
    hvsvpointtheta2->Fill(SVpoint.Theta(),event->N_sig_sw());
    if ( p1->charge()*p2->charge()<0 ) hvreson2->Fill(smass,event->N_sig_sw()); else hvreson0->Fill(smass,event->N_sig_sw());
    hz2->Fill(rdist,event->N_sig_sw()); 
    hvChi2->Fill(Vfit->chi2PerDoF(),event->N_sig_sw());
    hvpmin_2->Fill(std::min(p1->pt(), p2->pt()) /GeV,event->N_sig_sw());
    hvipmax2->Fill(std::max(p1->IP(), p2->IP()),event->N_sig_sw());
    hvipsmin2->Fill(ipsmin,event->N_sig_sw());
    hvdphi2->Fill(dphi,event->N_sig_sw());
    hvmass2->Fill(smass,event->N_sig_sw());
  }
  else {
    hvprobf0->Fill(probf,event->N_sig_sw());
    hvsvpointtheta0->Fill(SVpoint.Theta(),event->N_sig_sw());
    hvreson0->Fill(smass,event->N_sig_sw());
    hz0->Fill(rdist,event->N_sig_sw());
    hvChi0->Fill(Vfit->chi2PerDoF(),event->N_sig_sw());
    hvpmin_0->Fill(std::min(p1->pt(), p2->pt()) /GeV,event->N_sig_sw());
    hvipmax0->Fill(std::max(p1->IP(), p2->IP()),event->N_sig_sw());
    hvipsmin0->Fill(ipsmin,event->N_sig_sw());
    hvdphi0->Fill(dphi,event->N_sig_sw());
    hvmass0->Fill(smass,event->N_sig_sw());
  }

  //cut likelihood
  if( probf < m_maxprobf ) return vtxvect; // likelihood cut
  if(twofromB) hvmaxprobf2->Fill(probf,event->N_sig_sw()); else hvmaxprobf0->Fill(probf,event->N_sig_sw());  

  //save likelihood  
  Vfit->setLikelihood(probf);
  debug()<<"maxprobf="<<probf<<endreq;

  //add iteratively other tracks to the seed ----------------------
  Particles::iterator jpp;
  for ( jpp = vtags.begin(); jpp != vtags.end(); jpp++ ) {
    if( (*jpp)->pt() == p1->pt() ) continue;
    if( (*jpp)->pt() == p2->pt() ) continue;
#ifdef NEWCUTS
    if( (*jpp)->ghostProbability()> m_ghostProb_vtx) continue;
#endif
    double ip=(*jpp)->IP(), ipe=(*jpp)->IPerr();
    double ipSV=(*jpp)->IPSV();
    if((*jpp)->cloneDist()!=-1) continue;
    if((*jpp)->LCS()>=3) continue;
    //if((*jpp)->LCS()>=5) continue;
    if( ipe==0 ) continue;
    if( ip/ipe < 3.5 ) continue; //cut
    //if( ip/ipe < 1.5 ) continue; //cut
    if( ip < 0.1 ) continue;     //cut
    //if( ip < 0.05 ) continue;     //cut
    if( ipSV > 0.9 ) continue;//cut (0.7)
    //    if( ipSV > 1.2 ) continue;//cut (0.7)
    if((*jpp)->DOCA() > 0.2 ) continue;//cut
    //if((*jpp)->DOCA() > 2.2 ) continue;//cut

    //fill histo for added tracks
    if ((*jpp)->fromB()==1) htr_pt1->Fill((*jpp)->pt(),event->N_sig_sw());     else htr_pt0->Fill((*jpp)->pt(),event->N_sig_sw());
    if ((*jpp)->fromB()==1) htr_ip1->Fill(ip,event->N_sig_sw());               else htr_ip0->Fill(ip,event->N_sig_sw());
    if ((*jpp)->fromB()==1) htr_ips1->Fill(ip/ipe,event->N_sig_sw());          else htr_ips0->Fill(ip/ipe,event->N_sig_sw());
    if ((*jpp)->fromB()==1) htr_ipsv1->Fill(ipSV,event->N_sig_sw());           else htr_ipsv0->Fill(ipSV,event->N_sig_sw());
    if ((*jpp)->fromB()==1) htr_doca1->Fill((*jpp)->DOCA(),event->N_sig_sw()); else htr_doca0->Fill((*jpp)->DOCA(),event->N_sig_sw());
    if ((*jpp)->fromB()==1) htr_lcs1->Fill((*jpp)->LCS(),event->N_sig_sw());   else htr_lcs0->Fill((*jpp)->LCS(),event->N_sig_sw());

    Vfit->addToOutgoingParticles(*jpp);
    pp.push_back(*jpp); //add track to seed to compute vch
    debug() << " added to SV === pt=" << (*jpp)->pt() <<endreq;
  }

  //save vtx type and vtx into event  
  Vfit->setType(Vertex::Secondary);
  vtxvect.push_back(Vfit);
  event->setSecondaryVertices(vtxvect);

  //for plots -> Compute vtxCh
  Particles::iterator tip;
  double vch=0, norm=0;
  for(tip=pp.begin(); tip!=pp.end(); tip++) {
    double a = pow((*tip)->pt()/GeV, 0.4);
    vch += (*tip)->charge() * a;
    norm+= a;
  }
  if(norm) vch /= norm;
  if(event->TrueTag()==-vch){
    hr_seed_ipsmin-> Fill(ipsmin,event->N_sig_sw());
    hr_seed_ipmax -> Fill(std::max(p1->IP(), p2->IP()),event->N_sig_sw());
    hr_seed_ptmin -> Fill(std::min(p1->pt(), p2->pt()),event->N_sig_sw());
    hr_seed_chi2  -> Fill(seedchi2,event->N_sig_sw());
    hr_seed_dphi  -> Fill(dphi,event->N_sig_sw());
    hr_seed_rdist -> Fill(rdist,event->N_sig_sw());
    hr_seed_probf -> Fill(probf,event->N_sig_sw());
    hr_seed_svpointtheta -> Fill(pointtheta,event->N_sig_sw());
  }
  if(event->TrueTag()==vch){
    hw_seed_ipsmin-> Fill(ipsmin,event->N_sig_sw());
    hw_seed_ipmax -> Fill(std::max(p1->IP(), p2->IP()),event->N_sig_sw());
    hw_seed_ptmin -> Fill(std::min(p1->pt(), p2->pt()),event->N_sig_sw());
    hw_seed_chi2  -> Fill(seedchi2,event->N_sig_sw());
    hw_seed_dphi  -> Fill(dphi,event->N_sig_sw());
    hw_seed_rdist -> Fill(rdist,event->N_sig_sw());
    hw_seed_probf -> Fill(probf,event->N_sig_sw());
    hw_seed_svpointtheta -> Fill(pointtheta,event->N_sig_sw());
  }
  
  return vtxvect;
  }
  
  
  //////////////////////////////////////////////////////////////////
double SVertexOneSeedTool::combine(double p1, double p2, double p3,
                                   double p4, double p5, double p6, double p7){
  double probs = p1*p2*p3*p4*p5*p6*p7;
  double probb = (1-p1)*(1-p2)*(1-p3)*(1-p4)*(1-p5)*(1-p6)*(1-p7);
  double probf = probs / ( probs + probb );
  if(probf>1) probf=1;
  return probf;
}

