#include "TaggerDZeroTool.h"

/// WARNING: CHEATING for study purposes //
//author: Marc Grabalosa

TaggerDZeroTool::TaggerDZeroTool() {

  NNetTool_MLP nnet;
  tDZ = new Tagger();

  hD_doca_r = new TH1F("hD_doca_r",   "hD_doca_r",   10, 0, 10);
  hD_doca_w = new TH1F("hD_doca_w",   "hD_doca_w",   100, 0, .5);
  hD_ipSV_r = new TH1F("hD_ipSV_r",   "hD_ipSV_r",   100, 0, 2);
  hD_ipSV_w = new TH1F("hD_ipSV_w",   "hD_ipSV_w",   100, 0, 2);
  hD_IPs_r  = new TH1F("hD_IPs_r",    "hD_IPs_r",    100, 0, 20);
  hD_IPs_w  = new TH1F("hD_IPs_w",    "hD_IPs_w",    100, 0, 20);
  hD_pt_r   = new TH1F("hD_pt_r",     "hD_pt_r",     100, 0, 7);
  hD_pt_w   = new TH1F("hD_pt_w",     "hD_pt_w",     100, 0, 7);
  hD_mass   = new TH1F("hD_mass",     "hD_mass",     100, 0.5, 2.5);
  hD_mass_r = new TH1F("hD_mass_r",   "hD_mass_r",   100, .5, 2.5);
}

///////////////////////////////////////////////////
Tagger* TaggerDZeroTool::tag(Event& event) {

  tDZ->reset();

  return tDZ;

  if(msgLevel(MSG::VERBOSE)) verbose()<<"--DZeroTool Tagger--"<<endreq;

  Particles parts = event.particles();
  Particles::iterator i, j;
  Particles Pfit; Pfit.clear();

  //--- Inclusive Secondary Vertex ---
  //look for a secondary Vtx due to opposite B
  //use DaVinci processed information
  int npsv=0;
  int nD=0;
  for (i=parts.begin(); i!=parts.end(); ++i) {
    if(!(*i)->ComesFromSVtx()) continue;
    npsv++;
    Pfit.push_back(*i);
    if( (*i)->type()== Particle::Long ) {
      //      if(abs((*i)->motherID())==421 ){
      if((*i)->fromB()){
	nD++;
	bool iisK = checkPIDhypo(Particle::kaon_opposite, *i);
	bool iisP = checkPIDhypo(Particle::pion, *i);
	if( iisK || iisP ) {
	  //	  if((*i)->fromB()) {
	  if(abs((*i)->motherID())==421 ){
	    hD_doca_r->Fill((*i)->docaSV());
	    hD_ipSV_r->Fill((*i)->IPSV());
	    hD_IPs_r->Fill((*i)->IPs());
	    hD_pt_r->Fill((*i)->pt());
	  } else {
	    hD_doca_w->Fill((*i)->docaSV());
	    hD_ipSV_w->Fill((*i)->IPSV());
	    hD_IPs_w->Fill((*i)->IPs());
	    hD_pt_w->Fill((*i)->pt());
	  }
	}
      }//mother ID421 (K)
    }
  }
  //if (npsv) cout<<"npart sv: "<<npsv<<", nD: "<<nD<<endl;
  if(nD!=2)  return tDZ;

  //if Vertex does not contain any daughters, exit
  if(Pfit.empty()) return tDZ;
  //cout<<"--- SVTOOL buildVertex returns vertex"
  //      <<" with "<<Pfit.size()<<"tracks"<<endreq;
  
  int DZ = 0;
  //calculate 
  for(i=Pfit.begin(); i!=Pfit.end(); i++) { 
    if( (*i)->type()!= Particle::Long ) continue;
    // if((*i)->IPs()<2) continue;
    // if((*i)->pt()<.3) continue;
    bool iisK = checkPIDhypo(Particle::kaon_opposite, *i);
    bool iisP = checkPIDhypo(Particle::pion, *i);

    if(!iisK && !iisP) continue;

    //cout<<"Pi or Kaon"<<endl;

    for(j=i+1; j!=Pfit.end(); j++) { 
      if( (*j)->type()!= Particle::Long ) continue;
      if( (*i)->charge() * (*j)->charge() >0 ) continue; 
      bool jisK = checkPIDhypo(Particle::kaon_opposite, *j);
      bool jisP = checkPIDhypo(Particle::pion, *j);
      //cout<<"cut1"<<endl;
      if( !(jisK && iisP || iisK && jisP) ) continue;
      // if((*j)->IPs()<2) continue;
      // if((*j)->pt()<.3) continue;
      //cout<<"cut2"<<endl;
      TLorentzVector sum = (*i)->momentum() +(*j)->momentum(); 
      //1864.83
      hD_mass->Fill(sum.M());
      if(abs((*i)->motherID())==421 && abs((*j)->motherID())==421) hD_mass_r->Fill(sum.M());
      //cout<<"mass: "<<sum.M()<<endl;
      if (sum.M()<1464.83/1000) continue;
      if (sum.M()>2264.83/1000) continue;
      //cout<<"cut3"<<endl;

      if ( iisK ) DZ = (*i)->charge()>0 ? -1 : 1 ;
      if ( jisK ) DZ = (*j)->charge()>0 ? -1 : 1 ;
    }

  }

  tDZ->setDecision( DZ );
  // tDZ->setRawNNetOutput( 0 );
  tDZ->setOmega( 0.5 );
  // tDZ->setType( Tagger::VtxCharge ); 
  // for(ip=Pfit.begin(); ip!=Pfit.end(); ip++) {
  //   tDZ->addToTaggerParts(*ip);
  // }
  
  return tDZ;
}
