#ifndef TaggerVertexChargeTool_H
#define TaggerVertexChargeTool_H 1

#include <iostream>
#include <iomanip>
#include <sstream>
#include <ostream>
#include <string>
#include <vector>
#include <list>
#include <TLorentzVector.h>
#include "Tagger.h"
#include "Event.h"
#include "GenericTool.h"
#include "SVertexOneSeedTool.h"
#include "NNetTool_MLP.h"

#include "TH1F.h"
#include "TH2F.h"

using namespace std;

/** @class TaggerVertexChargeTool
 *
 *  Tagger Tool for the Vertex Charge
 *
 *  @author Marco Musy
 *  @date   2010-07-15
 */

class TaggerVertexChargeTool  : public GenericTool {

 public:

  TaggerVertexChargeTool( );
  ~TaggerVertexChargeTool( ){ delete m_svtool; delete tVch; } ///< Destructor

  Tagger* tag(Event& );

 private:

  double m_P0 , m_P1, m_AverageOmega, m_Gt075 ,  m_wSameSign2,  m_wSameSignMoreThan2; //obsolete
  double m_PowerK, m_MinimumVCharge, m_ProbMin_vtx;
  double m_Ptsum_vtx, m_Ptmean_vtx, m_IPSsum_vtx, m_DocaMaxsum_vtx, m_Psum_vtx, m_Msum_vtx, m_Magsum_vtx, m_Bdphidir_vtx;
  double m_P0_Cal_vtx ;
  double m_P1_Cal_vtx ;
  double m_Eta_Cal_vtx ;

  TString m_CombinationTechnique, m_SecondaryVertexToolName;

  bool  m_UseObsoleteSV;

  SVertexOneSeedTool* m_svtool;
  NNetTool_MLP nnet;
  Tagger* tVch;

  TH1F *hr_vtx_vmaxprobf, *hw_vtx_vmaxprobf;
  TH1F *hr_vtx_vptmean, *hw_vtx_vptmean;
  TH1F *hr_vtx_vipsmean, *hw_vtx_vipsmean;
  TH1F *hr_vtx_vdocamax, *hw_vtx_vdocamax;
  TH1F *hr_vtx_vdphidir, *hw_vtx_vdphidir;
  TH1F *hr_vtx_vptsum, *hw_vtx_vptsum;
  TH1F *hr_vtx_vsvp, *hw_vtx_vsvp;
  TH1F *hr_vtx_vsvpt, *hw_vtx_vsvpt;
  TH1F *hr_vtx_vsvm, *hw_vtx_vsvm;
  TH1F *hr_vtx_vsvtheta, *hw_vtx_vsvtheta;
  TH1F *hr_vtx_vsvphi, *hw_vtx_vsvphi;
  TH1F *hr_vtx_vsvdeltar, *hw_vtx_vsvdeltar;
  TH1F *hr_vtx_vsvmag, *hw_vtx_vsvmag;

  TH1F *hr_tr_pt, *hw_tr_pt;
  TH1F *hr_tr_ip, *hw_tr_ip;
  TH1F *hr_tr_ips, *hw_tr_ips;
  TH1F *hr_tr_ipsv, *hw_tr_ipsv;
  TH1F *hr_tr_lcs, *hw_tr_lcs;
  TH1F *hr_tr_docamax, *hw_tr_docamax;
  TH2F *hcut_corr_vtx[11][11];

};
#endif 
