// Class: Read_kaonMLPBNN
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : MLP::_kaonMLPBNN
TMVA Release   : 4.1.0         [262400]
ROOT Release   : 5.29/01       [335105]
Creator        : vecchi
Date           : Wed May 22 15:24:18 2013
Host           : Linux lhcbwn1.fe.infn.it 2.6.18-238.5.1.el5 #1 SMP Tue Mar 1 18:58:43 EST 2011 x86_64 x86_64 x86_64 GNU/Linux
Dir            : /home/vecchi/NEWFTC_optcal_2012_sWeights/root_TMVA_forMoriond2013_XML_newPIDNN
Training events: 58579
Analysis type  : [Classification]


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
NCycles: "180" [Number of training cycles]
HiddenLayers: "N+5" [Specification of hidden layer architecture]
NeuronType: "tanh" [Neuron activation function type]
EstimatorType: "CE" [MSE (Mean Square Estimator) for Gaussian Likelihood or CE(Cross-Entropy) for Bernoulli Likelihood]
V: "False" [Verbose output (short form of "VerbosityLevel" below - overrides the latter one)]
VarTransform: "D,N" [List of variable transformations performed before training, e.g., "D_Background,P_Signal,G,N_AllClasses" for: "Decorrelation, PCA-transformation, Gaussianisation, Normalisation, each for the given class of events ('AllClasses' denotes all events of all classes, if no class indication is given, 'All' is assumed)"]
H: "True" [Print method-specific help message]
TrainingMethod: "BFGS" [Train with Back-Propagation (BP), BFGS Algorithm (BFGS), or Genetic Algorithm (GA - slower and worse)]
TestRate: "5" [Test for overtraining performed at each #th epochs]
UseRegulator: "True" [Use regulator to avoid over-training]
# Default:
RandomSeed: "1" [Random seed for initial synapse weights (0 means unique seed for each run; default value '1')]
NeuronInputType: "sum" [Neuron input function type]
VerbosityLevel: "Default" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs (signal and background)]
IgnoreNegWeightsInTraining: "False" [Events with negative weights are ignored in the training (but are included for testing and performance evaluation)]
LearningRate: "2.000000e-02" [ANN learning rate parameter]
DecayRate: "1.000000e-02" [Decay rate for learning parameter]
EpochMonitoring: "False" [Provide epoch-wise monitoring plots according to TestRate (caution: causes big ROOT output file!)]
Sampling: "1.000000e+00" [Only 'Sampling' (randomly selected) events are trained each epoch]
SamplingEpoch: "1.000000e+00" [Sampling is used for the first 'SamplingEpoch' epochs, afterwards, all events are taken for training]
SamplingImportance: "1.000000e+00" [ The sampling weights of events in epochs which successful (worse estimator than before) are multiplied with SamplingImportance, else they are divided.]
SamplingTraining: "True" [The training sample is sampled]
SamplingTesting: "False" [The testing sample is sampled]
ResetStep: "50" [How often BFGS should reset history]
Tau: "3.000000e+00" [LineSearch "size step"]
BPMode: "sequential" [Back-propagation learning mode: sequential or batch]
BatchSize: "-1" [Batch size: number of events/batch, only set if in Batch Mode, -1 for BatchSize=number_of_events]
ConvergenceImprove: "1.000000e-30" [Minimum improvement which counts as improvement (<0 means automatic convergence check is turned off)]
ConvergenceTests: "-1" [Number of steps (without improvement) required for convergence (<0 means automatic convergence check is turned off)]
UpdateLimit: "10000" [Maximum times of regulator update]
CalculateErrors: "False" [Calculates inverse Hessian matrix at the end of the training to be able to calculate the uncertainties of an MVA value]
WeightRange: "1.000000e+00" [Take the events for the estimator calculations from small deviations from the desired value to large deviations only over the weight range]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 12
mult                          mult                          mult                          mult                          I                                 'F'    [1,130]
partP                         partP                         partP                         partP                         F                                 'F'    [0.971759498119,5.29803800583]
partPt                        partPt                        partPt                        partPt                        F                                 'F'    [-0.356578052044,2.3005900383]
nnkrec                        nnkrec                        nnkrec                        nnkrec                        I                                 'F'    [1,8]
ptB                           ptB                           ptB                           ptB                           F                                 'F'    [-4.26340532303,3.9813709259]
IPs                           IPs                           IPs                           IPs                           F                                 'F'    [1.38630819321,4.97467803955]
partlcs                       partlcs                       partlcs                       partlcs                       F                                 'F'    [-1.99878895283,1.09745883942]
PIDNNk                        PIDNNk                        PIDNNk                        PIDNNk                        F                                 'F'    [0.25003066659,0.999072551727]
PIDNNpi                       PIDNNpi                       PIDNNpi                       PIDNNpi                       F                                 'F'    [1.12712414193e-05,0.799927890301]
PIDNNp                        PIDNNp                        PIDNNp                        PIDNNp                        F                                 'F'    [1.07484980916e-08,0.748721539974]
ghostProb                     ghostProb                     ghostProb                     ghostProb                     F                                 'F'    [-100,-1.05095720291]
IPPU                          IPPU                          IPPU                          IPPU                          F                                 'F'    [1.79177522659,9.21034049988]
NSpec 0


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() : fStatusIsClean( true ) {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;

   // returns classifier status
   bool IsStatusClean() const { return fStatusIsClean; }

 protected:

   bool fStatusIsClean;
};

#endif

class Read_kaonMLPBNN : public IClassifierReader {

 public:

   // constructor
   Read_kaonMLPBNN( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "Read_kaonMLPBNN" ),
        fNvars( 12 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "mult", "partP", "partPt", "nnkrec", "ptB", "IPs", "partlcs", "PIDNNk", "PIDNNpi", "PIDNNp", "ghostProb", "IPPU" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -1;
      fVmax[0] = 1;
      fVmin[1] = -1;
      fVmax[1] = 0.99999988079071;
      fVmin[2] = -1;
      fVmax[2] = 0.99999988079071;
      fVmin[3] = -1;
      fVmax[3] = 0.99999988079071;
      fVmin[4] = -1;
      fVmax[4] = 1;
      fVmin[5] = -1;
      fVmax[5] = 1;
      fVmin[6] = -1;
      fVmax[6] = 1;
      fVmin[7] = -1;
      fVmax[7] = 1;
      fVmin[8] = -1;
      fVmax[8] = 1;
      fVmin[9] = -1;
      fVmax[9] = 1;
      fVmin[10] = -1;
      fVmax[10] = 1;
      fVmin[11] = -1;
      fVmax[11] = 1;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';
      fType[4] = 'F';
      fType[5] = 'F';
      fType[6] = 'F';
      fType[7] = 'F';
      fType[8] = 'F';
      fType[9] = 'F';
      fType[10] = 'F';
      fType[11] = 'F';

      // initialize constants
      Initialize();

      // initialize transformation
      InitTransform();
   }

   // destructor
   virtual ~Read_kaonMLPBNN() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // input variable transformation

   double fDecTF_1[3][12][12];

   double fMin_2[3][12];
   double fMax_2[3][12];
   void InitTransform_1();
   void Transform_1( std::vector<double> & iv, int sigOrBgd ) const;
   void InitTransform_2();
   void Transform_2( std::vector<double> & iv, int sigOrBgd ) const;
   void InitTransform();
   void Transform( std::vector<double> & iv, int sigOrBgd ) const;

   // common member variables
   const char* fClassName;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[12];
   double fVmax[12];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[12];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)

   double ActivationFnc(double x) const;
   double OutputActivationFnc(double x) const;

   int fLayers;
   int fLayerSize[3];
   double fWeightMatrix0to1[18][13];   // weight matrix from layer 0 to 1
   double fWeightMatrix1to2[1][18];   // weight matrix from layer 1 to 2

   double * fWeights[3];
};

inline void Read_kaonMLPBNN::Initialize()
{
   // build network structure
   fLayers = 3;
   fLayerSize[0] = 13; fWeights[0] = new double[13]; 
   fLayerSize[1] = 18; fWeights[1] = new double[18]; 
   fLayerSize[2] = 1; fWeights[2] = new double[1]; 
   // weight matrix from layer 0 to 1
   fWeightMatrix0to1[0][0] = -0.178840328805581;
   fWeightMatrix0to1[1][0] = 1.65141466699714;
   fWeightMatrix0to1[2][0] = 1.17259696060842;
   fWeightMatrix0to1[3][0] = 0.920600277143372;
   fWeightMatrix0to1[4][0] = -1.88923981705654;
   fWeightMatrix0to1[5][0] = -0.907787141637761;
   fWeightMatrix0to1[6][0] = 0.512095199510049;
   fWeightMatrix0to1[7][0] = 1.88750104357726;
   fWeightMatrix0to1[8][0] = -1.19352790539453;
   fWeightMatrix0to1[9][0] = -0.885990003534944;
   fWeightMatrix0to1[10][0] = -1.64811266928985;
   fWeightMatrix0to1[11][0] = -0.511491826467964;
   fWeightMatrix0to1[12][0] = -1.38560944040997;
   fWeightMatrix0to1[13][0] = -0.294904339399013;
   fWeightMatrix0to1[14][0] = -0.816901780303128;
   fWeightMatrix0to1[15][0] = 0.663164718771702;
   fWeightMatrix0to1[16][0] = -0.346738334875125;
   fWeightMatrix0to1[0][1] = 2.01573364462955;
   fWeightMatrix0to1[1][1] = 0.302517549770543;
   fWeightMatrix0to1[2][1] = 1.23003932920544;
   fWeightMatrix0to1[3][1] = -0.731161937690441;
   fWeightMatrix0to1[4][1] = -0.698423912213661;
   fWeightMatrix0to1[5][1] = 0.634500946096222;
   fWeightMatrix0to1[6][1] = 0.466655233543043;
   fWeightMatrix0to1[7][1] = -0.730348077084445;
   fWeightMatrix0to1[8][1] = 0.10483322736767;
   fWeightMatrix0to1[9][1] = 1.42118960054696;
   fWeightMatrix0to1[10][1] = 0.0960957769697859;
   fWeightMatrix0to1[11][1] = -1.83831616239378;
   fWeightMatrix0to1[12][1] = 0.0552385141749165;
   fWeightMatrix0to1[13][1] = 0.897544595410179;
   fWeightMatrix0to1[14][1] = 0.940497884755984;
   fWeightMatrix0to1[15][1] = -0.542480779004855;
   fWeightMatrix0to1[16][1] = -0.181369959892296;
   fWeightMatrix0to1[0][2] = 0.0720798278880662;
   fWeightMatrix0to1[1][2] = -0.570121229461166;
   fWeightMatrix0to1[2][2] = -1.21289444238911;
   fWeightMatrix0to1[3][2] = 1.96491314753114;
   fWeightMatrix0to1[4][2] = -1.1573287758611;
   fWeightMatrix0to1[5][2] = 1.18215218654518;
   fWeightMatrix0to1[6][2] = 1.1594347108503;
   fWeightMatrix0to1[7][2] = 0.477081392772128;
   fWeightMatrix0to1[8][2] = 1.90396158854593;
   fWeightMatrix0to1[9][2] = 1.16609881299415;
   fWeightMatrix0to1[10][2] = -0.156387511643168;
   fWeightMatrix0to1[11][2] = -1.39257972467418;
   fWeightMatrix0to1[12][2] = 0.655996750365549;
   fWeightMatrix0to1[13][2] = 0.0793026756332563;
   fWeightMatrix0to1[14][2] = 1.38652252438666;
   fWeightMatrix0to1[15][2] = 1.37001599031734;
   fWeightMatrix0to1[16][2] = 1.79351789029587;
   fWeightMatrix0to1[0][3] = 1.34441752629907;
   fWeightMatrix0to1[1][3] = -1.54951972009678;
   fWeightMatrix0to1[2][3] = 1.31492543279196;
   fWeightMatrix0to1[3][3] = -2.09569765906667;
   fWeightMatrix0to1[4][3] = -0.861525688193752;
   fWeightMatrix0to1[5][3] = -1.70206780587331;
   fWeightMatrix0to1[6][3] = -0.193241119553568;
   fWeightMatrix0to1[7][3] = 1.51515662688291;
   fWeightMatrix0to1[8][3] = 0.999430994167042;
   fWeightMatrix0to1[9][3] = -1.37045606294417;
   fWeightMatrix0to1[10][3] = 0.00875360833921376;
   fWeightMatrix0to1[11][3] = -0.376062531495341;
   fWeightMatrix0to1[12][3] = 0.332834411813091;
   fWeightMatrix0to1[13][3] = 1.7057368766053;
   fWeightMatrix0to1[14][3] = -0.961179082626556;
   fWeightMatrix0to1[15][3] = 0.453212210824547;
   fWeightMatrix0to1[16][3] = -0.912621194053754;
   fWeightMatrix0to1[0][4] = 0.421759765788714;
   fWeightMatrix0to1[1][4] = -0.7379945233813;
   fWeightMatrix0to1[2][4] = -0.868354964154857;
   fWeightMatrix0to1[3][4] = -0.780917798624635;
   fWeightMatrix0to1[4][4] = 0.701448666198249;
   fWeightMatrix0to1[5][4] = 0.550862906069703;
   fWeightMatrix0to1[6][4] = 0.38214709936223;
   fWeightMatrix0to1[7][4] = -0.610900143253145;
   fWeightMatrix0to1[8][4] = -1.52840718111798;
   fWeightMatrix0to1[9][4] = -1.89363971764052;
   fWeightMatrix0to1[10][4] = -0.381550886470398;
   fWeightMatrix0to1[11][4] = 0.507922488939967;
   fWeightMatrix0to1[12][4] = 2.04659246762207;
   fWeightMatrix0to1[13][4] = 0.40626178305963;
   fWeightMatrix0to1[14][4] = 1.37121413210867;
   fWeightMatrix0to1[15][4] = -0.378114137033927;
   fWeightMatrix0to1[16][4] = -0.769862674580958;
   fWeightMatrix0to1[0][5] = -0.226423059212222;
   fWeightMatrix0to1[1][5] = 0.695979062337793;
   fWeightMatrix0to1[2][5] = -0.492413826340411;
   fWeightMatrix0to1[3][5] = -1.38798803819609;
   fWeightMatrix0to1[4][5] = -1.62692377754664;
   fWeightMatrix0to1[5][5] = -0.0487283685797075;
   fWeightMatrix0to1[6][5] = -0.876375938980349;
   fWeightMatrix0to1[7][5] = 1.00878765814931;
   fWeightMatrix0to1[8][5] = -1.23757175672897;
   fWeightMatrix0to1[9][5] = -0.759633741993094;
   fWeightMatrix0to1[10][5] = 2.53833258434527;
   fWeightMatrix0to1[11][5] = -0.755221375250751;
   fWeightMatrix0to1[12][5] = -1.26184375281224;
   fWeightMatrix0to1[13][5] = -0.908054957453946;
   fWeightMatrix0to1[14][5] = -0.756728725788253;
   fWeightMatrix0to1[15][5] = -2.10046702714737;
   fWeightMatrix0to1[16][5] = -1.7075809267458;
   fWeightMatrix0to1[0][6] = 0.735457527881298;
   fWeightMatrix0to1[1][6] = 2.04851011189738;
   fWeightMatrix0to1[2][6] = -0.951435970141725;
   fWeightMatrix0to1[3][6] = 0.740812616139965;
   fWeightMatrix0to1[4][6] = -0.908906799112905;
   fWeightMatrix0to1[5][6] = -1.12804092761402;
   fWeightMatrix0to1[6][6] = -0.819232030126264;
   fWeightMatrix0to1[7][6] = 1.21651565923826;
   fWeightMatrix0to1[8][6] = -2.11709307277885;
   fWeightMatrix0to1[9][6] = 0.313795907018321;
   fWeightMatrix0to1[10][6] = -0.672173156481064;
   fWeightMatrix0to1[11][6] = 0.238257487519484;
   fWeightMatrix0to1[12][6] = -1.47124515826507;
   fWeightMatrix0to1[13][6] = 2.07453298052066;
   fWeightMatrix0to1[14][6] = -0.29995175928818;
   fWeightMatrix0to1[15][6] = -0.599864594316234;
   fWeightMatrix0to1[16][6] = 0.327623425277747;
   fWeightMatrix0to1[0][7] = -0.887004806630205;
   fWeightMatrix0to1[1][7] = -1.90032336888909;
   fWeightMatrix0to1[2][7] = -0.294424627041941;
   fWeightMatrix0to1[3][7] = 0.381869794176488;
   fWeightMatrix0to1[4][7] = 1.72023229510851;
   fWeightMatrix0to1[5][7] = 0.583924381854941;
   fWeightMatrix0to1[6][7] = 1.33297428587158;
   fWeightMatrix0to1[7][7] = -1.08544028885718;
   fWeightMatrix0to1[8][7] = 0.67204025765918;
   fWeightMatrix0to1[9][7] = -1.67921197056662;
   fWeightMatrix0to1[10][7] = 0.758294683947601;
   fWeightMatrix0to1[11][7] = 0.302729355225348;
   fWeightMatrix0to1[12][7] = -1.74246472695805;
   fWeightMatrix0to1[13][7] = 0.338295118434661;
   fWeightMatrix0to1[14][7] = -0.850244760393029;
   fWeightMatrix0to1[15][7] = 0.0159896012633512;
   fWeightMatrix0to1[16][7] = 2.0209951913395;
   fWeightMatrix0to1[0][8] = 1.52278952376044;
   fWeightMatrix0to1[1][8] = -1.86274425021569;
   fWeightMatrix0to1[2][8] = 0.221843914914726;
   fWeightMatrix0to1[3][8] = 1.78634285589235;
   fWeightMatrix0to1[4][8] = 1.54278996327518;
   fWeightMatrix0to1[5][8] = 0.14502683392957;
   fWeightMatrix0to1[6][8] = -1.13784079896531;
   fWeightMatrix0to1[7][8] = -0.50916590813504;
   fWeightMatrix0to1[8][8] = -1.00496436174119;
   fWeightMatrix0to1[9][8] = 1.38288847820231;
   fWeightMatrix0to1[10][8] = 1.28113094068929;
   fWeightMatrix0to1[11][8] = -0.381445453463804;
   fWeightMatrix0to1[12][8] = -0.223007092042425;
   fWeightMatrix0to1[13][8] = 0.0181190502799853;
   fWeightMatrix0to1[14][8] = -0.563170711556675;
   fWeightMatrix0to1[15][8] = 0.180513281437092;
   fWeightMatrix0to1[16][8] = 1.33292080375075;
   fWeightMatrix0to1[0][9] = -0.905577856337766;
   fWeightMatrix0to1[1][9] = -0.714920241131511;
   fWeightMatrix0to1[2][9] = 0.054308583699927;
   fWeightMatrix0to1[3][9] = 1.35332558563434;
   fWeightMatrix0to1[4][9] = 0.523384205836799;
   fWeightMatrix0to1[5][9] = 0.67697449077987;
   fWeightMatrix0to1[6][9] = -2.43177437676719;
   fWeightMatrix0to1[7][9] = 0.972891443160754;
   fWeightMatrix0to1[8][9] = 0.249416242318769;
   fWeightMatrix0to1[9][9] = 0.36950550104342;
   fWeightMatrix0to1[10][9] = 0.1610722507792;
   fWeightMatrix0to1[11][9] = 1.07071173744188;
   fWeightMatrix0to1[12][9] = -0.532170985233289;
   fWeightMatrix0to1[13][9] = -0.759447842244041;
   fWeightMatrix0to1[14][9] = 1.30181793437408;
   fWeightMatrix0to1[15][9] = -1.00798021446016;
   fWeightMatrix0to1[16][9] = -0.775373911159243;
   fWeightMatrix0to1[0][10] = 1.23860727162322;
   fWeightMatrix0to1[1][10] = 0.503349181772215;
   fWeightMatrix0to1[2][10] = -0.674568492399413;
   fWeightMatrix0to1[3][10] = 2.5757062371001;
   fWeightMatrix0to1[4][10] = 1.81575523493137;
   fWeightMatrix0to1[5][10] = -1.89945934069498;
   fWeightMatrix0to1[6][10] = -0.369124550298788;
   fWeightMatrix0to1[7][10] = -1.119237763881;
   fWeightMatrix0to1[8][10] = 0.224599843193246;
   fWeightMatrix0to1[9][10] = -1.77169052852844;
   fWeightMatrix0to1[10][10] = -2.27092248675439;
   fWeightMatrix0to1[11][10] = 1.37444268607356;
   fWeightMatrix0to1[12][10] = 1.89062576565265;
   fWeightMatrix0to1[13][10] = -2.16281744571063;
   fWeightMatrix0to1[14][10] = 0.658437651609796;
   fWeightMatrix0to1[15][10] = -0.672997764312802;
   fWeightMatrix0to1[16][10] = 0.535854818164024;
   fWeightMatrix0to1[0][11] = 1.52837783105244;
   fWeightMatrix0to1[1][11] = -0.176211243302084;
   fWeightMatrix0to1[2][11] = -0.22618712170079;
   fWeightMatrix0to1[3][11] = -0.538505747811149;
   fWeightMatrix0to1[4][11] = 0.968096913149567;
   fWeightMatrix0to1[5][11] = 1.62435485433312;
   fWeightMatrix0to1[6][11] = 0.0339891712573743;
   fWeightMatrix0to1[7][11] = 0.151937989792736;
   fWeightMatrix0to1[8][11] = -0.247054911029388;
   fWeightMatrix0to1[9][11] = -1.65246203983651;
   fWeightMatrix0to1[10][11] = -0.0937729461496225;
   fWeightMatrix0to1[11][11] = 0.451410462426605;
   fWeightMatrix0to1[12][11] = -0.761304862285701;
   fWeightMatrix0to1[13][11] = -0.624989360684073;
   fWeightMatrix0to1[14][11] = 0.264826150727082;
   fWeightMatrix0to1[15][11] = 0.38469563795896;
   fWeightMatrix0to1[16][11] = -0.930226539564401;
   fWeightMatrix0to1[0][12] = 1.23742839414508;
   fWeightMatrix0to1[1][12] = 0.227576430680624;
   fWeightMatrix0to1[2][12] = -0.92060109703857;
   fWeightMatrix0to1[3][12] = 1.04275401470403;
   fWeightMatrix0to1[4][12] = 1.59241556185396;
   fWeightMatrix0to1[5][12] = 1.13424980830331;
   fWeightMatrix0to1[6][12] = 0.183127438987245;
   fWeightMatrix0to1[7][12] = -1.31046646945224;
   fWeightMatrix0to1[8][12] = -1.88577297014872;
   fWeightMatrix0to1[9][12] = -1.00514330687063;
   fWeightMatrix0to1[10][12] = 1.66671875687226;
   fWeightMatrix0to1[11][12] = 1.49273032226907;
   fWeightMatrix0to1[12][12] = 0.872665939242843;
   fWeightMatrix0to1[13][12] = -0.258148522953648;
   fWeightMatrix0to1[14][12] = 2.85293849816323;
   fWeightMatrix0to1[15][12] = -1.93671665436857;
   fWeightMatrix0to1[16][12] = -0.892170362881099;
   // weight matrix from layer 1 to 2
   fWeightMatrix1to2[0][0] = 0.0945372640353302;
   fWeightMatrix1to2[0][1] = -1.20521980379898;
   fWeightMatrix1to2[0][2] = 0.131077197889733;
   fWeightMatrix1to2[0][3] = 1.01931015242481;
   fWeightMatrix1to2[0][4] = -1.00351329659239;
   fWeightMatrix1to2[0][5] = 0.923694409364278;
   fWeightMatrix1to2[0][6] = 0.502271806115359;
   fWeightMatrix1to2[0][7] = -0.928036102625019;
   fWeightMatrix1to2[0][8] = 0.202342884204665;
   fWeightMatrix1to2[0][9] = -0.0863726419688721;
   fWeightMatrix1to2[0][10] = 0.440713128933547;
   fWeightMatrix1to2[0][11] = 0.857950210744313;
   fWeightMatrix1to2[0][12] = -0.924455122073093;
   fWeightMatrix1to2[0][13] = 1.25426608549572;
   fWeightMatrix1to2[0][14] = -0.751165014620433;
   fWeightMatrix1to2[0][15] = -0.345495459928672;
   fWeightMatrix1to2[0][16] = 0.0631988226595067;
   fWeightMatrix1to2[0][17] = -1.31180287556687;
}

inline double Read_kaonMLPBNN::GetMvaValue__( const std::vector<double>& inputValues ) const
{
   if (inputValues.size() != (unsigned int)fLayerSize[0]-1) {
      std::cout << "Input vector needs to be of size " << fLayerSize[0]-1 << std::endl;
      return 0;
   }

   for (int l=0; l<fLayers; l++)
      for (int i=0; i<fLayerSize[l]; i++) fWeights[l][i]=0;

   for (int l=0; l<fLayers-1; l++)
      fWeights[l][fLayerSize[l]-1]=1;

   for (int i=0; i<fLayerSize[0]-1; i++)
      fWeights[0][i]=inputValues[i];

   // layer 0 to 1
   for (int o=0; o<fLayerSize[1]-1; o++) {
      for (int i=0; i<fLayerSize[0]; i++) {
         double inputVal = fWeightMatrix0to1[o][i] * fWeights[0][i];
         fWeights[1][o] += inputVal;
      }
      fWeights[1][o] = ActivationFnc(fWeights[1][o]);
   }
   // layer 1 to 2
   for (int o=0; o<fLayerSize[2]; o++) {
      for (int i=0; i<fLayerSize[1]; i++) {
         double inputVal = fWeightMatrix1to2[o][i] * fWeights[1][i];
         fWeights[2][o] += inputVal;
      }
      fWeights[2][o] = OutputActivationFnc(fWeights[2][o]);
   }

   return fWeights[2][0];
}

double Read_kaonMLPBNN::ActivationFnc(double x) const {
   // hyperbolic tan
   return tanh(x);
}
double Read_kaonMLPBNN::OutputActivationFnc(double x) const {
   // sigmoid
   return 1.0/(1.0+exp(-x));
}
   
// Clean up
inline void Read_kaonMLPBNN::Clear() 
{
   // nothing to clear
}
   inline double Read_kaonMLPBNN::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!IsStatusClean()) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            Transform( iV, -1 );
            retval = GetMvaValue__( iV );
         }
         else {
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(*varIt);
            }
            Transform( iV, -1 );
            retval = GetMvaValue__( iV );
         }
      }

      return retval;
   }

//_______________________________________________________________________
inline void Read_kaonMLPBNN::InitTransform_1()
{
   // Decorrelation transformation, initialisation
   fDecTF_1[0][0][0] = 0.0821460864078;
   fDecTF_1[0][0][1] = -0.00210703496685;
   fDecTF_1[0][0][2] = -0.00251136629227;
   fDecTF_1[0][0][3] = -0.00982877631561;
   fDecTF_1[0][0][4] = -0.0038073070814;
   fDecTF_1[0][0][5] = 0.00247475255464;
   fDecTF_1[0][0][6] = -0.00226468550478;
   fDecTF_1[0][0][7] = 0.00992832302613;
   fDecTF_1[0][0][8] = -0.003501475828;
   fDecTF_1[0][0][9] = -0.00165585891398;
   fDecTF_1[0][0][10] = -0.00769274659757;
   fDecTF_1[0][0][11] = -0.0036398789189;
   fDecTF_1[0][1][0] = -0.00210703496685;
   fDecTF_1[0][1][1] = 1.62925234622;
   fDecTF_1[0][1][2] = -0.532408797939;
   fDecTF_1[0][1][3] = 0.125489233745;
   fDecTF_1[0][1][4] = 0.000930212368372;
   fDecTF_1[0][1][5] = 0.0366380127228;
   fDecTF_1[0][1][6] = 0.395751598644;
   fDecTF_1[0][1][7] = -0.340489559377;
   fDecTF_1[0][1][8] = -0.493828187396;
   fDecTF_1[0][1][9] = 0.767795660764;
   fDecTF_1[0][1][10] = -0.0716764307379;
   fDecTF_1[0][1][11] = 0.106979645794;
   fDecTF_1[0][2][0] = -0.00251136629227;
   fDecTF_1[0][2][1] = -0.532408797939;
   fDecTF_1[0][2][2] = 2.4429949233;
   fDecTF_1[0][2][3] = -0.147565650458;
   fDecTF_1[0][2][4] = -0.0963983543514;
   fDecTF_1[0][2][5] = -0.0867913760845;
   fDecTF_1[0][2][6] = -0.251784561354;
   fDecTF_1[0][2][7] = -0.000943467958217;
   fDecTF_1[0][2][8] = 0.249755113979;
   fDecTF_1[0][2][9] = 0.048230149846;
   fDecTF_1[0][2][10] = 0.103080751178;
   fDecTF_1[0][2][11] = -0.101197822036;
   fDecTF_1[0][3][0] = -0.00982877631561;
   fDecTF_1[0][3][1] = 0.125489233745;
   fDecTF_1[0][3][2] = -0.147565650458;
   fDecTF_1[0][3][3] = 1.36379125775;
   fDecTF_1[0][3][4] = 0.00265322541227;
   fDecTF_1[0][3][5] = -0.0114209313939;
   fDecTF_1[0][3][6] = -0.0161875070038;
   fDecTF_1[0][3][7] = 0.0627148087934;
   fDecTF_1[0][3][8] = -0.0205451496241;
   fDecTF_1[0][3][9] = -0.0138919023866;
   fDecTF_1[0][3][10] = -0.0115657779963;
   fDecTF_1[0][3][11] = 0.347272274235;
   fDecTF_1[0][4][0] = -0.0038073070814;
   fDecTF_1[0][4][1] = 0.000930212368371;
   fDecTF_1[0][4][2] = -0.0963983543514;
   fDecTF_1[0][4][3] = 0.00265322541227;
   fDecTF_1[0][4][4] = 1.36541667174;
   fDecTF_1[0][4][5] = -0.00459236426143;
   fDecTF_1[0][4][6] = -0.0203365278057;
   fDecTF_1[0][4][7] = 0.0130776418949;
   fDecTF_1[0][4][8] = -0.00977936406286;
   fDecTF_1[0][4][9] = 0.000258746136672;
   fDecTF_1[0][4][10] = 0.00565085517006;
   fDecTF_1[0][4][11] = -0.00109117370373;
   fDecTF_1[0][5][0] = 0.00247475255464;
   fDecTF_1[0][5][1] = 0.0366380127228;
   fDecTF_1[0][5][2] = -0.0867913760845;
   fDecTF_1[0][5][3] = -0.0114209313939;
   fDecTF_1[0][5][4] = -0.00459236426143;
   fDecTF_1[0][5][5] = 1.32225413806;
   fDecTF_1[0][5][6] = 0.0192751580775;
   fDecTF_1[0][5][7] = -0.00230549169097;
   fDecTF_1[0][5][8] = 0.0119584757159;
   fDecTF_1[0][5][9] = -0.0222656453594;
   fDecTF_1[0][5][10] = 0.0108499198123;
   fDecTF_1[0][5][11] = 0.000432966705904;
   fDecTF_1[0][6][0] = -0.00226468550478;
   fDecTF_1[0][6][1] = 0.395751598644;
   fDecTF_1[0][6][2] = -0.251784561354;
   fDecTF_1[0][6][3] = -0.0161875070038;
   fDecTF_1[0][6][4] = -0.0203365278057;
   fDecTF_1[0][6][5] = 0.0192751580775;
   fDecTF_1[0][6][6] = 4.08681272307;
   fDecTF_1[0][6][7] = 0.497229957465;
   fDecTF_1[0][6][8] = 0.305040081437;
   fDecTF_1[0][6][9] = 0.247979261186;
   fDecTF_1[0][6][10] = -0.526256867908;
   fDecTF_1[0][6][11] = -0.0130100614878;
   fDecTF_1[0][7][0] = 0.00992832302613;
   fDecTF_1[0][7][1] = -0.340489559377;
   fDecTF_1[0][7][2] = -0.000943467958217;
   fDecTF_1[0][7][3] = 0.0627148087934;
   fDecTF_1[0][7][4] = 0.0130776418949;
   fDecTF_1[0][7][5] = -0.00230549169097;
   fDecTF_1[0][7][6] = 0.497229957465;
   fDecTF_1[0][7][7] = 6.25260683215;
   fDecTF_1[0][7][8] = 2.55772221593;
   fDecTF_1[0][7][9] = 2.18330159886;
   fDecTF_1[0][7][10] = 0.156332020752;
   fDecTF_1[0][7][11] = -0.0167947064371;
   fDecTF_1[0][8][0] = -0.003501475828;
   fDecTF_1[0][8][1] = -0.493828187396;
   fDecTF_1[0][8][2] = 0.249755113979;
   fDecTF_1[0][8][3] = -0.0205451496241;
   fDecTF_1[0][8][4] = -0.00977936406286;
   fDecTF_1[0][8][5] = 0.0119584757159;
   fDecTF_1[0][8][6] = 0.305040081437;
   fDecTF_1[0][8][7] = 2.55772221593;
   fDecTF_1[0][8][8] = 6.9131105354;
   fDecTF_1[0][8][9] = 1.748732684;
   fDecTF_1[0][8][10] = 0.120102492362;
   fDecTF_1[0][8][11] = 0.0172779770627;
   fDecTF_1[0][9][0] = -0.00165585891398;
   fDecTF_1[0][9][1] = 0.767795660764;
   fDecTF_1[0][9][2] = 0.048230149846;
   fDecTF_1[0][9][3] = -0.0138919023866;
   fDecTF_1[0][9][4] = 0.000258746136672;
   fDecTF_1[0][9][5] = -0.0222656453594;
   fDecTF_1[0][9][6] = 0.247979261186;
   fDecTF_1[0][9][7] = 2.18330159886;
   fDecTF_1[0][9][8] = 1.748732684;
   fDecTF_1[0][9][9] = 10.0214979108;
   fDecTF_1[0][9][10] = 0.155831480968;
   fDecTF_1[0][9][11] = -0.000768008168838;
   fDecTF_1[0][10][0] = -0.00769274659757;
   fDecTF_1[0][10][1] = -0.0716764307379;
   fDecTF_1[0][10][2] = 0.103080751178;
   fDecTF_1[0][10][3] = -0.0115657779963;
   fDecTF_1[0][10][4] = 0.00565085517006;
   fDecTF_1[0][10][5] = 0.0108499198123;
   fDecTF_1[0][10][6] = -0.526256867908;
   fDecTF_1[0][10][7] = 0.156332020752;
   fDecTF_1[0][10][8] = 0.120102492362;
   fDecTF_1[0][10][9] = 0.155831480968;
   fDecTF_1[0][10][10] = 0.943546095904;
   fDecTF_1[0][10][11] = 0.0257839697725;
   fDecTF_1[0][11][0] = -0.0036398789189;
   fDecTF_1[0][11][1] = 0.106979645794;
   fDecTF_1[0][11][2] = -0.101197822036;
   fDecTF_1[0][11][3] = 0.347272274235;
   fDecTF_1[0][11][4] = -0.00109117370373;
   fDecTF_1[0][11][5] = 0.000432966705904;
   fDecTF_1[0][11][6] = -0.0130100614878;
   fDecTF_1[0][11][7] = -0.0167947064371;
   fDecTF_1[0][11][8] = 0.0172779770627;
   fDecTF_1[0][11][9] = -0.000768008168838;
   fDecTF_1[0][11][10] = 0.0257839697725;
   fDecTF_1[0][11][11] = 0.539973874827;
   fDecTF_1[1][0][0] = 0.0794687387915;
   fDecTF_1[1][0][1] = -0.00278102293154;
   fDecTF_1[1][0][2] = -0.00413817941397;
   fDecTF_1[1][0][3] = -0.00902585778967;
   fDecTF_1[1][0][4] = -0.00519504663476;
   fDecTF_1[1][0][5] = 0.0041189933178;
   fDecTF_1[1][0][6] = -0.00383466151902;
   fDecTF_1[1][0][7] = 0.00856073374095;
   fDecTF_1[1][0][8] = -0.00167049834033;
   fDecTF_1[1][0][9] = 0.00118172917375;
   fDecTF_1[1][0][10] = -0.00573601361004;
   fDecTF_1[1][0][11] = -0.00380657470679;
   fDecTF_1[1][1][0] = -0.00278102293154;
   fDecTF_1[1][1][1] = 1.58078524138;
   fDecTF_1[1][1][2] = -0.480986603608;
   fDecTF_1[1][1][3] = 0.122829721027;
   fDecTF_1[1][1][4] = -0.00559373100172;
   fDecTF_1[1][1][5] = 0.036297017824;
   fDecTF_1[1][1][6] = 0.33944454516;
   fDecTF_1[1][1][7] = -0.312718474809;
   fDecTF_1[1][1][8] = -0.430737815519;
   fDecTF_1[1][1][9] = 0.765521560538;
   fDecTF_1[1][1][10] = -0.0449911156662;
   fDecTF_1[1][1][11] = 0.103869802801;
   fDecTF_1[1][2][0] = -0.00413817941397;
   fDecTF_1[1][2][1] = -0.480986603608;
   fDecTF_1[1][2][2] = 2.47984571526;
   fDecTF_1[1][2][3] = -0.136845032334;
   fDecTF_1[1][2][4] = -0.0809445607185;
   fDecTF_1[1][2][5] = -0.0530904782328;
   fDecTF_1[1][2][6] = -0.177730536213;
   fDecTF_1[1][2][7] = -0.00890808626679;
   fDecTF_1[1][2][8] = 0.239026943594;
   fDecTF_1[1][2][9] = -0.00429690983274;
   fDecTF_1[1][2][10] = 0.0610910304989;
   fDecTF_1[1][2][11] = -0.0993601797429;
   fDecTF_1[1][3][0] = -0.00902585778967;
   fDecTF_1[1][3][1] = 0.122829721027;
   fDecTF_1[1][3][2] = -0.136845032334;
   fDecTF_1[1][3][3] = 1.3180900054;
   fDecTF_1[1][3][4] = 0.00866573434426;
   fDecTF_1[1][3][5] = -0.00889016320209;
   fDecTF_1[1][3][6] = -0.0242583094422;
   fDecTF_1[1][3][7] = 0.0466568740034;
   fDecTF_1[1][3][8] = -0.0194233014596;
   fDecTF_1[1][3][9] = -0.00103840711577;
   fDecTF_1[1][3][10] = -0.00855781574726;
   fDecTF_1[1][3][11] = 0.337368408021;
   fDecTF_1[1][4][0] = -0.00519504663476;
   fDecTF_1[1][4][1] = -0.00559373100172;
   fDecTF_1[1][4][2] = -0.0809445607185;
   fDecTF_1[1][4][3] = 0.00866573434426;
   fDecTF_1[1][4][4] = 1.38815260192;
   fDecTF_1[1][4][5] = -0.0128725059892;
   fDecTF_1[1][4][6] = -0.0208370554067;
   fDecTF_1[1][4][7] = 0.00438365196378;
   fDecTF_1[1][4][8] = 0.000139296660009;
   fDecTF_1[1][4][9] = 0.0155907474166;
   fDecTF_1[1][4][10] = 0.0060253440329;
   fDecTF_1[1][4][11] = -0.00454418212687;
   fDecTF_1[1][5][0] = 0.0041189933178;
   fDecTF_1[1][5][1] = 0.036297017824;
   fDecTF_1[1][5][2] = -0.0530904782328;
   fDecTF_1[1][5][3] = -0.00889016320209;
   fDecTF_1[1][5][4] = -0.0128725059892;
   fDecTF_1[1][5][5] = 1.26605176888;
   fDecTF_1[1][5][6] = 0.0340641805409;
   fDecTF_1[1][5][7] = 0.0218641013231;
   fDecTF_1[1][5][8] = -0.00590960822162;
   fDecTF_1[1][5][9] = -0.0462045382111;
   fDecTF_1[1][5][10] = 0.0136856644206;
   fDecTF_1[1][5][11] = 0.00834477458813;
   fDecTF_1[1][6][0] = -0.00383466151902;
   fDecTF_1[1][6][1] = 0.33944454516;
   fDecTF_1[1][6][2] = -0.177730536213;
   fDecTF_1[1][6][3] = -0.0242583094422;
   fDecTF_1[1][6][4] = -0.0208370554067;
   fDecTF_1[1][6][5] = 0.0340641805409;
   fDecTF_1[1][6][6] = 3.75177647659;
   fDecTF_1[1][6][7] = 0.554373846191;
   fDecTF_1[1][6][8] = 0.419924819875;
   fDecTF_1[1][6][9] = 0.319557719466;
   fDecTF_1[1][6][10] = -0.33494661316;
   fDecTF_1[1][6][11] = -0.00566468024394;
   fDecTF_1[1][7][0] = 0.00856073374095;
   fDecTF_1[1][7][1] = -0.312718474809;
   fDecTF_1[1][7][2] = -0.00890808626679;
   fDecTF_1[1][7][3] = 0.0466568740034;
   fDecTF_1[1][7][4] = 0.00438365196378;
   fDecTF_1[1][7][5] = 0.0218641013231;
   fDecTF_1[1][7][6] = 0.554373846191;
   fDecTF_1[1][7][7] = 6.15830831309;
   fDecTF_1[1][7][8] = 2.42734032813;
   fDecTF_1[1][7][9] = 1.86961074544;
   fDecTF_1[1][7][10] = 0.1017619556;
   fDecTF_1[1][7][11] = -0.0201723355928;
   fDecTF_1[1][8][0] = -0.00167049834033;
   fDecTF_1[1][8][1] = -0.430737815519;
   fDecTF_1[1][8][2] = 0.239026943594;
   fDecTF_1[1][8][3] = -0.0194233014596;
   fDecTF_1[1][8][4] = 0.000139296660009;
   fDecTF_1[1][8][5] = -0.00590960822162;
   fDecTF_1[1][8][6] = 0.419924819875;
   fDecTF_1[1][8][7] = 2.42734032813;
   fDecTF_1[1][8][8] = 6.72790960502;
   fDecTF_1[1][8][9] = 1.76419401138;
   fDecTF_1[1][8][10] = 0.0918572022471;
   fDecTF_1[1][8][11] = 0.00897102618111;
   fDecTF_1[1][9][0] = 0.00118172917375;
   fDecTF_1[1][9][1] = 0.765521560538;
   fDecTF_1[1][9][2] = -0.00429690983274;
   fDecTF_1[1][9][3] = -0.00103840711577;
   fDecTF_1[1][9][4] = 0.0155907474166;
   fDecTF_1[1][9][5] = -0.0462045382111;
   fDecTF_1[1][9][6] = 0.319557719466;
   fDecTF_1[1][9][7] = 1.86961074544;
   fDecTF_1[1][9][8] = 1.76419401138;
   fDecTF_1[1][9][9] = 9.62021727725;
   fDecTF_1[1][9][10] = 0.10711369407;
   fDecTF_1[1][9][11] = 0.0048378422477;
   fDecTF_1[1][10][0] = -0.00573601361004;
   fDecTF_1[1][10][1] = -0.0449911156662;
   fDecTF_1[1][10][2] = 0.0610910304989;
   fDecTF_1[1][10][3] = -0.00855781574726;
   fDecTF_1[1][10][4] = 0.0060253440329;
   fDecTF_1[1][10][5] = 0.0136856644206;
   fDecTF_1[1][10][6] = -0.33494661316;
   fDecTF_1[1][10][7] = 0.1017619556;
   fDecTF_1[1][10][8] = 0.0918572022471;
   fDecTF_1[1][10][9] = 0.10711369407;
   fDecTF_1[1][10][10] = 0.751656796641;
   fDecTF_1[1][10][11] = 0.0192276593865;
   fDecTF_1[1][11][0] = -0.00380657470679;
   fDecTF_1[1][11][1] = 0.103869802801;
   fDecTF_1[1][11][2] = -0.0993601797429;
   fDecTF_1[1][11][3] = 0.337368408021;
   fDecTF_1[1][11][4] = -0.00454418212687;
   fDecTF_1[1][11][5] = 0.00834477458813;
   fDecTF_1[1][11][6] = -0.00566468024394;
   fDecTF_1[1][11][7] = -0.0201723355928;
   fDecTF_1[1][11][8] = 0.00897102618111;
   fDecTF_1[1][11][9] = 0.0048378422477;
   fDecTF_1[1][11][10] = 0.0192276593865;
   fDecTF_1[1][11][11] = 0.534876640042;
   fDecTF_1[2][0][0] = 0.0808803564564;
   fDecTF_1[2][0][1] = -0.00230020881469;
   fDecTF_1[2][0][2] = -0.00300947454209;
   fDecTF_1[2][0][3] = -0.00948041819665;
   fDecTF_1[2][0][4] = -0.0044192577167;
   fDecTF_1[2][0][5] = 0.0032867706951;
   fDecTF_1[2][0][6] = -0.00318085554174;
   fDecTF_1[2][0][7] = 0.0095637172908;
   fDecTF_1[2][0][8] = -0.00271928163491;
   fDecTF_1[2][0][9] = -0.000515012150656;
   fDecTF_1[2][0][10] = -0.00677922814699;
   fDecTF_1[2][0][11] = -0.00366064127578;
   fDecTF_1[2][1][0] = -0.00230020881469;
   fDecTF_1[2][1][1] = 1.6064107372;
   fDecTF_1[2][1][2] = -0.509735738242;
   fDecTF_1[2][1][3] = 0.124254489286;
   fDecTF_1[2][1][4] = -0.00188629517103;
   fDecTF_1[2][1][5] = 0.0361147847094;
   fDecTF_1[2][1][6] = 0.365823733438;
   fDecTF_1[2][1][7] = -0.327190477821;
   fDecTF_1[2][1][8] = -0.464647224091;
   fDecTF_1[2][1][9] = 0.768492155048;
   fDecTF_1[2][1][10] = -0.0567758690805;
   fDecTF_1[2][1][11] = 0.105542605745;
   fDecTF_1[2][2][0] = -0.00300947454209;
   fDecTF_1[2][2][1] = -0.509735738242;
   fDecTF_1[2][2][2] = 2.4526857332;
   fDecTF_1[2][2][3] = -0.142886638641;
   fDecTF_1[2][2][4] = -0.0898115582073;
   fDecTF_1[2][2][5] = -0.0726476365705;
   fDecTF_1[2][2][6] = -0.211588586881;
   fDecTF_1[2][2][7] = -0.0111270388537;
   fDecTF_1[2][2][8] = 0.244091163444;
   fDecTF_1[2][2][9] = 0.026753552112;
   fDecTF_1[2][2][10] = 0.0808561240838;
   fDecTF_1[2][2][11] = -0.100755446093;
   fDecTF_1[2][3][0] = -0.00948041819665;
   fDecTF_1[2][3][1] = 0.124254489286;
   fDecTF_1[2][3][2] = -0.142886638641;
   fDecTF_1[2][3][3] = 1.34379272635;
   fDecTF_1[2][3][4] = 0.00526816336821;
   fDecTF_1[2][3][5] = -0.0103258863826;
   fDecTF_1[2][3][6] = -0.0201611093661;
   fDecTF_1[2][3][7] = 0.0557764657008;
   fDecTF_1[2][3][8] = -0.0199537302947;
   fDecTF_1[2][3][9] = -0.00812940115627;
   fDecTF_1[2][3][10] = -0.00999085029153;
   fDecTF_1[2][3][11] = 0.342945020806;
   fDecTF_1[2][4][0] = -0.0044192577167;
   fDecTF_1[2][4][1] = -0.00188629517103;
   fDecTF_1[2][4][2] = -0.0898115582073;
   fDecTF_1[2][4][3] = 0.00526816336821;
   fDecTF_1[2][4][4] = 1.37473410464;
   fDecTF_1[2][4][5] = -0.00804237817941;
   fDecTF_1[2][4][6] = -0.0206591535484;
   fDecTF_1[2][4][7] = 0.00992076300936;
   fDecTF_1[2][4][8] = -0.00574708775415;
   fDecTF_1[2][4][9] = 0.00648489378079;
   fDecTF_1[2][4][10] = 0.00581801532151;
   fDecTF_1[2][4][11] = -0.00250283134446;
   fDecTF_1[2][5][0] = 0.0032867706951;
   fDecTF_1[2][5][1] = 0.0361147847094;
   fDecTF_1[2][5][2] = -0.0726476365705;
   fDecTF_1[2][5][3] = -0.0103258863826;
   fDecTF_1[2][5][4] = -0.00804237817941;
   fDecTF_1[2][5][5] = 1.29691352143;
   fDecTF_1[2][5][6] = 0.0257834665613;
   fDecTF_1[2][5][7] = 0.00749739106519;
   fDecTF_1[2][5][8] = 0.00417408627522;
   fDecTF_1[2][5][9] = -0.031891777657;
   fDecTF_1[2][5][10] = 0.0125419331016;
   fDecTF_1[2][5][11] = 0.00382732551942;
   fDecTF_1[2][6][0] = -0.00318085554174;
   fDecTF_1[2][6][1] = 0.365823733438;
   fDecTF_1[2][6][2] = -0.211588586881;
   fDecTF_1[2][6][3] = -0.0201611093661;
   fDecTF_1[2][6][4] = -0.0206591535484;
   fDecTF_1[2][6][5] = 0.0257834665613;
   fDecTF_1[2][6][6] = 3.90602591023;
   fDecTF_1[2][6][7] = 0.534044188729;
   fDecTF_1[2][6][8] = 0.361865711825;
   fDecTF_1[2][6][9] = 0.288021627236;
   fDecTF_1[2][6][10] = -0.423204826294;
   fDecTF_1[2][6][11] = -0.00917876101078;
   fDecTF_1[2][7][0] = 0.0095637172908;
   fDecTF_1[2][7][1] = -0.327190477821;
   fDecTF_1[2][7][2] = -0.0111270388537;
   fDecTF_1[2][7][3] = 0.0557764657008;
   fDecTF_1[2][7][4] = 0.00992076300936;
   fDecTF_1[2][7][5] = 0.00749739106519;
   fDecTF_1[2][7][6] = 0.534044188729;
   fDecTF_1[2][7][7] = 6.20000744642;
   fDecTF_1[2][7][8] = 2.50050769736;
   fDecTF_1[2][7][9] = 2.04793208924;
   fDecTF_1[2][7][10] = 0.12720733963;
   fDecTF_1[2][7][11] = -0.0186994054876;
   fDecTF_1[2][8][0] = -0.00271928163491;
   fDecTF_1[2][8][1] = -0.464647224091;
   fDecTF_1[2][8][2] = 0.244091163444;
   fDecTF_1[2][8][3] = -0.0199537302947;
   fDecTF_1[2][8][4] = -0.00574708775415;
   fDecTF_1[2][8][5] = 0.00417408627522;
   fDecTF_1[2][8][6] = 0.361865711825;
   fDecTF_1[2][8][7] = 2.50050769736;
   fDecTF_1[2][8][8] = 6.82722503131;
   fDecTF_1[2][8][9] = 1.74865410856;
   fDecTF_1[2][8][10] = 0.10416415455;
   fDecTF_1[2][8][11] = 0.0137767200241;
   fDecTF_1[2][9][0] = -0.000515012150656;
   fDecTF_1[2][9][1] = 0.768492155048;
   fDecTF_1[2][9][2] = 0.026753552112;
   fDecTF_1[2][9][3] = -0.00812940115627;
   fDecTF_1[2][9][4] = 0.00648489378079;
   fDecTF_1[2][9][5] = -0.031891777657;
   fDecTF_1[2][9][6] = 0.288021627236;
   fDecTF_1[2][9][7] = 2.04793208924;
   fDecTF_1[2][9][8] = 1.74865410856;
   fDecTF_1[2][9][9] = 9.82552511042;
   fDecTF_1[2][9][10] = 0.128458471904;
   fDecTF_1[2][9][11] = 0.00190904556142;
   fDecTF_1[2][10][0] = -0.00677922814699;
   fDecTF_1[2][10][1] = -0.0567758690805;
   fDecTF_1[2][10][2] = 0.0808561240838;
   fDecTF_1[2][10][3] = -0.00999085029153;
   fDecTF_1[2][10][4] = 0.00581801532151;
   fDecTF_1[2][10][5] = 0.0125419331016;
   fDecTF_1[2][10][6] = -0.423204826294;
   fDecTF_1[2][10][7] = 0.12720733963;
   fDecTF_1[2][10][8] = 0.10416415455;
   fDecTF_1[2][10][9] = 0.128458471904;
   fDecTF_1[2][10][10] = 0.844864343431;
   fDecTF_1[2][10][11] = 0.0225212573338;
   fDecTF_1[2][11][0] = -0.00366064127578;
   fDecTF_1[2][11][1] = 0.105542605745;
   fDecTF_1[2][11][2] = -0.100755446093;
   fDecTF_1[2][11][3] = 0.342945020806;
   fDecTF_1[2][11][4] = -0.00250283134446;
   fDecTF_1[2][11][5] = 0.00382732551942;
   fDecTF_1[2][11][6] = -0.00917876101078;
   fDecTF_1[2][11][7] = -0.0186994054876;
   fDecTF_1[2][11][8] = 0.0137767200241;
   fDecTF_1[2][11][9] = 0.00190904556142;
   fDecTF_1[2][11][10] = 0.0225212573338;
   fDecTF_1[2][11][11] = 0.537672775836;
}

//_______________________________________________________________________
inline void Read_kaonMLPBNN::Transform_1( std::vector<double>& iv, int cls) const
{
   // Decorrelation transformation
   if (cls < 0 || cls > 2) {
       if (2 > 1 ) cls = 2;
       else cls = 2;
   }

   // define the indices of the variables which are transformed by this transformation
   std::vector<int> indicesGet;
   std::vector<int> indicesPut;

   indicesGet.push_back( 0);
   indicesGet.push_back( 1);
   indicesGet.push_back( 2);
   indicesGet.push_back( 3);
   indicesGet.push_back( 4);
   indicesGet.push_back( 5);
   indicesGet.push_back( 6);
   indicesGet.push_back( 7);
   indicesGet.push_back( 8);
   indicesGet.push_back( 9);
   indicesGet.push_back( 10);
   indicesGet.push_back( 11);
   indicesPut.push_back( 0);
   indicesPut.push_back( 1);
   indicesPut.push_back( 2);
   indicesPut.push_back( 3);
   indicesPut.push_back( 4);
   indicesPut.push_back( 5);
   indicesPut.push_back( 6);
   indicesPut.push_back( 7);
   indicesPut.push_back( 8);
   indicesPut.push_back( 9);
   indicesPut.push_back( 10);
   indicesPut.push_back( 11);

   std::vector<double> tv;
   for (int i=0; i<12;i++) {
      double v = 0;
      for (int j=0; j<12; j++)
         v += iv[indicesGet.at(j)] * fDecTF_1[cls][i][j];
      tv.push_back(v);
   }
   for (int i=0; i<12;i++) iv[indicesPut.at(i)] = tv[i];
}

//_______________________________________________________________________
inline void Read_kaonMLPBNN::InitTransform_2()
{
   // Normalization transformation, initialisation
   fMin_2[0][0] = 0.101012043655;
   fMax_2[0][0] = 10.3885307312;
   fMin_2[1][0] = 0.079770103097;
   fMax_2[1][0] = 10.4709043503;
   fMin_2[2][0] = 0.079770103097;
   fMax_2[2][0] = 10.4709043503;
   fMin_2[0][1] = 2.48159408569;
   fMax_2[0][1] = 8.9674987793;
   fMin_2[1][1] = 2.74456906319;
   fMax_2[1][1] = 12.6733865738;
   fMin_2[2][1] = 2.48159408569;
   fMax_2[2][1] = 12.6733865738;
   fMin_2[0][2] = -4.72285604477;
   fMax_2[0][2] = 2.14852666855;
   fMin_2[1][2] = -9.16865062714;
   fMax_2[1][2] = 2.20977401733;
   fMin_2[2][2] = -9.16865062714;
   fMax_2[2][2] = 2.20977401733;
   fMin_2[0][3] = 2.93898129463;
   fMax_2[0][3] = 11.7722110748;
   fMin_2[1][3] = 3.11691403389;
   fMax_2[1][3] = 12.2579898834;
   fMin_2[2][3] = 2.93898129463;
   fMax_2[2][3] = 12.2579898834;
   fMin_2[0][4] = -5.24459505081;
   fMax_2[0][4] = 5.1295375824;
   fMin_2[1][4] = -6.14168977737;
   fMax_2[1][4] = 5.1054520607;
   fMin_2[2][4] = -6.14168977737;
   fMax_2[2][4] = 5.1295375824;
   fMin_2[0][5] = 1.76816403866;
   fMax_2[0][5] = 6.45536518097;
   fMin_2[1][5] = 1.71007168293;
   fMax_2[1][5] = 6.55869197845;
   fMin_2[2][5] = 1.71007168293;
   fMax_2[2][5] = 6.55869197845;
   fMin_2[0][6] = -3.31635475159;
   fMax_2[0][6] = 8.88293170929;
   fMin_2[1][6] = -2.69254636765;
   fMax_2[1][6] = 47.6837882996;
   fMin_2[2][6] = -3.31635475159;
   fMax_2[2][6] = 47.6837882996;
   fMin_2[0][7] = -0.682406425476;
   fMax_2[0][7] = 6.8931889534;
   fMin_2[1][7] = -10.139787674;
   fMax_2[1][7] = 6.75202798843;
   fMin_2[2][7] = -10.139787674;
   fMax_2[2][7] = 6.8931889534;
   fMin_2[0][8] = -1.85603058338;
   fMax_2[0][8] = 5.99666166306;
   fMin_2[1][8] = -8.61538791656;
   fMax_2[1][8] = 5.90857362747;
   fMin_2[2][8] = -8.61538791656;
   fMax_2[2][8] = 5.99666166306;
   fMin_2[0][9] = 1.63233661652;
   fMax_2[0][9] = 10.781627655;
   fMin_2[1][9] = -8.15376567841;
   fMax_2[1][9] = 9.94253540039;
   fMin_2[2][9] = -8.15376567841;
   fMax_2[2][9] = 10.781627655;
   fMin_2[0][10] = -9.44369411469;
   fMax_2[0][10] = -0.747401595116;
   fMin_2[1][10] = -85.3190841675;
   fMax_2[1][10] = -0.992535054684;
   fMin_2[2][10] = -85.3190841675;
   fMax_2[2][10] = -0.747401595116;
   fMin_2[0][11] = 1.59542655945;
   fMax_2[0][11] = 5.87845516205;
   fMin_2[1][11] = 1.62705934048;
   fMax_2[1][11] = 5.68215179443;
   fMin_2[2][11] = 1.59542655945;
   fMax_2[2][11] = 5.87845516205;
}

//_______________________________________________________________________
inline void Read_kaonMLPBNN::Transform_2( std::vector<double>& iv, int cls) const
{
   // Normalization transformation
   if (cls < 0 || cls > 2) {
   if (2 > 1 ) cls = 2;
      else cls = 2;
   }
   const int nVar = 12;

   // get indices of used variables

   // define the indices of the variables which are transformed by this transformation
   std::vector<int> indicesGet;
   std::vector<int> indicesPut;

   indicesGet.push_back( 0);
   indicesGet.push_back( 1);
   indicesGet.push_back( 2);
   indicesGet.push_back( 3);
   indicesGet.push_back( 4);
   indicesGet.push_back( 5);
   indicesGet.push_back( 6);
   indicesGet.push_back( 7);
   indicesGet.push_back( 8);
   indicesGet.push_back( 9);
   indicesGet.push_back( 10);
   indicesGet.push_back( 11);
   indicesPut.push_back( 0);
   indicesPut.push_back( 1);
   indicesPut.push_back( 2);
   indicesPut.push_back( 3);
   indicesPut.push_back( 4);
   indicesPut.push_back( 5);
   indicesPut.push_back( 6);
   indicesPut.push_back( 7);
   indicesPut.push_back( 8);
   indicesPut.push_back( 9);
   indicesPut.push_back( 10);
   indicesPut.push_back( 11);

   std::vector<double> dv(nVar);
   for (int ivar=0; ivar<nVar; ivar++) dv[ivar] = iv[indicesGet.at(ivar)];
   for (int ivar=0;ivar<12;ivar++) {
      double offset = fMin_2[cls][ivar];
      double scale  = 1.0/(fMax_2[cls][ivar]-fMin_2[cls][ivar]);
      iv[indicesPut.at(ivar)] = (dv[ivar]-offset)*scale * 2 - 1;
   }
}

//_______________________________________________________________________
inline void Read_kaonMLPBNN::InitTransform()
{
   InitTransform_1();
   InitTransform_2();
}

//_______________________________________________________________________
inline void Read_kaonMLPBNN::Transform( std::vector<double>& iv, int sigOrBgd ) const
{
   Transform_1( iv, sigOrBgd );
   Transform_2( iv, sigOrBgd );
}
