// Class: Read_muonMLPBNN
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : MLP::_muonMLPBNN
TMVA Release   : 4.1.0         [262400]
ROOT Release   : 5.29/01       [335105]
Creator        : vecchi
Date           : Wed May 22 16:01:40 2013
Host           : Linux lhcbwn1.fe.infn.it 2.6.18-238.5.1.el5 #1 SMP Tue Mar 1 18:58:43 EST 2011 x86_64 x86_64 x86_64 GNU/Linux
Dir            : /home/vecchi/NEWFTC_optcal_2012_sWeights/parallelo
Training events: 18444
Analysis type  : [Classification]


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
NCycles: "180" [Number of training cycles]
HiddenLayers: "N+5" [Specification of hidden layer architecture]
NeuronType: "sigmoid" [Neuron activation function type]
V: "False" [Verbose output (short form of "VerbosityLevel" below - overrides the latter one)]
VarTransform: "D,N" [List of variable transformations performed before training, e.g., "D_Background,P_Signal,G,N_AllClasses" for: "Decorrelation, PCA-transformation, Gaussianisation, Normalisation, each for the given class of events ('AllClasses' denotes all events of all classes, if no class indication is given, 'All' is assumed)"]
H: "True" [Print method-specific help message]
TrainingMethod: "BFGS" [Train with Back-Propagation (BP), BFGS Algorithm (BFGS), or Genetic Algorithm (GA - slower and worse)]
TestRate: "5" [Test for overtraining performed at each #th epochs]
UseRegulator: "True" [Use regulator to avoid over-training]
# Default:
RandomSeed: "1" [Random seed for initial synapse weights (0 means unique seed for each run; default value '1')]
EstimatorType: "MSE" [MSE (Mean Square Estimator) for Gaussian Likelihood or CE(Cross-Entropy) for Bernoulli Likelihood]
NeuronInputType: "sum" [Neuron input function type]
VerbosityLevel: "Default" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs (signal and background)]
IgnoreNegWeightsInTraining: "False" [Events with negative weights are ignored in the training (but are included for testing and performance evaluation)]
LearningRate: "2.000000e-02" [ANN learning rate parameter]
DecayRate: "1.000000e-02" [Decay rate for learning parameter]
EpochMonitoring: "False" [Provide epoch-wise monitoring plots according to TestRate (caution: causes big ROOT output file!)]
Sampling: "1.000000e+00" [Only 'Sampling' (randomly selected) events are trained each epoch]
SamplingEpoch: "1.000000e+00" [Sampling is used for the first 'SamplingEpoch' epochs, afterwards, all events are taken for training]
SamplingImportance: "1.000000e+00" [ The sampling weights of events in epochs which successful (worse estimator than before) are multiplied with SamplingImportance, else they are divided.]
SamplingTraining: "True" [The training sample is sampled]
SamplingTesting: "False" [The testing sample is sampled]
ResetStep: "50" [How often BFGS should reset history]
Tau: "3.000000e+00" [LineSearch "size step"]
BPMode: "sequential" [Back-propagation learning mode: sequential or batch]
BatchSize: "-1" [Batch size: number of events/batch, only set if in Batch Mode, -1 for BatchSize=number_of_events]
ConvergenceImprove: "1.000000e-30" [Minimum improvement which counts as improvement (<0 means automatic convergence check is turned off)]
ConvergenceTests: "-1" [Number of steps (without improvement) required for convergence (<0 means automatic convergence check is turned off)]
UpdateLimit: "10000" [Maximum times of regulator update]
CalculateErrors: "False" [Calculates inverse Hessian matrix at the end of the training to be able to calculate the uncertainties of an MVA value]
WeightRange: "1.000000e+00" [Take the events for the estimator calculations from small deviations from the desired value to large deviations only over the weight range]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 9
mult                          mult                          mult                          mult                          I                                 'F'    [1,135]
partP                         partP                         partP                         partP                         F                                 'F'    [1.18993878365,5.29766893387]
partPt                        partPt                        partPt                        partPt                        F                                 'F'    [0.0953430384398,2.30242347717]
ptB                           ptB                           ptB                           ptB                           F                                 'F'    [-3.75328564644,3.79909777641]
IPs                           IPs                           IPs                           IPs                           F                                 'F'    [-5.43279027939,7.90389442444]
partlcs                       partlcs                       partlcs                       partlcs                       F                                 'F'    [-1.45116055012,1.09621489048]
PIDNNm                        PIDNNm                        PIDNNm                        PIDNNm                        F                                 'F'    [0.350009262562,0.997365832329]
ghostProb                     ghostProb                     ghostProb                     ghostProb                     F                                 'F'    [-11.7512645721,-0.923411846161]
IPPU                          IPPU                          IPPU                          IPPU                          F                                 'F'    [1.09890723228,9.21034049988]
NSpec 0


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() : fStatusIsClean( true ) {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;

   // returns classifier status
   bool IsStatusClean() const { return fStatusIsClean; }

 protected:

   bool fStatusIsClean;
};

#endif

class Read_muonMLPBNN : public IClassifierReader {

 public:

   // constructor
   Read_muonMLPBNN( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "Read_muonMLPBNN" ),
        fNvars( 9 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "mult", "partP", "partPt", "ptB", "IPs", "partlcs", "PIDNNm", "ghostProb", "IPPU" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -1;
      fVmax[0] = 0.99999988079071;
      fVmin[1] = -1;
      fVmax[1] = 1;
      fVmin[2] = -1;
      fVmax[2] = 1;
      fVmin[3] = -1;
      fVmax[3] = 1;
      fVmin[4] = -1;
      fVmax[4] = 1;
      fVmin[5] = -1;
      fVmax[5] = 1;
      fVmin[6] = -1;
      fVmax[6] = 1;
      fVmin[7] = -1;
      fVmax[7] = 1;
      fVmin[8] = -1;
      fVmax[8] = 1;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';
      fType[4] = 'F';
      fType[5] = 'F';
      fType[6] = 'F';
      fType[7] = 'F';
      fType[8] = 'F';

      // initialize constants
      Initialize();

      // initialize transformation
      InitTransform();
   }

   // destructor
   virtual ~Read_muonMLPBNN() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // input variable transformation

   double fDecTF_1[3][9][9];

   double fMin_2[3][9];
   double fMax_2[3][9];
   void InitTransform_1();
   void Transform_1( std::vector<double> & iv, int sigOrBgd ) const;
   void InitTransform_2();
   void Transform_2( std::vector<double> & iv, int sigOrBgd ) const;
   void InitTransform();
   void Transform( std::vector<double> & iv, int sigOrBgd ) const;

   // common member variables
   const char* fClassName;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[9];
   double fVmax[9];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[9];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)

   double ActivationFnc(double x) const;
   double OutputActivationFnc(double x) const;

   int fLayers;
   int fLayerSize[3];
   double fWeightMatrix0to1[15][10];   // weight matrix from layer 0 to 1
   double fWeightMatrix1to2[1][15];   // weight matrix from layer 1 to 2

   double * fWeights[3];
};

inline void Read_muonMLPBNN::Initialize()
{
   // build network structure
   fLayers = 3;
   fLayerSize[0] = 10; fWeights[0] = new double[10]; 
   fLayerSize[1] = 15; fWeights[1] = new double[15]; 
   fLayerSize[2] = 1; fWeights[2] = new double[1]; 
   // weight matrix from layer 0 to 1
   fWeightMatrix0to1[0][0] = 0.0268481862320671;
   fWeightMatrix0to1[1][0] = 1.73028108821566;
   fWeightMatrix0to1[2][0] = -0.68885687878623;
   fWeightMatrix0to1[3][0] = 1.49481498325252;
   fWeightMatrix0to1[4][0] = -1.83597576741187;
   fWeightMatrix0to1[5][0] = -1.29939991758502;
   fWeightMatrix0to1[6][0] = 0.0513693433275299;
   fWeightMatrix0to1[7][0] = 1.5719713387486;
   fWeightMatrix0to1[8][0] = -1.52845813403352;
   fWeightMatrix0to1[9][0] = -0.868155122221743;
   fWeightMatrix0to1[10][0] = -1.72719030809413;
   fWeightMatrix0to1[11][0] = -0.390979516213536;
   fWeightMatrix0to1[12][0] = -0.303865459779288;
   fWeightMatrix0to1[13][0] = -0.26089520068442;
   fWeightMatrix0to1[0][1] = -0.979900284248711;
   fWeightMatrix0to1[1][1] = 0.324249584634229;
   fWeightMatrix0to1[2][1] = 0.717151033685368;
   fWeightMatrix0to1[3][1] = 1.51945403187153;
   fWeightMatrix0to1[4][1] = 0.183677325513014;
   fWeightMatrix0to1[5][1] = 0.541366008259089;
   fWeightMatrix0to1[6][1] = 0.00476498993840325;
   fWeightMatrix0to1[7][1] = -0.160385389884104;
   fWeightMatrix0to1[8][1] = 0.614867672269883;
   fWeightMatrix0to1[9][1] = 0.496109798643063;
   fWeightMatrix0to1[10][1] = -1.21938634528855;
   fWeightMatrix0to1[11][1] = -0.209740791393429;
   fWeightMatrix0to1[12][1] = 1.85195797839722;
   fWeightMatrix0to1[13][1] = -0.642974940245443;
   fWeightMatrix0to1[0][2] = -2.2146001698685;
   fWeightMatrix0to1[1][2] = 0.175639504020115;
   fWeightMatrix0to1[2][2] = 0.333661064043348;
   fWeightMatrix0to1[3][2] = 1.63790908416119;
   fWeightMatrix0to1[4][2] = -1.24069142755673;
   fWeightMatrix0to1[5][2] = -0.217393892571353;
   fWeightMatrix0to1[6][2] = 1.13690981588572;
   fWeightMatrix0to1[7][2] = -0.0812460019309611;
   fWeightMatrix0to1[8][2] = -0.882329694434917;
   fWeightMatrix0to1[9][2] = 1.96716008116804;
   fWeightMatrix0to1[10][2] = -0.713081116530286;
   fWeightMatrix0to1[11][2] = 1.15542521893029;
   fWeightMatrix0to1[12][2] = 1.6552391083627;
   fWeightMatrix0to1[13][2] = 1.03743812204976;
   fWeightMatrix0to1[0][3] = 0.864296032530639;
   fWeightMatrix0to1[1][3] = 1.189469891128;
   fWeightMatrix0to1[2][3] = -1.9175686955553;
   fWeightMatrix0to1[3][3] = -1.55322496522784;
   fWeightMatrix0to1[4][3] = 0.345647578128654;
   fWeightMatrix0to1[5][3] = -0.378573340879333;
   fWeightMatrix0to1[6][3] = 1.69585613474784;
   fWeightMatrix0to1[7][3] = 1.58412054919265;
   fWeightMatrix0to1[8][3] = 1.75102775552602;
   fWeightMatrix0to1[9][3] = 1.36771654806119;
   fWeightMatrix0to1[10][3] = -1.16527407302155;
   fWeightMatrix0to1[11][3] = 1.34375136154259;
   fWeightMatrix0to1[12][3] = -1.99239085559449;
   fWeightMatrix0to1[13][3] = -1.02119550085603;
   fWeightMatrix0to1[0][4] = -2.29499923098776;
   fWeightMatrix0to1[1][4] = -1.97295341973677;
   fWeightMatrix0to1[2][4] = 3.23350262770489;
   fWeightMatrix0to1[3][4] = 0.514867707744199;
   fWeightMatrix0to1[4][4] = -0.147009887468667;
   fWeightMatrix0to1[5][4] = 0.655959805330418;
   fWeightMatrix0to1[6][4] = 0.0582209681207384;
   fWeightMatrix0to1[7][4] = 0.79393749406715;
   fWeightMatrix0to1[8][4] = 3.12144255127425;
   fWeightMatrix0to1[9][4] = -0.329146324461007;
   fWeightMatrix0to1[10][4] = 0.368925295346245;
   fWeightMatrix0to1[11][4] = -1.11228963711921;
   fWeightMatrix0to1[12][4] = 0.714320686904047;
   fWeightMatrix0to1[13][4] = -1.07145535369841;
   fWeightMatrix0to1[0][5] = 0.175377531966483;
   fWeightMatrix0to1[1][5] = -1.08504650556398;
   fWeightMatrix0to1[2][5] = -0.632278517736111;
   fWeightMatrix0to1[3][5] = 0.938097285839004;
   fWeightMatrix0to1[4][5] = 0.927027135192328;
   fWeightMatrix0to1[5][5] = -0.369930023913903;
   fWeightMatrix0to1[6][5] = -1.28151744594046;
   fWeightMatrix0to1[7][5] = -1.6149616363773;
   fWeightMatrix0to1[8][5] = 0.0997845461901019;
   fWeightMatrix0to1[9][5] = 0.0445332119813262;
   fWeightMatrix0to1[10][5] = 1.56707864066416;
   fWeightMatrix0to1[11][5] = 0.685888614318561;
   fWeightMatrix0to1[12][5] = 1.25533962530721;
   fWeightMatrix0to1[13][5] = -0.761290012692548;
   fWeightMatrix0to1[0][6] = -0.193364599764265;
   fWeightMatrix0to1[1][6] = -0.334429017291961;
   fWeightMatrix0to1[2][6] = 0.588345893835655;
   fWeightMatrix0to1[3][6] = -1.14259037308247;
   fWeightMatrix0to1[4][6] = -1.22514756050876;
   fWeightMatrix0to1[5][6] = -0.699094226684227;
   fWeightMatrix0to1[6][6] = 0.605141425789983;
   fWeightMatrix0to1[7][6] = 0.101286954336567;
   fWeightMatrix0to1[8][6] = 1.28304917327624;
   fWeightMatrix0to1[9][6] = -1.16789725568553;
   fWeightMatrix0to1[10][6] = -0.786653458380552;
   fWeightMatrix0to1[11][6] = 1.40612900185557;
   fWeightMatrix0to1[12][6] = 0.568428951339293;
   fWeightMatrix0to1[13][6] = -1.43093674626759;
   fWeightMatrix0to1[0][7] = -0.717280730181983;
   fWeightMatrix0to1[1][7] = 0.164997381512458;
   fWeightMatrix0to1[2][7] = -1.124429692452;
   fWeightMatrix0to1[3][7] = -1.74889758891726;
   fWeightMatrix0to1[4][7] = 0.24619086544924;
   fWeightMatrix0to1[5][7] = 2.17375961709548;
   fWeightMatrix0to1[6][7] = -0.465881027518278;
   fWeightMatrix0to1[7][7] = 1.76623707257431;
   fWeightMatrix0to1[8][7] = -0.557924176930017;
   fWeightMatrix0to1[9][7] = -0.414337622241978;
   fWeightMatrix0to1[10][7] = -0.225444862188668;
   fWeightMatrix0to1[11][7] = 0.451797353055668;
   fWeightMatrix0to1[12][7] = -0.878600096531183;
   fWeightMatrix0to1[13][7] = 0.123795644086299;
   fWeightMatrix0to1[0][8] = 0.407732697949635;
   fWeightMatrix0to1[1][8] = 0.144118513829862;
   fWeightMatrix0to1[2][8] = -0.465199075722889;
   fWeightMatrix0to1[3][8] = 1.48671524899499;
   fWeightMatrix0to1[4][8] = -0.260123675048382;
   fWeightMatrix0to1[5][8] = -0.527204828462742;
   fWeightMatrix0to1[6][8] = 0.737154836726202;
   fWeightMatrix0to1[7][8] = -1.0877370918433;
   fWeightMatrix0to1[8][8] = -0.309980084076196;
   fWeightMatrix0to1[9][8] = 0.397310152039944;
   fWeightMatrix0to1[10][8] = -0.169939788414528;
   fWeightMatrix0to1[11][8] = 1.4430334155828;
   fWeightMatrix0to1[12][8] = -0.0735106922920181;
   fWeightMatrix0to1[13][8] = -0.189130438416144;
   fWeightMatrix0to1[0][9] = 0.705987193071402;
   fWeightMatrix0to1[1][9] = 0.381276637233707;
   fWeightMatrix0to1[2][9] = -1.81529883915345;
   fWeightMatrix0to1[3][9] = 0.68929941674152;
   fWeightMatrix0to1[4][9] = -0.780302582038359;
   fWeightMatrix0to1[5][9] = -1.46030510760996;
   fWeightMatrix0to1[6][9] = 0.944120954956064;
   fWeightMatrix0to1[7][9] = -1.43402408448868;
   fWeightMatrix0to1[8][9] = 0.0609425287906549;
   fWeightMatrix0to1[9][9] = 0.943038355574624;
   fWeightMatrix0to1[10][9] = 1.74878512091099;
   fWeightMatrix0to1[11][9] = -1.31566087426277;
   fWeightMatrix0to1[12][9] = 0.477165959187821;
   fWeightMatrix0to1[13][9] = 1.07016681306948;
   // weight matrix from layer 1 to 2
   fWeightMatrix1to2[0][0] = 0.587800013235188;
   fWeightMatrix1to2[0][1] = -0.464944817711856;
   fWeightMatrix1to2[0][2] = -0.759048100202072;
   fWeightMatrix1to2[0][3] = -0.0889837287907571;
   fWeightMatrix1to2[0][4] = -0.675654676366389;
   fWeightMatrix1to2[0][5] = 0.342843163952581;
   fWeightMatrix1to2[0][6] = 0.524960423711722;
   fWeightMatrix1to2[0][7] = -0.221440652686932;
   fWeightMatrix1to2[0][8] = 0.527751237441424;
   fWeightMatrix1to2[0][9] = 0.127921329343091;
   fWeightMatrix1to2[0][10] = -0.265720797780361;
   fWeightMatrix1to2[0][11] = -0.325681403594293;
   fWeightMatrix1to2[0][12] = 0.575337257248748;
   fWeightMatrix1to2[0][13] = 0.25566056971271;
   fWeightMatrix1to2[0][14] = -0.0472783313988748;
}

inline double Read_muonMLPBNN::GetMvaValue__( const std::vector<double>& inputValues ) const
{
   if (inputValues.size() != (unsigned int)fLayerSize[0]-1) {
      std::cout << "Input vector needs to be of size " << fLayerSize[0]-1 << std::endl;
      return 0;
   }

   for (int l=0; l<fLayers; l++)
      for (int i=0; i<fLayerSize[l]; i++) fWeights[l][i]=0;

   for (int l=0; l<fLayers-1; l++)
      fWeights[l][fLayerSize[l]-1]=1;

   for (int i=0; i<fLayerSize[0]-1; i++)
      fWeights[0][i]=inputValues[i];

   // layer 0 to 1
   for (int o=0; o<fLayerSize[1]-1; o++) {
      for (int i=0; i<fLayerSize[0]; i++) {
         double inputVal = fWeightMatrix0to1[o][i] * fWeights[0][i];
         fWeights[1][o] += inputVal;
      }
      fWeights[1][o] = ActivationFnc(fWeights[1][o]);
   }
   // layer 1 to 2
   for (int o=0; o<fLayerSize[2]; o++) {
      for (int i=0; i<fLayerSize[1]; i++) {
         double inputVal = fWeightMatrix1to2[o][i] * fWeights[1][i];
         fWeights[2][o] += inputVal;
      }
      fWeights[2][o] = OutputActivationFnc(fWeights[2][o]);
   }

   return fWeights[2][0];
}

double Read_muonMLPBNN::ActivationFnc(double x) const {
   // sigmoid
   return 1.0/(1.0+exp(-x));
}
double Read_muonMLPBNN::OutputActivationFnc(double x) const {
   // identity
   return x;
}
   
// Clean up
inline void Read_muonMLPBNN::Clear() 
{
   // nothing to clear
}
   inline double Read_muonMLPBNN::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!IsStatusClean()) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            Transform( iV, -1 );
            retval = GetMvaValue__( iV );
         }
         else {
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(*varIt);
            }
            Transform( iV, -1 );
            retval = GetMvaValue__( iV );
         }
      }

      return retval;
   }

//_______________________________________________________________________
inline void Read_muonMLPBNN::InitTransform_1()
{
   // Decorrelation transformation, initialisation
   fDecTF_1[0][0][0] = 0.081708624239;
   fDecTF_1[0][0][1] = -0.00055053441209;
   fDecTF_1[0][0][2] = -0.0034827847678;
   fDecTF_1[0][0][3] = -0.00449691248302;
   fDecTF_1[0][0][4] = 0.00102804890872;
   fDecTF_1[0][0][5] = -0.00290073960383;
   fDecTF_1[0][0][6] = 0.00870610653769;
   fDecTF_1[0][0][7] = -0.00673564793165;
   fDecTF_1[0][0][8] = 0.000133410286556;
   fDecTF_1[0][1][0] = -0.00055053441209;
   fDecTF_1[0][1][1] = 1.45827215336;
   fDecTF_1[0][1][2] = -0.519333731084;
   fDecTF_1[0][1][3] = -0.00197025373381;
   fDecTF_1[0][1][4] = 0.0319326856672;
   fDecTF_1[0][1][5] = 0.4886560284;
   fDecTF_1[0][1][6] = -0.0755708771932;
   fDecTF_1[0][1][7] = -0.0598906218179;
   fDecTF_1[0][1][8] = 0.0562483955584;
   fDecTF_1[0][2][0] = -0.0034827847678;
   fDecTF_1[0][2][1] = -0.519333731084;
   fDecTF_1[0][2][2] = 2.6734295211;
   fDecTF_1[0][2][3] = -0.0882217764989;
   fDecTF_1[0][2][4] = -0.0311295562247;
   fDecTF_1[0][2][5] = -0.427988242309;
   fDecTF_1[0][2][6] = -0.733319898918;
   fDecTF_1[0][2][7] = 0.104880509744;
   fDecTF_1[0][2][8] = -0.0341556291855;
   fDecTF_1[0][3][0] = -0.00449691248302;
   fDecTF_1[0][3][1] = -0.00197025373381;
   fDecTF_1[0][3][2] = -0.0882217764989;
   fDecTF_1[0][3][3] = 1.34094233912;
   fDecTF_1[0][3][4] = 0.000944946098799;
   fDecTF_1[0][3][5] = -0.0272285952939;
   fDecTF_1[0][3][6] = 0.025217705741;
   fDecTF_1[0][3][7] = 0.00238022676027;
   fDecTF_1[0][3][8] = -0.00551997130904;
   fDecTF_1[0][4][0] = 0.00102804890872;
   fDecTF_1[0][4][1] = 0.0319326856672;
   fDecTF_1[0][4][2] = -0.0311295562247;
   fDecTF_1[0][4][3] = 0.000944946098799;
   fDecTF_1[0][4][4] = 0.666839773149;
   fDecTF_1[0][4][5] = 0.00918460592758;
   fDecTF_1[0][4][6] = -0.0896468714126;
   fDecTF_1[0][4][7] = 0.0254751672313;
   fDecTF_1[0][4][8] = 0.00945883903618;
   fDecTF_1[0][5][0] = -0.00290073960383;
   fDecTF_1[0][5][1] = 0.4886560284;
   fDecTF_1[0][5][2] = -0.427988242309;
   fDecTF_1[0][5][3] = -0.0272285952939;
   fDecTF_1[0][5][4] = 0.00918460592758;
   fDecTF_1[0][5][5] = 3.98288109854;
   fDecTF_1[0][5][6] = 0.615523450733;
   fDecTF_1[0][5][7] = -0.457207834923;
   fDecTF_1[0][5][8] = 0.00653601811149;
   fDecTF_1[0][6][0] = 0.00870610653769;
   fDecTF_1[0][6][1] = -0.0755708771932;
   fDecTF_1[0][6][2] = -0.733319898918;
   fDecTF_1[0][6][3] = 0.025217705741;
   fDecTF_1[0][6][4] = -0.0896468714126;
   fDecTF_1[0][6][5] = 0.615523450733;
   fDecTF_1[0][6][6] = 6.86487875331;
   fDecTF_1[0][6][7] = 0.222776163612;
   fDecTF_1[0][6][8] = -0.0312945558152;
   fDecTF_1[0][7][0] = -0.00673564793165;
   fDecTF_1[0][7][1] = -0.0598906218179;
   fDecTF_1[0][7][2] = 0.104880509744;
   fDecTF_1[0][7][3] = 0.00238022676027;
   fDecTF_1[0][7][4] = 0.0254751672313;
   fDecTF_1[0][7][5] = -0.457207834923;
   fDecTF_1[0][7][6] = 0.222776163612;
   fDecTF_1[0][7][7] = 0.916415228395;
   fDecTF_1[0][7][8] = 0.0246961914268;
   fDecTF_1[0][8][0] = 0.000133410286556;
   fDecTF_1[0][8][1] = 0.0562483955584;
   fDecTF_1[0][8][2] = -0.0341556291855;
   fDecTF_1[0][8][3] = -0.00551997130904;
   fDecTF_1[0][8][4] = 0.00945883903618;
   fDecTF_1[0][8][5] = 0.00653601811149;
   fDecTF_1[0][8][6] = -0.0312945558152;
   fDecTF_1[0][8][7] = 0.0246961914268;
   fDecTF_1[0][8][8] = 0.444826210481;
   fDecTF_1[1][0][0] = 0.0825175659584;
   fDecTF_1[1][0][1] = -0.001432408326;
   fDecTF_1[1][0][2] = -0.00195719994621;
   fDecTF_1[1][0][3] = -0.00396690366688;
   fDecTF_1[1][0][4] = 0.00508606880491;
   fDecTF_1[1][0][5] = -0.00159717503135;
   fDecTF_1[1][0][6] = 0.00936185747572;
   fDecTF_1[1][0][7] = -0.00816796416531;
   fDecTF_1[1][0][8] = -0.000379983449304;
   fDecTF_1[1][1][0] = -0.001432408326;
   fDecTF_1[1][1][1] = 1.52031968532;
   fDecTF_1[1][1][2] = -0.491238585856;
   fDecTF_1[1][1][3] = -0.00786817831662;
   fDecTF_1[1][1][4] = 0.0164965351935;
   fDecTF_1[1][1][5] = 0.5105087863;
   fDecTF_1[1][1][6] = -0.0896555345214;
   fDecTF_1[1][1][7] = -0.0478375732018;
   fDecTF_1[1][1][8] = 0.0677759279383;
   fDecTF_1[1][2][0] = -0.00195719994621;
   fDecTF_1[1][2][1] = -0.491238585856;
   fDecTF_1[1][2][2] = 2.75699455464;
   fDecTF_1[1][2][3] = -0.0592024393737;
   fDecTF_1[1][2][4] = -0.0362681571098;
   fDecTF_1[1][2][5] = -0.376237090506;
   fDecTF_1[1][2][6] = -0.567022795187;
   fDecTF_1[1][2][7] = 0.0735947394225;
   fDecTF_1[1][2][8] = -0.0433512926729;
   fDecTF_1[1][3][0] = -0.00396690366688;
   fDecTF_1[1][3][1] = -0.00786817831662;
   fDecTF_1[1][3][2] = -0.0592024393737;
   fDecTF_1[1][3][3] = 1.30390027184;
   fDecTF_1[1][3][4] = 0.00790669247572;
   fDecTF_1[1][3][5] = 0.00690761607633;
   fDecTF_1[1][3][6] = -0.00698603212478;
   fDecTF_1[1][3][7] = -0.0274416285841;
   fDecTF_1[1][3][8] = -0.017692054565;
   fDecTF_1[1][4][0] = 0.00508606880491;
   fDecTF_1[1][4][1] = 0.0164965351935;
   fDecTF_1[1][4][2] = -0.0362681571098;
   fDecTF_1[1][4][3] = 0.00790669247572;
   fDecTF_1[1][4][4] = 0.586113536739;
   fDecTF_1[1][4][5] = 0.0152743228617;
   fDecTF_1[1][4][6] = -0.118300427173;
   fDecTF_1[1][4][7] = 0.0291624999852;
   fDecTF_1[1][4][8] = 0.0385423328108;
   fDecTF_1[1][5][0] = -0.00159717503135;
   fDecTF_1[1][5][1] = 0.5105087863;
   fDecTF_1[1][5][2] = -0.376237090506;
   fDecTF_1[1][5][3] = 0.00690761607634;
   fDecTF_1[1][5][4] = 0.0152743228617;
   fDecTF_1[1][5][5] = 4.05071598577;
   fDecTF_1[1][5][6] = 0.513224644242;
   fDecTF_1[1][5][7] = -0.514491569805;
   fDecTF_1[1][5][8] = 0.00453161639718;
   fDecTF_1[1][6][0] = 0.00936185747572;
   fDecTF_1[1][6][1] = -0.0896555345214;
   fDecTF_1[1][6][2] = -0.567022795187;
   fDecTF_1[1][6][3] = -0.00698603212478;
   fDecTF_1[1][6][4] = -0.118300427173;
   fDecTF_1[1][6][5] = 0.513224644242;
   fDecTF_1[1][6][6] = 6.43194104146;
   fDecTF_1[1][6][7] = 0.255409498825;
   fDecTF_1[1][6][8] = -0.0284907057939;
   fDecTF_1[1][7][0] = -0.00816796416531;
   fDecTF_1[1][7][1] = -0.0478375732018;
   fDecTF_1[1][7][2] = 0.0735947394225;
   fDecTF_1[1][7][3] = -0.0274416285841;
   fDecTF_1[1][7][4] = 0.0291624999852;
   fDecTF_1[1][7][5] = -0.514491569805;
   fDecTF_1[1][7][6] = 0.255409498825;
   fDecTF_1[1][7][7] = 0.90756561346;
   fDecTF_1[1][7][8] = 0.0257998084975;
   fDecTF_1[1][8][0] = -0.000379983449304;
   fDecTF_1[1][8][1] = 0.0677759279383;
   fDecTF_1[1][8][2] = -0.0433512926729;
   fDecTF_1[1][8][3] = -0.017692054565;
   fDecTF_1[1][8][4] = 0.0385423328108;
   fDecTF_1[1][8][5] = 0.00453161639718;
   fDecTF_1[1][8][6] = -0.0284907057939;
   fDecTF_1[1][8][7] = 0.0257998084975;
   fDecTF_1[1][8][8] = 0.435507502456;
   fDecTF_1[2][0][0] = 0.0818365086739;
   fDecTF_1[2][0][1] = -0.00052168269764;
   fDecTF_1[2][0][2] = -0.00258218264279;
   fDecTF_1[2][0][3] = -0.00441466004666;
   fDecTF_1[2][0][4] = 0.00272338585319;
   fDecTF_1[2][0][5] = -0.00257838599872;
   fDecTF_1[2][0][6] = 0.00933257889922;
   fDecTF_1[2][0][7] = -0.00746252598387;
   fDecTF_1[2][0][8] = 3.0550640712e-06;
   fDecTF_1[2][1][0] = -0.00052168269764;
   fDecTF_1[2][1][1] = 1.47608556592;
   fDecTF_1[2][1][2] = -0.513928092804;
   fDecTF_1[2][1][3] = -0.00300345083677;
   fDecTF_1[2][1][4] = 0.0247268685331;
   fDecTF_1[2][1][5] = 0.496846332769;
   fDecTF_1[2][1][6] = -0.0860990383735;
   fDecTF_1[2][1][7] = -0.0540904662358;
   fDecTF_1[2][1][8] = 0.0600009761122;
   fDecTF_1[2][2][0] = -0.00258218264279;
   fDecTF_1[2][2][1] = -0.513928092804;
   fDecTF_1[2][2][2] = 2.68966967437;
   fDecTF_1[2][2][3] = -0.0769902141102;
   fDecTF_1[2][2][4] = -0.0334976466973;
   fDecTF_1[2][2][5] = -0.410419896122;
   fDecTF_1[2][2][6] = -0.681380467663;
   fDecTF_1[2][2][7] = 0.0963753295162;
   fDecTF_1[2][2][8] = -0.0381585287692;
   fDecTF_1[2][3][0] = -0.00441466004666;
   fDecTF_1[2][3][1] = -0.00300345083677;
   fDecTF_1[2][3][2] = -0.0769902141102;
   fDecTF_1[2][3][3] = 1.32657753628;
   fDecTF_1[2][3][4] = 0.00451549391548;
   fDecTF_1[2][3][5] = -0.0162103740677;
   fDecTF_1[2][3][6] = 0.015475722898;
   fDecTF_1[2][3][7] = -0.00866849982329;
   fDecTF_1[2][3][8] = -0.00993559718225;
   fDecTF_1[2][4][0] = 0.00272338585319;
   fDecTF_1[2][4][1] = 0.0247268685331;
   fDecTF_1[2][4][2] = -0.0334976466973;
   fDecTF_1[2][4][3] = 0.00451549391548;
   fDecTF_1[2][4][4] = 0.63291361593;
   fDecTF_1[2][4][5] = 0.0119135517647;
   fDecTF_1[2][4][6] = -0.103511481602;
   fDecTF_1[2][4][7] = 0.027858538836;
   fDecTF_1[2][4][8] = 0.0210927761701;
   fDecTF_1[2][5][0] = -0.00257838599872;
   fDecTF_1[2][5][1] = 0.496846332769;
   fDecTF_1[2][5][2] = -0.410419896122;
   fDecTF_1[2][5][3] = -0.0162103740677;
   fDecTF_1[2][5][4] = 0.0119135517647;
   fDecTF_1[2][5][5] = 4.00261163462;
   fDecTF_1[2][5][6] = 0.580171762671;
   fDecTF_1[2][5][7] = -0.47713754703;
   fDecTF_1[2][5][8] = 0.00603947846045;
   fDecTF_1[2][6][0] = 0.00933257889922;
   fDecTF_1[2][6][1] = -0.0860990383735;
   fDecTF_1[2][6][2] = -0.681380467663;
   fDecTF_1[2][6][3] = 0.015475722898;
   fDecTF_1[2][6][4] = -0.103511481602;
   fDecTF_1[2][6][5] = 0.580171762671;
   fDecTF_1[2][6][6] = 6.6773343072;
   fDecTF_1[2][6][7] = 0.236735605426;
   fDecTF_1[2][6][8] = -0.0303495940932;
   fDecTF_1[2][7][0] = -0.00746252598387;
   fDecTF_1[2][7][1] = -0.0540904662358;
   fDecTF_1[2][7][2] = 0.0963753295162;
   fDecTF_1[2][7][3] = -0.00866849982329;
   fDecTF_1[2][7][4] = 0.027858538836;
   fDecTF_1[2][7][5] = -0.47713754703;
   fDecTF_1[2][7][6] = 0.236735605426;
   fDecTF_1[2][7][7] = 0.911427985293;
   fDecTF_1[2][7][8] = 0.0252012041054;
   fDecTF_1[2][8][0] = 3.0550640712e-06;
   fDecTF_1[2][8][1] = 0.0600009761122;
   fDecTF_1[2][8][2] = -0.0381585287692;
   fDecTF_1[2][8][3] = -0.00993559718225;
   fDecTF_1[2][8][4] = 0.0210927761701;
   fDecTF_1[2][8][5] = 0.00603947846045;
   fDecTF_1[2][8][6] = -0.0303495940932;
   fDecTF_1[2][8][7] = 0.0252012041054;
   fDecTF_1[2][8][8] = 0.440847282152;
}

//_______________________________________________________________________
inline void Read_muonMLPBNN::Transform_1( std::vector<double>& iv, int cls) const
{
   // Decorrelation transformation
   if (cls < 0 || cls > 2) {
       if (2 > 1 ) cls = 2;
       else cls = 2;
   }

   // define the indices of the variables which are transformed by this transformation
   std::vector<int> indicesGet;
   std::vector<int> indicesPut;

   indicesGet.push_back( 0);
   indicesGet.push_back( 1);
   indicesGet.push_back( 2);
   indicesGet.push_back( 3);
   indicesGet.push_back( 4);
   indicesGet.push_back( 5);
   indicesGet.push_back( 6);
   indicesGet.push_back( 7);
   indicesGet.push_back( 8);
   indicesPut.push_back( 0);
   indicesPut.push_back( 1);
   indicesPut.push_back( 2);
   indicesPut.push_back( 3);
   indicesPut.push_back( 4);
   indicesPut.push_back( 5);
   indicesPut.push_back( 6);
   indicesPut.push_back( 7);
   indicesPut.push_back( 8);

   std::vector<double> tv;
   for (int i=0; i<9;i++) {
      double v = 0;
      for (int j=0; j<9; j++)
         v += iv[indicesGet.at(j)] * fDecTF_1[cls][i][j];
      tv.push_back(v);
   }
   for (int i=0; i<9;i++) iv[indicesPut.at(i)] = tv[i];
}

//_______________________________________________________________________
inline void Read_muonMLPBNN::InitTransform_2()
{
   // Normalization transformation, initialisation
   fMin_2[0][0] = 0.115731880069;
   fMax_2[0][0] = 10.1746749878;
   fMin_2[1][0] = 0.291180163622;
   fMax_2[1][0] = 11.0775203705;
   fMin_2[2][0] = 0.115731880069;
   fMax_2[2][0] = 11.0775203705;
   fMin_2[0][1] = 2.18882322311;
   fMax_2[0][1] = 7.81738138199;
   fMin_2[1][1] = 2.20701932907;
   fMax_2[1][1] = 7.75432538986;
   fMin_2[2][1] = 2.18882322311;
   fMax_2[2][1] = 7.81738138199;
   fMin_2[0][2] = -3.5178155899;
   fMax_2[0][2] = 2.76786279678;
   fMin_2[1][2] = -3.38416790962;
   fMax_2[1][2] = 2.49308776855;
   fMin_2[2][2] = -3.5178155899;
   fMax_2[2][2] = 2.76786279678;
   fMin_2[0][3] = -4.78951597214;
   fMax_2[0][3] = 4.83111619949;
   fMin_2[1][3] = -5.13260602951;
   fMax_2[1][3] = 4.79681348801;
   fMin_2[2][3] = -5.13260602951;
   fMax_2[2][3] = 4.83111619949;
   fMin_2[0][4] = -3.32609176636;
   fMax_2[0][4] = 4.91909265518;
   fMin_2[1][4] = -3.13046693802;
   fMax_2[1][4] = 5.08129405975;
   fMin_2[2][4] = -3.32609176636;
   fMax_2[2][4] = 5.08129405975;
   fMin_2[0][5] = -0.630447626114;
   fMax_2[0][5] = 7.62688064575;
   fMin_2[1][5] = -1.27372276783;
   fMax_2[1][5] = 8.10869598389;
   fMin_2[2][5] = -1.27372276783;
   fMax_2[2][5] = 8.10869598389;
   fMin_2[0][6] = -0.765228807926;
   fMax_2[0][6] = 6.11333799362;
   fMin_2[1][6] = -0.491316795349;
   fMax_2[1][6] = 6.18400478363;
   fMin_2[2][6] = -0.765228807926;
   fMax_2[2][6] = 6.18400478363;
   fMin_2[0][7] = -10.5953903198;
   fMax_2[0][7] = -1.00231575966;
   fMin_2[1][7] = -9.35707187653;
   fMax_2[1][7] = -1.05921900272;
   fMin_2[2][7] = -10.5953903198;
   fMax_2[2][7] = -1.00231575966;
   fMin_2[0][8] = 0.490629345179;
   fMax_2[0][8] = 4.29026412964;
   fMin_2[1][8] = 0.480275988579;
   fMax_2[1][8] = 4.28923130035;
   fMin_2[2][8] = 0.480275988579;
   fMax_2[2][8] = 4.29026412964;
}

//_______________________________________________________________________
inline void Read_muonMLPBNN::Transform_2( std::vector<double>& iv, int cls) const
{
   // Normalization transformation
   if (cls < 0 || cls > 2) {
   if (2 > 1 ) cls = 2;
      else cls = 2;
   }
   const int nVar = 9;

   // get indices of used variables

   // define the indices of the variables which are transformed by this transformation
   std::vector<int> indicesGet;
   std::vector<int> indicesPut;

   indicesGet.push_back( 0);
   indicesGet.push_back( 1);
   indicesGet.push_back( 2);
   indicesGet.push_back( 3);
   indicesGet.push_back( 4);
   indicesGet.push_back( 5);
   indicesGet.push_back( 6);
   indicesGet.push_back( 7);
   indicesGet.push_back( 8);
   indicesPut.push_back( 0);
   indicesPut.push_back( 1);
   indicesPut.push_back( 2);
   indicesPut.push_back( 3);
   indicesPut.push_back( 4);
   indicesPut.push_back( 5);
   indicesPut.push_back( 6);
   indicesPut.push_back( 7);
   indicesPut.push_back( 8);

   std::vector<double> dv(nVar);
   for (int ivar=0; ivar<nVar; ivar++) dv[ivar] = iv[indicesGet.at(ivar)];
   for (int ivar=0;ivar<9;ivar++) {
      double offset = fMin_2[cls][ivar];
      double scale  = 1.0/(fMax_2[cls][ivar]-fMin_2[cls][ivar]);
      iv[indicesPut.at(ivar)] = (dv[ivar]-offset)*scale * 2 - 1;
   }
}

//_______________________________________________________________________
inline void Read_muonMLPBNN::InitTransform()
{
   InitTransform_1();
   InitTransform_2();
}

//_______________________________________________________________________
inline void Read_muonMLPBNN::Transform( std::vector<double>& iv, int sigOrBgd ) const
{
   Transform_1( iv, sigOrBgd );
   Transform_2( iv, sigOrBgd );
}
