// Class: Read_vtxMLPBNN
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : MLP::_vtxMLPBNN
TMVA Release   : 4.1.0         [262400]
ROOT Release   : 5.29/01       [335105]
Creator        : vecchi
Date           : Wed May 22 14:44:50 2013
Host           : Linux lhcbwn1.fe.infn.it 2.6.18-238.5.1.el5 #1 SMP Tue Mar 1 18:58:43 EST 2011 x86_64 x86_64 x86_64 GNU/Linux
Dir            : /home/vecchi/NEWFTC_optcal_2012_sWeights/root_TMVA_forMoriond2013_XML_newPIDNN
Training events: 65251
Analysis type  : [Classification]


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
NCycles: "180" [Number of training cycles]
HiddenLayers: "N+5" [Specification of hidden layer architecture]
NeuronType: "tanh" [Neuron activation function type]
EstimatorType: "CE" [MSE (Mean Square Estimator) for Gaussian Likelihood or CE(Cross-Entropy) for Bernoulli Likelihood]
V: "False" [Verbose output (short form of "VerbosityLevel" below - overrides the latter one)]
VarTransform: "D,N" [List of variable transformations performed before training, e.g., "D_Background,P_Signal,G,N_AllClasses" for: "Decorrelation, PCA-transformation, Gaussianisation, Normalisation, each for the given class of events ('AllClasses' denotes all events of all classes, if no class indication is given, 'All' is assumed)"]
H: "True" [Print method-specific help message]
TrainingMethod: "BFGS" [Train with Back-Propagation (BP), BFGS Algorithm (BFGS), or Genetic Algorithm (GA - slower and worse)]
TestRate: "5" [Test for overtraining performed at each #th epochs]
UseRegulator: "True" [Use regulator to avoid over-training]
# Default:
RandomSeed: "1" [Random seed for initial synapse weights (0 means unique seed for each run; default value '1')]
NeuronInputType: "sum" [Neuron input function type]
VerbosityLevel: "Default" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs (signal and background)]
IgnoreNegWeightsInTraining: "False" [Events with negative weights are ignored in the training (but are included for testing and performance evaluation)]
LearningRate: "2.000000e-02" [ANN learning rate parameter]
DecayRate: "1.000000e-02" [Decay rate for learning parameter]
EpochMonitoring: "False" [Provide epoch-wise monitoring plots according to TestRate (caution: causes big ROOT output file!)]
Sampling: "1.000000e+00" [Only 'Sampling' (randomly selected) events are trained each epoch]
SamplingEpoch: "1.000000e+00" [Sampling is used for the first 'SamplingEpoch' epochs, afterwards, all events are taken for training]
SamplingImportance: "1.000000e+00" [ The sampling weights of events in epochs which successful (worse estimator than before) are multiplied with SamplingImportance, else they are divided.]
SamplingTraining: "True" [The training sample is sampled]
SamplingTesting: "False" [The testing sample is sampled]
ResetStep: "50" [How often BFGS should reset history]
Tau: "3.000000e+00" [LineSearch "size step"]
BPMode: "sequential" [Back-propagation learning mode: sequential or batch]
BatchSize: "-1" [Batch size: number of events/batch, only set if in Batch Mode, -1 for BatchSize=number_of_events]
ConvergenceImprove: "1.000000e-30" [Minimum improvement which counts as improvement (<0 means automatic convergence check is turned off)]
ConvergenceTests: "-1" [Number of steps (without improvement) required for convergence (<0 means automatic convergence check is turned off)]
UpdateLimit: "10000" [Maximum times of regulator update]
CalculateErrors: "False" [Calculates inverse Hessian matrix at the end of the training to be able to calculate the uncertainties of an MVA value]
WeightRange: "1.000000e+00" [Take the events for the estimator calculations from small deviations from the desired value to large deviations only over the weight range]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 12
mult                          mult                          mult                          mult                          I                                 'F'    [4,153]
nnkrec                        nnkrec                        nnkrec                        nnkrec                        I                                 'F'    [1,10]
ptB                           ptB                           ptB                           ptB                           F                                 'F'    [-4.58604240417,4.08077192307]
vflag                         vflag                         vflag                         vflag                         F                                 'F'    [2,16]
ptmean                        ptmean                        ptmean                        ptmean                        F                                 'F'    [-1.11490440369,2.05206084251]
ipsmean                       ipsmean                       ipsmean                       ipsmean                       F                                 'F'    [1.14409482479,5.08755588531]
vcharge                       vcharge                       vcharge                       vcharge                       F                                 'F'    [0.200022608042,1]
svm                           svm                           svm                           svm                           F                                 'F'    [-0.510807216167,3.50635480881]
svp                           svp                           svp                           svp                           F                                 'F'    [2.08272647858,6.25444173813]
BDphiDir                      BDphiDir                      BDphiDir                      BDphiDir                      F                                 'F'    [-3.14148402214,3.14154911041]
svtau                         svtau                         svtau                         svtau                         F                                 'F'    [-3.27444171906,2.84161376953]
docamax                       docamax                       docamax                       docamax                       F                                 'F'    [0,0.0999424010515]
NSpec 0


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() : fStatusIsClean( true ) {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;

   // returns classifier status
   bool IsStatusClean() const { return fStatusIsClean; }

 protected:

   bool fStatusIsClean;
};

#endif

class Read_vtxMLPBNN : public IClassifierReader {

 public:

   // constructor
   Read_vtxMLPBNN( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "Read_vtxMLPBNN" ),
        fNvars( 12 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "mult", "nnkrec", "ptB", "vflag", "ptmean", "ipsmean", "vcharge", "svm", "svp", "BDphiDir", "svtau", "docamax" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -1;
      fVmax[0] = 1;
      fVmin[1] = -1;
      fVmax[1] = 1;
      fVmin[2] = -1;
      fVmax[2] = 1;
      fVmin[3] = -1;
      fVmax[3] = 1;
      fVmin[4] = -1;
      fVmax[4] = 1;
      fVmin[5] = -1;
      fVmax[5] = 0.99999988079071;
      fVmin[6] = -1;
      fVmax[6] = 1;
      fVmin[7] = -1;
      fVmax[7] = 1;
      fVmin[8] = -1;
      fVmax[8] = 1;
      fVmin[9] = -1;
      fVmax[9] = 0.99999988079071;
      fVmin[10] = -1;
      fVmax[10] = 1;
      fVmin[11] = -1;
      fVmax[11] = 1;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';
      fType[4] = 'F';
      fType[5] = 'F';
      fType[6] = 'F';
      fType[7] = 'F';
      fType[8] = 'F';
      fType[9] = 'F';
      fType[10] = 'F';
      fType[11] = 'F';

      // initialize constants
      Initialize();

      // initialize transformation
      InitTransform();
   }

   // destructor
   virtual ~Read_vtxMLPBNN() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // input variable transformation

   double fDecTF_1[3][12][12];

   double fMin_2[3][12];
   double fMax_2[3][12];
   void InitTransform_1();
   void Transform_1( std::vector<double> & iv, int sigOrBgd ) const;
   void InitTransform_2();
   void Transform_2( std::vector<double> & iv, int sigOrBgd ) const;
   void InitTransform();
   void Transform( std::vector<double> & iv, int sigOrBgd ) const;

   // common member variables
   const char* fClassName;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[12];
   double fVmax[12];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[12];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)

   double ActivationFnc(double x) const;
   double OutputActivationFnc(double x) const;

   int fLayers;
   int fLayerSize[3];
   double fWeightMatrix0to1[18][13];   // weight matrix from layer 0 to 1
   double fWeightMatrix1to2[1][18];   // weight matrix from layer 1 to 2

   double * fWeights[3];
};

inline void Read_vtxMLPBNN::Initialize()
{
   // build network structure
   fLayers = 3;
   fLayerSize[0] = 13; fWeights[0] = new double[13]; 
   fLayerSize[1] = 18; fWeights[1] = new double[18]; 
   fLayerSize[2] = 1; fWeights[2] = new double[1]; 
   // weight matrix from layer 0 to 1
   fWeightMatrix0to1[0][0] = -0.56691576208685;
   fWeightMatrix0to1[1][0] = 2.49220596288466;
   fWeightMatrix0to1[2][0] = 0.994316876484853;
   fWeightMatrix0to1[3][0] = 0.549309080822612;
   fWeightMatrix0to1[4][0] = -2.33637945513594;
   fWeightMatrix0to1[5][0] = -1.75732550916771;
   fWeightMatrix0to1[6][0] = -0.351939861271946;
   fWeightMatrix0to1[7][0] = 2.25260561094711;
   fWeightMatrix0to1[8][0] = -1.02715255232767;
   fWeightMatrix0to1[9][0] = -1.19908766955258;
   fWeightMatrix0to1[10][0] = -1.49280611604031;
   fWeightMatrix0to1[11][0] = 0.247618261645051;
   fWeightMatrix0to1[12][0] = -1.19512989867063;
   fWeightMatrix0to1[13][0] = 0.291896157097914;
   fWeightMatrix0to1[14][0] = -0.79370655651178;
   fWeightMatrix0to1[15][0] = 0.907244141509688;
   fWeightMatrix0to1[16][0] = -0.522715776936272;
   fWeightMatrix0to1[0][1] = 1.31431697523664;
   fWeightMatrix0to1[1][1] = 0.814428375034111;
   fWeightMatrix0to1[2][1] = 1.25770864200811;
   fWeightMatrix0to1[3][1] = -0.801084837811437;
   fWeightMatrix0to1[4][1] = -1.04762018554613;
   fWeightMatrix0to1[5][1] = 0.344022608733234;
   fWeightMatrix0to1[6][1] = 0.219187300990934;
   fWeightMatrix0to1[7][1] = -0.303159710584248;
   fWeightMatrix0to1[8][1] = -0.00205089781434912;
   fWeightMatrix0to1[9][1] = 1.17293488140989;
   fWeightMatrix0to1[10][1] = -1.01911450831446;
   fWeightMatrix0to1[11][1] = -1.54562657455315;
   fWeightMatrix0to1[12][1] = 0.34280957060178;
   fWeightMatrix0to1[13][1] = 1.18451870170319;
   fWeightMatrix0to1[14][1] = 1.51153726646857;
   fWeightMatrix0to1[15][1] = 0.382439457412062;
   fWeightMatrix0to1[16][1] = 0.240263308293082;
   fWeightMatrix0to1[0][2] = 0.18670060940589;
   fWeightMatrix0to1[1][2] = -0.822205217210585;
   fWeightMatrix0to1[2][2] = -1.37024843050186;
   fWeightMatrix0to1[3][2] = 1.73571880028101;
   fWeightMatrix0to1[4][2] = -1.25861742913963;
   fWeightMatrix0to1[5][2] = 1.34824548668968;
   fWeightMatrix0to1[6][2] = 0.939208691983986;
   fWeightMatrix0to1[7][2] = 0.109351081383526;
   fWeightMatrix0to1[8][2] = 1.64433070523631;
   fWeightMatrix0to1[9][2] = 1.27630863136858;
   fWeightMatrix0to1[10][2] = -0.479052481214376;
   fWeightMatrix0to1[11][2] = -0.793422329406781;
   fWeightMatrix0to1[12][2] = 0.90165036637702;
   fWeightMatrix0to1[13][2] = -0.545532667070106;
   fWeightMatrix0to1[14][2] = 1.98090524064294;
   fWeightMatrix0to1[15][2] = 0.778714205407421;
   fWeightMatrix0to1[16][2] = 1.72975790298337;
   fWeightMatrix0to1[0][3] = 1.22743992108375;
   fWeightMatrix0to1[1][3] = -1.36437541130429;
   fWeightMatrix0to1[2][3] = 1.45230493224694;
   fWeightMatrix0to1[3][3] = -2.52216292425673;
   fWeightMatrix0to1[4][3] = -0.907629422723945;
   fWeightMatrix0to1[5][3] = -0.288279166885066;
   fWeightMatrix0to1[6][3] = -1.20397520598704;
   fWeightMatrix0to1[7][3] = 2.08723198327814;
   fWeightMatrix0to1[8][3] = 0.519921298328284;
   fWeightMatrix0to1[9][3] = -1.70742670498492;
   fWeightMatrix0to1[10][3] = 0.65978541798572;
   fWeightMatrix0to1[11][3] = -0.617842762618056;
   fWeightMatrix0to1[12][3] = 0.628031976483347;
   fWeightMatrix0to1[13][3] = 2.15353571342003;
   fWeightMatrix0to1[14][3] = -0.657759502375125;
   fWeightMatrix0to1[15][3] = -0.704690039890871;
   fWeightMatrix0to1[16][3] = -1.31921214066543;
   fWeightMatrix0to1[0][4] = 0.510443900003733;
   fWeightMatrix0to1[1][4] = -0.184535886462383;
   fWeightMatrix0to1[2][4] = -0.526302557939007;
   fWeightMatrix0to1[3][4] = -1.26463294174788;
   fWeightMatrix0to1[4][4] = 0.807564478825804;
   fWeightMatrix0to1[5][4] = 1.08701502082089;
   fWeightMatrix0to1[6][4] = 1.30116206741002;
   fWeightMatrix0to1[7][4] = 0.281120099927685;
   fWeightMatrix0to1[8][4] = -1.71719874068678;
   fWeightMatrix0to1[9][4] = -1.84895050226395;
   fWeightMatrix0to1[10][4] = 0.209704524411256;
   fWeightMatrix0to1[11][4] = 0.776626864201647;
   fWeightMatrix0to1[12][4] = 1.75669571679683;
   fWeightMatrix0to1[13][4] = 0.662931181849155;
   fWeightMatrix0to1[14][4] = 0.304026693838452;
   fWeightMatrix0to1[15][4] = -0.638022678307505;
   fWeightMatrix0to1[16][4] = -1.37041513901442;
   fWeightMatrix0to1[0][5] = -0.175892910366965;
   fWeightMatrix0to1[1][5] = 0.747808518800665;
   fWeightMatrix0to1[2][5] = -0.88684345956437;
   fWeightMatrix0to1[3][5] = -1.11234745937153;
   fWeightMatrix0to1[4][5] = -1.70191912083136;
   fWeightMatrix0to1[5][5] = -0.396511225683398;
   fWeightMatrix0to1[6][5] = -0.147048655009519;
   fWeightMatrix0to1[7][5] = 1.28357713380609;
   fWeightMatrix0to1[8][5] = -1.10509845405634;
   fWeightMatrix0to1[9][5] = -0.80560859306759;
   fWeightMatrix0to1[10][5] = 1.49956677491833;
   fWeightMatrix0to1[11][5] = -1.11316456438892;
   fWeightMatrix0to1[12][5] = -0.752636459999209;
   fWeightMatrix0to1[13][5] = -0.831288166267714;
   fWeightMatrix0to1[14][5] = 0.113288228143996;
   fWeightMatrix0to1[15][5] = -2.16450071094424;
   fWeightMatrix0to1[16][5] = -1.8562419317773;
   fWeightMatrix0to1[0][6] = 0.723561802560006;
   fWeightMatrix0to1[1][6] = 1.43975683746627;
   fWeightMatrix0to1[2][6] = -0.804064891130463;
   fWeightMatrix0to1[3][6] = 0.895386625244176;
   fWeightMatrix0to1[4][6] = 0.00455356409722069;
   fWeightMatrix0to1[5][6] = -0.870299441801119;
   fWeightMatrix0to1[6][6] = 0.982154475223781;
   fWeightMatrix0to1[7][6] = 0.495643963226953;
   fWeightMatrix0to1[8][6] = -1.93413065077996;
   fWeightMatrix0to1[9][6] = 0.134628246002467;
   fWeightMatrix0to1[10][6] = -0.483063940511809;
   fWeightMatrix0to1[11][6] = 0.17640563449802;
   fWeightMatrix0to1[12][6] = -0.857124780596875;
   fWeightMatrix0to1[13][6] = 1.2542337486708;
   fWeightMatrix0to1[14][6] = -0.243799697946788;
   fWeightMatrix0to1[15][6] = 0.0288846219045982;
   fWeightMatrix0to1[16][6] = 0.890769353265156;
   fWeightMatrix0to1[0][7] = -0.86986545182479;
   fWeightMatrix0to1[1][7] = -1.53581199323746;
   fWeightMatrix0to1[2][7] = 0.122595914527572;
   fWeightMatrix0to1[3][7] = -0.026938560777919;
   fWeightMatrix0to1[4][7] = 1.48899069460882;
   fWeightMatrix0to1[5][7] = 0.201682751179844;
   fWeightMatrix0to1[6][7] = -0.836166050483327;
   fWeightMatrix0to1[7][7] = 0.0989253426223331;
   fWeightMatrix0to1[8][7] = -0.312250123348044;
   fWeightMatrix0to1[9][7] = -1.63117081687832;
   fWeightMatrix0to1[10][7] = 0.728202329098772;
   fWeightMatrix0to1[11][7] = -0.378431400933374;
   fWeightMatrix0to1[12][7] = -2.24065515424233;
   fWeightMatrix0to1[13][7] = 0.437301383597534;
   fWeightMatrix0to1[14][7] = -1.32506344882385;
   fWeightMatrix0to1[15][7] = 0.444524622740606;
   fWeightMatrix0to1[16][7] = 1.79834800233612;
   fWeightMatrix0to1[0][8] = 1.70916060876316;
   fWeightMatrix0to1[1][8] = -1.05923069774767;
   fWeightMatrix0to1[2][8] = 0.262445358443083;
   fWeightMatrix0to1[3][8] = 0.952208180070474;
   fWeightMatrix0to1[4][8] = 1.22106712510696;
   fWeightMatrix0to1[5][8] = 0.642338286322168;
   fWeightMatrix0to1[6][8] = -1.10360388764396;
   fWeightMatrix0to1[7][8] = -0.0248055890665636;
   fWeightMatrix0to1[8][8] = -1.16639064699063;
   fWeightMatrix0to1[9][8] = 1.13764982481754;
   fWeightMatrix0to1[10][8] = 1.19957910744273;
   fWeightMatrix0to1[11][8] = -1.03990510492164;
   fWeightMatrix0to1[12][8] = -0.811052382406599;
   fWeightMatrix0to1[13][8] = 0.224589344829138;
   fWeightMatrix0to1[14][8] = -1.33173267276772;
   fWeightMatrix0to1[15][8] = 0.438269618248316;
   fWeightMatrix0to1[16][8] = 0.617310329484675;
   fWeightMatrix0to1[0][9] = -0.34272223212851;
   fWeightMatrix0to1[1][9] = -0.444503565867984;
   fWeightMatrix0to1[2][9] = 0.124869760433105;
   fWeightMatrix0to1[3][9] = 0.761950275345433;
   fWeightMatrix0to1[4][9] = 0.512670011737721;
   fWeightMatrix0to1[5][9] = 0.99999590023626;
   fWeightMatrix0to1[6][9] = -1.7936486160189;
   fWeightMatrix0to1[7][9] = 1.35672532740789;
   fWeightMatrix0to1[8][9] = 0.758308194054102;
   fWeightMatrix0to1[9][9] = 0.438075149551906;
   fWeightMatrix0to1[10][9] = 0.201049644691516;
   fWeightMatrix0to1[11][9] = 0.62093458108021;
   fWeightMatrix0to1[12][9] = 0.248668358914676;
   fWeightMatrix0to1[13][9] = -0.459583815187771;
   fWeightMatrix0to1[14][9] = 0.463693912110601;
   fWeightMatrix0to1[15][9] = -1.09975715275492;
   fWeightMatrix0to1[16][9] = -0.789385842436162;
   fWeightMatrix0to1[0][10] = 1.42817503949012;
   fWeightMatrix0to1[1][10] = 0.660060318165424;
   fWeightMatrix0to1[2][10] = -0.476368463974427;
   fWeightMatrix0to1[3][10] = 1.95966403188273;
   fWeightMatrix0to1[4][10] = 1.54975196037782;
   fWeightMatrix0to1[5][10] = -2.15925538026126;
   fWeightMatrix0to1[6][10] = 0.294025472512968;
   fWeightMatrix0to1[7][10] = -0.320968546122526;
   fWeightMatrix0to1[8][10] = 0.377237650413668;
   fWeightMatrix0to1[9][10] = -1.33481902417872;
   fWeightMatrix0to1[10][10] = -1.6869981913412;
   fWeightMatrix0to1[11][10] = 0.369759054740179;
   fWeightMatrix0to1[12][10] = 1.75505442707516;
   fWeightMatrix0to1[13][10] = -1.783695575612;
   fWeightMatrix0to1[14][10] = -0.415662224572193;
   fWeightMatrix0to1[15][10] = 0.00755881657130136;
   fWeightMatrix0to1[16][10] = -0.0824781452184513;
   fWeightMatrix0to1[0][11] = 1.59527524539676;
   fWeightMatrix0to1[1][11] = -0.439403006259923;
   fWeightMatrix0to1[2][11] = -0.512573827050789;
   fWeightMatrix0to1[3][11] = -0.713017554395169;
   fWeightMatrix0to1[4][11] = 1.02410456001412;
   fWeightMatrix0to1[5][11] = 0.83627910809802;
   fWeightMatrix0to1[6][11] = 0.872209720560965;
   fWeightMatrix0to1[7][11] = -0.154912423638663;
   fWeightMatrix0to1[8][11] = -0.562463466109013;
   fWeightMatrix0to1[9][11] = -1.91030690625538;
   fWeightMatrix0to1[10][11] = 1.01210303619974;
   fWeightMatrix0to1[11][11] = 0.334703292048424;
   fWeightMatrix0to1[12][11] = -1.45492529888259;
   fWeightMatrix0to1[13][11] = -0.608480211772018;
   fWeightMatrix0to1[14][11] = 0.332943654687836;
   fWeightMatrix0to1[15][11] = 0.670711875773692;
   fWeightMatrix0to1[16][11] = -0.416834973459506;
   fWeightMatrix0to1[0][12] = 1.64512542561124;
   fWeightMatrix0to1[1][12] = -0.0831372483004573;
   fWeightMatrix0to1[2][12] = -0.994244886905172;
   fWeightMatrix0to1[3][12] = 1.62018090281788;
   fWeightMatrix0to1[4][12] = 1.32345121453231;
   fWeightMatrix0to1[5][12] = 1.43451497805654;
   fWeightMatrix0to1[6][12] = 0.108123611029388;
   fWeightMatrix0to1[7][12] = -1.15614723417431;
   fWeightMatrix0to1[8][12] = -1.99745285367971;
   fWeightMatrix0to1[9][12] = -0.454859656843041;
   fWeightMatrix0to1[10][12] = 1.59140428201623;
   fWeightMatrix0to1[11][12] = 1.21575169578427;
   fWeightMatrix0to1[12][12] = 0.349675471101789;
   fWeightMatrix0to1[13][12] = -1.11256731527703;
   fWeightMatrix0to1[14][12] = 2.09379546607391;
   fWeightMatrix0to1[15][12] = -0.690966977855985;
   fWeightMatrix0to1[16][12] = -1.09873767296827;
   // weight matrix from layer 1 to 2
   fWeightMatrix1to2[0][0] = 0.0999530039117194;
   fWeightMatrix1to2[0][1] = -0.0938763752466102;
   fWeightMatrix1to2[0][2] = 0.0456066538633924;
   fWeightMatrix1to2[0][3] = 0.522497443485337;
   fWeightMatrix1to2[0][4] = -0.659844437519558;
   fWeightMatrix1to2[0][5] = 0.482742934370457;
   fWeightMatrix1to2[0][6] = 0.20448358887934;
   fWeightMatrix1to2[0][7] = -1.09153324872411;
   fWeightMatrix1to2[0][8] = -0.233854156809696;
   fWeightMatrix1to2[0][9] = -0.0114750951941354;
   fWeightMatrix1to2[0][10] = 0.271024039013707;
   fWeightMatrix1to2[0][11] = 0.614527443662565;
   fWeightMatrix1to2[0][12] = 0.256285548083592;
   fWeightMatrix1to2[0][13] = 0.289552511933529;
   fWeightMatrix1to2[0][14] = -1.22116451403738;
   fWeightMatrix1to2[0][15] = -0.411614959975326;
   fWeightMatrix1to2[0][16] = 0.414462496736696;
   fWeightMatrix1to2[0][17] = -0.974060488914361;
}

inline double Read_vtxMLPBNN::GetMvaValue__( const std::vector<double>& inputValues ) const
{
   if (inputValues.size() != (unsigned int)fLayerSize[0]-1) {
      std::cout << "Input vector needs to be of size " << fLayerSize[0]-1 << std::endl;
      return 0;
   }

   for (int l=0; l<fLayers; l++)
      for (int i=0; i<fLayerSize[l]; i++) fWeights[l][i]=0;

   for (int l=0; l<fLayers-1; l++)
      fWeights[l][fLayerSize[l]-1]=1;

   for (int i=0; i<fLayerSize[0]-1; i++)
      fWeights[0][i]=inputValues[i];

   // layer 0 to 1
   for (int o=0; o<fLayerSize[1]-1; o++) {
      for (int i=0; i<fLayerSize[0]; i++) {
         double inputVal = fWeightMatrix0to1[o][i] * fWeights[0][i];
         fWeights[1][o] += inputVal;
      }
      fWeights[1][o] = ActivationFnc(fWeights[1][o]);
   }
   // layer 1 to 2
   for (int o=0; o<fLayerSize[2]; o++) {
      for (int i=0; i<fLayerSize[1]; i++) {
         double inputVal = fWeightMatrix1to2[o][i] * fWeights[1][i];
         fWeights[2][o] += inputVal;
      }
      fWeights[2][o] = OutputActivationFnc(fWeights[2][o]);
   }

   return fWeights[2][0];
}

double Read_vtxMLPBNN::ActivationFnc(double x) const {
   // hyperbolic tan
   return tanh(x);
}
double Read_vtxMLPBNN::OutputActivationFnc(double x) const {
   // sigmoid
   return 1.0/(1.0+exp(-x));
}
   
// Clean up
inline void Read_vtxMLPBNN::Clear() 
{
   // nothing to clear
}
   inline double Read_vtxMLPBNN::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!IsStatusClean()) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            Transform( iV, -1 );
            retval = GetMvaValue__( iV );
         }
         else {
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(*varIt);
            }
            Transform( iV, -1 );
            retval = GetMvaValue__( iV );
         }
      }

      return retval;
   }

//_______________________________________________________________________
inline void Read_vtxMLPBNN::InitTransform_1()
{
   // Decorrelation transformation, initialisation
   fDecTF_1[0][0][0] = 0.0819756499617;
   fDecTF_1[0][0][1] = -0.00670796522698;
   fDecTF_1[0][0][2] = -0.00490910840004;
   fDecTF_1[0][0][3] = -0.0143613014102;
   fDecTF_1[0][0][4] = 0.00262557392131;
   fDecTF_1[0][0][5] = 0.00751621536232;
   fDecTF_1[0][0][6] = -0.00133080084998;
   fDecTF_1[0][0][7] = -0.00804494099124;
   fDecTF_1[0][0][8] = -0.00507804872527;
   fDecTF_1[0][0][9] = -0.000412791030216;
   fDecTF_1[0][0][10] = 0.00685833372733;
   fDecTF_1[0][0][11] = -0.00644675679578;
   fDecTF_1[0][1][0] = -0.00670796522698;
   fDecTF_1[0][1][1] = 0.944286216288;
   fDecTF_1[0][1][2] = 0.0103340234539;
   fDecTF_1[0][1][3] = 0.0100444117691;
   fDecTF_1[0][1][4] = 0.0272282104373;
   fDecTF_1[0][1][5] = -0.037646995867;
   fDecTF_1[0][1][6] = -0.0202010228251;
   fDecTF_1[0][1][7] = -0.0260804032028;
   fDecTF_1[0][1][8] = -0.0119346753903;
   fDecTF_1[0][1][9] = -0.000939951200957;
   fDecTF_1[0][1][10] = 0.00491580765297;
   fDecTF_1[0][1][11] = -0.032156102595;
   fDecTF_1[0][2][0] = -0.00490910840004;
   fDecTF_1[0][2][1] = 0.0103340234539;
   fDecTF_1[0][2][2] = 1.37488651466;
   fDecTF_1[0][2][3] = -0.0285944065763;
   fDecTF_1[0][2][4] = -0.135111431117;
   fDecTF_1[0][2][5] = -9.91167929411e-05;
   fDecTF_1[0][2][6] = 0.00111212239049;
   fDecTF_1[0][2][7] = 0.0593827456622;
   fDecTF_1[0][2][8] = -0.00716369499943;
   fDecTF_1[0][2][9] = -0.00977442822132;
   fDecTF_1[0][2][10] = -0.00185399377948;
   fDecTF_1[0][2][11] = -0.0155674465712;
   fDecTF_1[0][3][0] = -0.0143613014102;
   fDecTF_1[0][3][1] = 0.0100444117691;
   fDecTF_1[0][3][2] = -0.0285944065763;
   fDecTF_1[0][3][3] = 1.03946136414;
   fDecTF_1[0][3][4] = 0.426835290253;
   fDecTF_1[0][3][5] = 0.0307582118582;
   fDecTF_1[0][3][6] = 0.239066390284;
   fDecTF_1[0][3][7] = -0.410051921267;
   fDecTF_1[0][3][8] = -0.156951524788;
   fDecTF_1[0][3][9] = -0.000828818272236;
   fDecTF_1[0][3][10] = -0.073732717004;
   fDecTF_1[0][3][11] = -0.3188621781;
   fDecTF_1[0][4][0] = 0.00262557392131;
   fDecTF_1[0][4][1] = 0.0272282104373;
   fDecTF_1[0][4][2] = -0.135111431117;
   fDecTF_1[0][4][3] = 0.426835290253;
   fDecTF_1[0][4][4] = 2.97960884865;
   fDecTF_1[0][4][5] = -0.463815710779;
   fDecTF_1[0][4][6] = -0.0251332044242;
   fDecTF_1[0][4][7] = -0.185988567238;
   fDecTF_1[0][4][8] = -0.394095133994;
   fDecTF_1[0][4][9] = 0.00271913768018;
   fDecTF_1[0][4][10] = 0.253118679246;
   fDecTF_1[0][4][11] = 0.681745877796;
   fDecTF_1[0][5][0] = 0.00751621536232;
   fDecTF_1[0][5][1] = -0.037646995867;
   fDecTF_1[0][5][2] = -9.91167929411e-05;
   fDecTF_1[0][5][3] = 0.0307582118582;
   fDecTF_1[0][5][4] = -0.463815710779;
   fDecTF_1[0][5][5] = 2.10237338627;
   fDecTF_1[0][5][6] = 0.0447144072344;
   fDecTF_1[0][5][7] = -0.0682919703349;
   fDecTF_1[0][5][8] = -0.00349581681511;
   fDecTF_1[0][5][9] = 0.00670207031117;
   fDecTF_1[0][5][10] = -0.911635337583;
   fDecTF_1[0][5][11] = 0.125259902859;
   fDecTF_1[0][6][0] = -0.00133080084998;
   fDecTF_1[0][6][1] = -0.0202010228251;
   fDecTF_1[0][6][2] = 0.00111212239049;
   fDecTF_1[0][6][3] = 0.239066390284;
   fDecTF_1[0][6][4] = -0.0251332044242;
   fDecTF_1[0][6][5] = 0.0447144072344;
   fDecTF_1[0][6][6] = 4.01935005585;
   fDecTF_1[0][6][7] = -0.110248276264;
   fDecTF_1[0][6][8] = 0.00763124030296;
   fDecTF_1[0][6][9] = -0.00773174372191;
   fDecTF_1[0][6][10] = 0.0512338699315;
   fDecTF_1[0][6][11] = 0.0148323152827;
   fDecTF_1[0][7][0] = -0.00804494099124;
   fDecTF_1[0][7][1] = -0.0260804032028;
   fDecTF_1[0][7][2] = 0.0593827456622;
   fDecTF_1[0][7][3] = -0.410051921267;
   fDecTF_1[0][7][4] = -0.185988567238;
   fDecTF_1[0][7][5] = -0.0682919703349;
   fDecTF_1[0][7][6] = -0.110248276264;
   fDecTF_1[0][7][7] = 2.2739412927;
   fDecTF_1[0][7][8] = -0.201079877619;
   fDecTF_1[0][7][9] = 0.00269062133683;
   fDecTF_1[0][7][10] = 0.195148991101;
   fDecTF_1[0][7][11] = -0.402113984893;
   fDecTF_1[0][8][0] = -0.00507804872527;
   fDecTF_1[0][8][1] = -0.0119346753903;
   fDecTF_1[0][8][2] = -0.00716369499943;
   fDecTF_1[0][8][3] = -0.156951524788;
   fDecTF_1[0][8][4] = -0.394095133994;
   fDecTF_1[0][8][5] = -0.00349581681511;
   fDecTF_1[0][8][6] = 0.00763124030296;
   fDecTF_1[0][8][7] = -0.201079877619;
   fDecTF_1[0][8][8] = 1.73274035534;
   fDecTF_1[0][8][9] = -0.00130047592974;
   fDecTF_1[0][8][10] = 0.149332605484;
   fDecTF_1[0][8][11] = -0.055818275392;
   fDecTF_1[0][9][0] = -0.000412791030216;
   fDecTF_1[0][9][1] = -0.000939951200957;
   fDecTF_1[0][9][2] = -0.00977442822132;
   fDecTF_1[0][9][3] = -0.000828818272236;
   fDecTF_1[0][9][4] = 0.00271913768018;
   fDecTF_1[0][9][5] = 0.00670207031117;
   fDecTF_1[0][9][6] = -0.00773174372191;
   fDecTF_1[0][9][7] = 0.00269062133683;
   fDecTF_1[0][9][8] = -0.00130047592974;
   fDecTF_1[0][9][9] = 1.16762508409;
   fDecTF_1[0][9][10] = -0.00224882049383;
   fDecTF_1[0][9][11] = 0.003845765876;
   fDecTF_1[0][10][0] = 0.00685833372733;
   fDecTF_1[0][10][1] = 0.00491580765297;
   fDecTF_1[0][10][2] = -0.00185399377948;
   fDecTF_1[0][10][3] = -0.073732717004;
   fDecTF_1[0][10][4] = 0.253118679246;
   fDecTF_1[0][10][5] = -0.911635337583;
   fDecTF_1[0][10][6] = 0.0512338699315;
   fDecTF_1[0][10][7] = 0.195148991101;
   fDecTF_1[0][10][8] = 0.149332605484;
   fDecTF_1[0][10][9] = -0.00224882049383;
   fDecTF_1[0][10][10] = 2.03705031594;
   fDecTF_1[0][10][11] = 0.0831957248809;
   fDecTF_1[0][11][0] = -0.00644675679578;
   fDecTF_1[0][11][1] = -0.032156102595;
   fDecTF_1[0][11][2] = -0.0155674465712;
   fDecTF_1[0][11][3] = -0.3188621781;
   fDecTF_1[0][11][4] = 0.681745877796;
   fDecTF_1[0][11][5] = 0.125259902859;
   fDecTF_1[0][11][6] = 0.0148323152827;
   fDecTF_1[0][11][7] = -0.402113984893;
   fDecTF_1[0][11][8] = -0.055818275392;
   fDecTF_1[0][11][9] = 0.003845765876;
   fDecTF_1[0][11][10] = 0.0831957248809;
   fDecTF_1[0][11][11] = 56.0061329093;
   fDecTF_1[1][0][0] = 0.0805346605859;
   fDecTF_1[1][0][1] = -0.00769226806866;
   fDecTF_1[1][0][2] = -0.00274694838711;
   fDecTF_1[1][0][3] = -0.0140521965358;
   fDecTF_1[1][0][4] = 0.00189363423155;
   fDecTF_1[1][0][5] = 0.00814628146396;
   fDecTF_1[1][0][6] = -0.003021666985;
   fDecTF_1[1][0][7] = -0.00742416173299;
   fDecTF_1[1][0][8] = -0.00279713534655;
   fDecTF_1[1][0][9] = -0.000644450996954;
   fDecTF_1[1][0][10] = 0.00494525946651;
   fDecTF_1[1][0][11] = -0.00542558482562;
   fDecTF_1[1][1][0] = -0.00769226806866;
   fDecTF_1[1][1][1] = 0.925049911308;
   fDecTF_1[1][1][2] = 0.00308699955643;
   fDecTF_1[1][1][3] = 0.00446790374474;
   fDecTF_1[1][1][4] = 0.0231574960389;
   fDecTF_1[1][1][5] = -0.0480927906694;
   fDecTF_1[1][1][6] = -0.0197001106421;
   fDecTF_1[1][1][7] = -0.0271248138189;
   fDecTF_1[1][1][8] = -0.0206271312211;
   fDecTF_1[1][1][9] = 0.00357824835017;
   fDecTF_1[1][1][10] = 0.00590726002683;
   fDecTF_1[1][1][11] = -0.0227428008751;
   fDecTF_1[1][2][0] = -0.00274694838711;
   fDecTF_1[1][2][1] = 0.00308699955643;
   fDecTF_1[1][2][2] = 1.38144549024;
   fDecTF_1[1][2][3] = -0.0165856213069;
   fDecTF_1[1][2][4] = -0.128802378081;
   fDecTF_1[1][2][5] = 0.0130448690457;
   fDecTF_1[1][2][6] = 0.000646244255219;
   fDecTF_1[1][2][7] = 0.0524265570775;
   fDecTF_1[1][2][8] = -0.018801771776;
   fDecTF_1[1][2][9] = -0.00518600824739;
   fDecTF_1[1][2][10] = -0.00188735794334;
   fDecTF_1[1][2][11] = 0.00172073532791;
   fDecTF_1[1][3][0] = -0.0140521965358;
   fDecTF_1[1][3][1] = 0.00446790374474;
   fDecTF_1[1][3][2] = -0.0165856213069;
   fDecTF_1[1][3][3] = 1.04789074566;
   fDecTF_1[1][3][4] = 0.438758007934;
   fDecTF_1[1][3][5] = 0.02240847336;
   fDecTF_1[1][3][6] = 0.23226322607;
   fDecTF_1[1][3][7] = -0.406983208423;
   fDecTF_1[1][3][8] = -0.153615538745;
   fDecTF_1[1][3][9] = -0.00308417262021;
   fDecTF_1[1][3][10] = -0.060293616684;
   fDecTF_1[1][3][11] = -0.333634905915;
   fDecTF_1[1][4][0] = 0.00189363423155;
   fDecTF_1[1][4][1] = 0.0231574960389;
   fDecTF_1[1][4][2] = -0.128802378081;
   fDecTF_1[1][4][3] = 0.438758007934;
   fDecTF_1[1][4][4] = 3.07768339913;
   fDecTF_1[1][4][5] = -0.430184394113;
   fDecTF_1[1][4][6] = 0.00943637312199;
   fDecTF_1[1][4][7] = -0.17432626846;
   fDecTF_1[1][4][8] = -0.347561239655;
   fDecTF_1[1][4][9] = -0.0166678818399;
   fDecTF_1[1][4][10] = 0.214706443495;
   fDecTF_1[1][4][11] = 0.684204008523;
   fDecTF_1[1][5][0] = 0.00814628146396;
   fDecTF_1[1][5][1] = -0.0480927906694;
   fDecTF_1[1][5][2] = 0.0130448690457;
   fDecTF_1[1][5][3] = 0.02240847336;
   fDecTF_1[1][5][4] = -0.430184394113;
   fDecTF_1[1][5][5] = 2.02709885246;
   fDecTF_1[1][5][6] = 0.06601596121;
   fDecTF_1[1][5][7] = -0.0450589636621;
   fDecTF_1[1][5][8] = -0.0253543695844;
   fDecTF_1[1][5][9] = 0.0116124483399;
   fDecTF_1[1][5][10] = -0.836971828274;
   fDecTF_1[1][5][11] = 0.0906891707146;
   fDecTF_1[1][6][0] = -0.003021666985;
   fDecTF_1[1][6][1] = -0.0197001106421;
   fDecTF_1[1][6][2] = 0.000646244255219;
   fDecTF_1[1][6][3] = 0.23226322607;
   fDecTF_1[1][6][4] = 0.00943637312199;
   fDecTF_1[1][6][5] = 0.06601596121;
   fDecTF_1[1][6][6] = 4.085003018;
   fDecTF_1[1][6][7] = -0.119579556235;
   fDecTF_1[1][6][8] = 0.0134977064369;
   fDecTF_1[1][6][9] = 0.0110691493343;
   fDecTF_1[1][6][10] = 0.0294395376979;
   fDecTF_1[1][6][11] = -0.0167337302868;
   fDecTF_1[1][7][0] = -0.00742416173299;
   fDecTF_1[1][7][1] = -0.0271248138189;
   fDecTF_1[1][7][2] = 0.0524265570775;
   fDecTF_1[1][7][3] = -0.406983208423;
   fDecTF_1[1][7][4] = -0.17432626846;
   fDecTF_1[1][7][5] = -0.0450589636621;
   fDecTF_1[1][7][6] = -0.119579556235;
   fDecTF_1[1][7][7] = 2.25790133823;
   fDecTF_1[1][7][8] = -0.224809226954;
   fDecTF_1[1][7][9] = -0.00120183268972;
   fDecTF_1[1][7][10] = 0.197274747839;
   fDecTF_1[1][7][11] = -0.380700962985;
   fDecTF_1[1][8][0] = -0.00279713534655;
   fDecTF_1[1][8][1] = -0.0206271312211;
   fDecTF_1[1][8][2] = -0.018801771776;
   fDecTF_1[1][8][3] = -0.153615538745;
   fDecTF_1[1][8][4] = -0.347561239655;
   fDecTF_1[1][8][5] = -0.0253543695844;
   fDecTF_1[1][8][6] = 0.0134977064369;
   fDecTF_1[1][8][7] = -0.224809226954;
   fDecTF_1[1][8][8] = 1.7449877649;
   fDecTF_1[1][8][9] = 0.00644457393542;
   fDecTF_1[1][8][10] = 0.174924105737;
   fDecTF_1[1][8][11] = -0.0722241622938;
   fDecTF_1[1][9][0] = -0.000644450996954;
   fDecTF_1[1][9][1] = 0.00357824835017;
   fDecTF_1[1][9][2] = -0.00518600824739;
   fDecTF_1[1][9][3] = -0.00308417262021;
   fDecTF_1[1][9][4] = -0.0166678818399;
   fDecTF_1[1][9][5] = 0.0116124483399;
   fDecTF_1[1][9][6] = 0.0110691493343;
   fDecTF_1[1][9][7] = -0.00120183268972;
   fDecTF_1[1][9][8] = 0.00644457393542;
   fDecTF_1[1][9][9] = 1.06653144671;
   fDecTF_1[1][9][10] = -0.0149544754582;
   fDecTF_1[1][9][11] = 0.00450134823249;
   fDecTF_1[1][10][0] = 0.00494525946651;
   fDecTF_1[1][10][1] = 0.00590726002683;
   fDecTF_1[1][10][2] = -0.00188735794334;
   fDecTF_1[1][10][3] = -0.060293616684;
   fDecTF_1[1][10][4] = 0.214706443495;
   fDecTF_1[1][10][5] = -0.836971828274;
   fDecTF_1[1][10][6] = 0.0294395376979;
   fDecTF_1[1][10][7] = 0.197274747839;
   fDecTF_1[1][10][8] = 0.174924105737;
   fDecTF_1[1][10][9] = -0.0149544754582;
   fDecTF_1[1][10][10] = 1.95947008774;
   fDecTF_1[1][10][11] = 0.100008705228;
   fDecTF_1[1][11][0] = -0.00542558482562;
   fDecTF_1[1][11][1] = -0.0227428008751;
   fDecTF_1[1][11][2] = 0.00172073532791;
   fDecTF_1[1][11][3] = -0.333634905915;
   fDecTF_1[1][11][4] = 0.684204008523;
   fDecTF_1[1][11][5] = 0.0906891707146;
   fDecTF_1[1][11][6] = -0.0167337302868;
   fDecTF_1[1][11][7] = -0.380700962985;
   fDecTF_1[1][11][8] = -0.0722241622938;
   fDecTF_1[1][11][9] = 0.00450134823249;
   fDecTF_1[1][11][10] = 0.100008705228;
   fDecTF_1[1][11][11] = 55.3161508742;
   fDecTF_1[2][0][0] = 0.0812467216758;
   fDecTF_1[2][0][1] = -0.00719443828336;
   fDecTF_1[2][0][2] = -0.00397814278453;
   fDecTF_1[2][0][3] = -0.0142018160321;
   fDecTF_1[2][0][4] = 0.00248990172076;
   fDecTF_1[2][0][5] = 0.00794772066607;
   fDecTF_1[2][0][6] = -0.00184999774702;
   fDecTF_1[2][0][7] = -0.00774598094967;
   fDecTF_1[2][0][8] = -0.00401694066468;
   fDecTF_1[2][0][9] = -0.000503508014548;
   fDecTF_1[2][0][10] = 0.00605313117042;
   fDecTF_1[2][0][11] = -0.00604038102104;
   fDecTF_1[2][1][0] = -0.00719443828336;
   fDecTF_1[2][1][1] = 0.935707354682;
   fDecTF_1[2][1][2] = 0.00725486295147;
   fDecTF_1[2][1][3] = 0.00782655536651;
   fDecTF_1[2][1][4] = 0.0264427005884;
   fDecTF_1[2][1][5] = -0.0419607021127;
   fDecTF_1[2][1][6] = -0.0192919067088;
   fDecTF_1[2][1][7] = -0.0265043223307;
   fDecTF_1[2][1][8] = -0.0155193133636;
   fDecTF_1[2][1][9] = 0.00120896049742;
   fDecTF_1[2][1][10] = 0.00564923159119;
   fDecTF_1[2][1][11] = -0.0282703622894;
   fDecTF_1[2][2][0] = -0.00397814278453;
   fDecTF_1[2][2][1] = 0.00725486295147;
   fDecTF_1[2][2][2] = 1.37736329341;
   fDecTF_1[2][2][3] = -0.0234738246684;
   fDecTF_1[2][2][4] = -0.131998237614;
   fDecTF_1[2][2][5] = 0.00552192244355;
   fDecTF_1[2][2][6] = 0.00144570157839;
   fDecTF_1[2][2][7] = 0.0562638844899;
   fDecTF_1[2][2][8] = -0.0122209731916;
   fDecTF_1[2][2][9] = -0.00758086061822;
   fDecTF_1[2][2][10] = -0.00175673964777;
   fDecTF_1[2][2][11] = -0.00825150629744;
   fDecTF_1[2][3][0] = -0.0142018160321;
   fDecTF_1[2][3][1] = 0.00782655536651;
   fDecTF_1[2][3][2] = -0.0234738246684;
   fDecTF_1[2][3][3] = 1.04264121303;
   fDecTF_1[2][3][4] = 0.430587908283;
   fDecTF_1[2][3][5] = 0.0267473203541;
   fDecTF_1[2][3][6] = 0.234963158019;
   fDecTF_1[2][3][7] = -0.408641203766;
   fDecTF_1[2][3][8] = -0.155710838202;
   fDecTF_1[2][3][9] = -0.00186474497284;
   fDecTF_1[2][3][10] = -0.0681288301956;
   fDecTF_1[2][3][11] = -0.324656904626;
   fDecTF_1[2][4][0] = 0.00248990172076;
   fDecTF_1[2][4][1] = 0.0264427005884;
   fDecTF_1[2][4][2] = -0.131998237614;
   fDecTF_1[2][4][3] = 0.430587908283;
   fDecTF_1[2][4][4] = 3.01310922207;
   fDecTF_1[2][4][5] = -0.450066336555;
   fDecTF_1[2][4][6] = -0.0168616513782;
   fDecTF_1[2][4][7] = -0.180722191107;
   fDecTF_1[2][4][8] = -0.375138720809;
   fDecTF_1[2][4][9] = -0.0065557284614;
   fDecTF_1[2][4][10] = 0.23469891002;
   fDecTF_1[2][4][11] = 0.68522704264;
   fDecTF_1[2][5][0] = 0.00794772066607;
   fDecTF_1[2][5][1] = -0.0419607021127;
   fDecTF_1[2][5][2] = 0.00552192244355;
   fDecTF_1[2][5][3] = 0.0267473203541;
   fDecTF_1[2][5][4] = -0.450066336555;
   fDecTF_1[2][5][5] = 2.06745195853;
   fDecTF_1[2][5][6] = 0.0521030794093;
   fDecTF_1[2][5][7] = -0.0583914938453;
   fDecTF_1[2][5][8] = -0.0136556632899;
   fDecTF_1[2][5][9] = 0.00910888554141;
   fDecTF_1[2][5][10] = -0.878185998266;
   fDecTF_1[2][5][11] = 0.109774853143;
   fDecTF_1[2][6][0] = -0.00184999774702;
   fDecTF_1[2][6][1] = -0.0192919067088;
   fDecTF_1[2][6][2] = 0.00144570157839;
   fDecTF_1[2][6][3] = 0.234963158019;
   fDecTF_1[2][6][4] = -0.0168616513782;
   fDecTF_1[2][6][5] = 0.0521030794093;
   fDecTF_1[2][6][6] = 4.03889194002;
   fDecTF_1[2][6][7] = -0.114135486727;
   fDecTF_1[2][6][8] = 0.00934706506068;
   fDecTF_1[2][6][9] = 0.00063461018541;
   fDecTF_1[2][6][10] = 0.0410509758211;
   fDecTF_1[2][6][11] = 0.004037382394;
   fDecTF_1[2][7][0] = -0.00774598094967;
   fDecTF_1[2][7][1] = -0.0265043223307;
   fDecTF_1[2][7][2] = 0.0562638844899;
   fDecTF_1[2][7][3] = -0.408641203766;
   fDecTF_1[2][7][4] = -0.180722191107;
   fDecTF_1[2][7][5] = -0.0583914938453;
   fDecTF_1[2][7][6] = -0.114135486727;
   fDecTF_1[2][7][7] = 2.26663344196;
   fDecTF_1[2][7][8] = -0.211258196113;
   fDecTF_1[2][7][9] = 0.000965379163678;
   fDecTF_1[2][7][10] = 0.196086497789;
   fDecTF_1[2][7][11] = -0.3928878158;
   fDecTF_1[2][8][0] = -0.00401694066468;
   fDecTF_1[2][8][1] = -0.0155193133636;
   fDecTF_1[2][8][2] = -0.0122209731916;
   fDecTF_1[2][8][3] = -0.155710838202;
   fDecTF_1[2][8][4] = -0.375138720809;
   fDecTF_1[2][8][5] = -0.0136556632899;
   fDecTF_1[2][8][6] = 0.00934706506068;
   fDecTF_1[2][8][7] = -0.211258196113;
   fDecTF_1[2][8][8] = 1.73713595044;
   fDecTF_1[2][8][9] = 0.00236115809436;
   fDecTF_1[2][8][10] = 0.160743744848;
   fDecTF_1[2][8][11] = -0.0628328133976;
   fDecTF_1[2][9][0] = -0.000503508014548;
   fDecTF_1[2][9][1] = 0.00120896049742;
   fDecTF_1[2][9][2] = -0.00758086061822;
   fDecTF_1[2][9][3] = -0.00186474497284;
   fDecTF_1[2][9][4] = -0.0065557284614;
   fDecTF_1[2][9][5] = 0.00910888554141;
   fDecTF_1[2][9][6] = 0.00063461018541;
   fDecTF_1[2][9][7] = 0.000965379163678;
   fDecTF_1[2][9][8] = 0.00236115809436;
   fDecTF_1[2][9][9] = 1.12108328657;
   fDecTF_1[2][9][10] = -0.00838678384852;
   fDecTF_1[2][9][11] = 0.00429634640982;
   fDecTF_1[2][10][0] = 0.00605313117042;
   fDecTF_1[2][10][1] = 0.00564923159119;
   fDecTF_1[2][10][2] = -0.00175673964777;
   fDecTF_1[2][10][3] = -0.0681288301956;
   fDecTF_1[2][10][4] = 0.23469891002;
   fDecTF_1[2][10][5] = -0.878185998266;
   fDecTF_1[2][10][6] = 0.0410509758211;
   fDecTF_1[2][10][7] = 0.196086497789;
   fDecTF_1[2][10][8] = 0.160743744848;
   fDecTF_1[2][10][9] = -0.00838678384852;
   fDecTF_1[2][10][10] = 2.0016758183;
   fDecTF_1[2][10][11] = 0.0917367224439;
   fDecTF_1[2][11][0] = -0.00604038102104;
   fDecTF_1[2][11][1] = -0.0282703622894;
   fDecTF_1[2][11][2] = -0.00825150629744;
   fDecTF_1[2][11][3] = -0.324656904626;
   fDecTF_1[2][11][4] = 0.68522704264;
   fDecTF_1[2][11][5] = 0.109774853143;
   fDecTF_1[2][11][6] = 0.004037382394;
   fDecTF_1[2][11][7] = -0.3928878158;
   fDecTF_1[2][11][8] = -0.0628328133976;
   fDecTF_1[2][11][9] = 0.00429634640982;
   fDecTF_1[2][11][10] = 0.0917367224439;
   fDecTF_1[2][11][11] = 55.6986693791;
}

//_______________________________________________________________________
inline void Read_vtxMLPBNN::Transform_1( std::vector<double>& iv, int cls) const
{
   // Decorrelation transformation
   if (cls < 0 || cls > 2) {
       if (2 > 1 ) cls = 2;
       else cls = 2;
   }

   // define the indices of the variables which are transformed by this transformation
   std::vector<int> indicesGet;
   std::vector<int> indicesPut;

   indicesGet.push_back( 0);
   indicesGet.push_back( 1);
   indicesGet.push_back( 2);
   indicesGet.push_back( 3);
   indicesGet.push_back( 4);
   indicesGet.push_back( 5);
   indicesGet.push_back( 6);
   indicesGet.push_back( 7);
   indicesGet.push_back( 8);
   indicesGet.push_back( 9);
   indicesGet.push_back( 10);
   indicesGet.push_back( 11);
   indicesPut.push_back( 0);
   indicesPut.push_back( 1);
   indicesPut.push_back( 2);
   indicesPut.push_back( 3);
   indicesPut.push_back( 4);
   indicesPut.push_back( 5);
   indicesPut.push_back( 6);
   indicesPut.push_back( 7);
   indicesPut.push_back( 8);
   indicesPut.push_back( 9);
   indicesPut.push_back( 10);
   indicesPut.push_back( 11);

   std::vector<double> tv;
   for (int i=0; i<12;i++) {
      double v = 0;
      for (int j=0; j<12; j++)
         v += iv[indicesGet.at(j)] * fDecTF_1[cls][i][j];
      tv.push_back(v);
   }
   for (int i=0; i<12;i++) iv[indicesPut.at(i)] = tv[i];
}

//_______________________________________________________________________
inline void Read_vtxMLPBNN::InitTransform_2()
{
   // Normalization transformation, initialisation
   fMin_2[0][0] = 0.250603497028;
   fMax_2[0][0] = 12.2949104309;
   fMin_2[1][0] = 0.245451629162;
   fMax_2[1][0] = 11.8671798706;
   fMin_2[2][0] = 0.245451629162;
   fMax_2[2][0] = 12.2949104309;
   fMin_2[0][1] = 0.164267078042;
   fMax_2[0][1] = 8.86612033844;
   fMin_2[1][1] = 0.0547260344028;
   fMax_2[1][1] = 7.14079618454;
   fMin_2[2][1] = 0.0547260344028;
   fMax_2[2][1] = 8.86612033844;
   fMin_2[0][2] = -6.3956155777;
   fMax_2[0][2] = 5.3596200943;
   fMin_2[1][2] = -6.05735874176;
   fMax_2[1][2] = 5.1621928215;
   fMin_2[2][2] = -6.3956155777;
   fMax_2[2][2] = 5.3596200943;
   fMin_2[0][3] = 0.109454728663;
   fMax_2[0][3] = 14.0343341827;
   fMin_2[1][3] = 0.122865118086;
   fMax_2[1][3] = 14.3364591599;
   fMin_2[2][3] = 0.109454728663;
   fMax_2[2][3] = 14.3364591599;
   fMin_2[0][4] = -3.53323483467;
   fMax_2[0][4] = 4.49182462692;
   fMin_2[1][4] = -3.37025547028;
   fMax_2[1][4] = 3.53301405907;
   fMin_2[2][4] = -3.53323483467;
   fMax_2[2][4] = 4.49182462692;
   fMin_2[0][5] = 2.04600167274;
   fMax_2[0][5] = 8.72155761719;
   fMin_2[1][5] = 2.09537959099;
   fMax_2[1][5] = 8.93591785431;
   fMin_2[2][5] = 2.04600167274;
   fMax_2[2][5] = 8.93591785431;
   fMin_2[0][6] = 1.14797055721;
   fMax_2[0][6] = 5.93934869766;
   fMin_2[1][6] = 1.10148155689;
   fMax_2[1][6] = 5.84153604507;
   fMin_2[2][6] = 1.10148155689;
   fMax_2[2][6] = 5.93934869766;
   fMin_2[0][7] = -4.13378095627;
   fMax_2[0][7] = 3.26705002785;
   fMin_2[1][7] = -4.16120529175;
   fMax_2[1][7] = 2.7374818325;
   fMin_2[2][7] = -4.16120529175;
   fMax_2[2][7] = 3.26705002785;
   fMin_2[0][8] = 3.14101600647;
   fMax_2[0][8] = 9.2373342514;
   fMin_2[1][8] = 3.14796280861;
   fMax_2[1][8] = 9.35597896576;
   fMin_2[2][8] = 3.14101600647;
   fMax_2[2][8] = 9.35597896576;
   fMin_2[0][9] = -3.53048872948;
   fMax_2[0][9] = 3.5649228096;
   fMin_2[1][9] = -3.52953386307;
   fMax_2[1][9] = 3.54358458519;
   fMin_2[2][9] = -3.53048872948;
   fMax_2[2][9] = 3.5649228096;
   fMin_2[0][10] = -7.06455516815;
   fMax_2[0][10] = 2.9150223732;
   fMin_2[1][10] = -7.96890354156;
   fMax_2[1][10] = 2.76259350777;
   fMin_2[2][10] = -7.96890354156;
   fMax_2[2][10] = 2.9150223732;
   fMin_2[0][11] = -5.56878519058;
   fMax_2[0][11] = 3.66702032089;
   fMin_2[1][11] = -5.12455797195;
   fMax_2[1][11] = 3.52592730522;
   fMin_2[2][11] = -5.56878519058;
   fMax_2[2][11] = 3.66702032089;
}

//_______________________________________________________________________
inline void Read_vtxMLPBNN::Transform_2( std::vector<double>& iv, int cls) const
{
   // Normalization transformation
   if (cls < 0 || cls > 2) {
   if (2 > 1 ) cls = 2;
      else cls = 2;
   }
   const int nVar = 12;

   // get indices of used variables

   // define the indices of the variables which are transformed by this transformation
   std::vector<int> indicesGet;
   std::vector<int> indicesPut;

   indicesGet.push_back( 0);
   indicesGet.push_back( 1);
   indicesGet.push_back( 2);
   indicesGet.push_back( 3);
   indicesGet.push_back( 4);
   indicesGet.push_back( 5);
   indicesGet.push_back( 6);
   indicesGet.push_back( 7);
   indicesGet.push_back( 8);
   indicesGet.push_back( 9);
   indicesGet.push_back( 10);
   indicesGet.push_back( 11);
   indicesPut.push_back( 0);
   indicesPut.push_back( 1);
   indicesPut.push_back( 2);
   indicesPut.push_back( 3);
   indicesPut.push_back( 4);
   indicesPut.push_back( 5);
   indicesPut.push_back( 6);
   indicesPut.push_back( 7);
   indicesPut.push_back( 8);
   indicesPut.push_back( 9);
   indicesPut.push_back( 10);
   indicesPut.push_back( 11);

   std::vector<double> dv(nVar);
   for (int ivar=0; ivar<nVar; ivar++) dv[ivar] = iv[indicesGet.at(ivar)];
   for (int ivar=0;ivar<12;ivar++) {
      double offset = fMin_2[cls][ivar];
      double scale  = 1.0/(fMax_2[cls][ivar]-fMin_2[cls][ivar]);
      iv[indicesPut.at(ivar)] = (dv[ivar]-offset)*scale * 2 - 1;
   }
}

//_______________________________________________________________________
inline void Read_vtxMLPBNN::InitTransform()
{
   InitTransform_1();
   InitTransform_2();
}

//_______________________________________________________________________
inline void Read_vtxMLPBNN::Transform( std::vector<double>& iv, int sigOrBgd ) const
{
   Transform_1( iv, sigOrBgd );
   Transform_2( iv, sigOrBgd );
}
